/*
Version:  0.1.30
Author:   unknown
06/18/2014: HLI, added code to handle the submission spam and uncheck the opt-in if form:country=canada
06/27/2014: HLI, remove honeypot submission code since Eloqua is going to do it in their backend. 
10/01/2014: MLIU, commented out carousel autoplay setting as that needs to be set at page-level.
11/12/2014: MLIU, added Normalize Carousel Height function.
11/12/2014: HLI, Eloqua request: for EMEA localized sites, if a visitor select US as their country value, the check box should be checked.  
11/12/2014: MLIU, added 2 functions: pdfTrackingEvent() and exploreMenuClick()
Filename: nuance.js
11/25/2014: MLIU, updated normalize Carousel Height function carouselNormalize()
12/04/2014: AWHITE/MLIU, updated showMobileMenu to accomodate stores for foreign countries
01/08/2015: MLIU, added call to pdfTrackingEvent() in document.ready so all PDF downloads will be tagged and tracked in GA
01/20/2015: MLIU, added engageusDivision()
01/21/2015: AWHITE, added engage_us path to engageusDivision()
01/29/2015: MLIU, added call to exploreMenuClick() in document.ready
02/04/2015: AWHITE, added call to elPrepPop() in document.ready, also adding verbose for console statements and urlParam
02/19/2015: AWHITE, Updated code to allow elPrePop to call either the zzSFDCEmailOptOutDiv or the partent of the input field
03/06/2015: MLIU, added call to function CTABtnClickEvent() in document.ready
04/07/2015: MLIU, added function $.fn.divNormalize
04/13/2015: AWHITE, added code to check eloqua and hide opt out/in if cookie exits
05/13/2015: MLIU, updated CTABtnClickEvent() to track current page path
05/22/2015: AWHITE, removed TYPEOF from email opt out code
06/25/2015: MLIU, added hideFlyout() and showFlyout()
06/26/2015: MLIU, added volumePricing()
06/29/2015: MLIU, updated volumePricing()
06/30/2015: MLIU, added FlyoutSidebarTracking()
11/02/2015: MLIU, added new function flyoutSlider to replace old hideFlyout() and showFlyout()
02/16/2015: MLIU, updated pdfTrackingEvent() to use rel attribute for cases when there're multiple PDF download on same page.
*/

var versionNumber = '0.1.30';

  //Global methods for troubleshooting: urlParam(name) and verbose(saywhat)
  	function urlParam(name){
		var results = new RegExp('[\\?&]' + name + '=([^&#]*)').exec(window.location.href);
		if (results===null){
			return null;
		}
		else{
			return results[1] || 0;
		}
	}

	function verbose(saywhat){
		// this is a simple function so that I don't have to keep commenting out console.log statements when I publish
		if(decodeURIComponent(urlParam('verboseMode')) === "true"){
			console.log(saywhat);
		}
	}

	verbose("Verbose mode is on for nuance.js / version: " + versionNumber);
  
  window.onscroll = function () {
    // only do this is #pageNavigation exists (because it's optional)

    if($("#backtop").length === 0){
      createBacktop();
    }

    if($("#pageNavigation").length){
      if($(window).scrollTop() > $("#pageNavigation").offset().top){
        if( $("#collapsedNav").length == 0 ) { createCollapsedNav(); } // check to see if #collapsedNav exists, and if not create it
        $("#collapsedNav").css("display", "block");
        $('#backtop').fadeIn();
      }

      else{
        // *poof* it's gone
        $("#collapsedNav").css("display", "none") ;
        $('#backtop').fadeOut();
        docked = false;
      }
    }
  };

  $(window).on("resize", function(event){
    
    //console.log( "The screen width is " + $(this).width()+ "px.");   // utility function only -- not for go live

    if( $(this).width() <= 883 ){
      $("#collapsedNav").css("display", "none") ;
      $('#backtop').fadeOut();
      $("#countrySelector .input-append").toggle();
    }
    else{

      if($("#pageNavigation").length){  // there's a chance pageNavigation doesn't exist...if not, skip this
        if($(window).scrollTop() > $("#pageNavigation").offset().top){
          if( $("#collapsedNav").length == 0 ) { createCollapsedNav(); } // check to see if #collapsedNav exists, and if not create it
          $("#collapsedNav").css("display", "block") ;
          $('#backtop').fadeIn();
        }
      }
      $("#countrySelector .input-append").toggle();
    }

  });


  function showMobileMenu(){
    //$("#globalNav_Primary").toggle();
 
    if( $("#mobileOverlay").length === 0){ // menu doesn't exist, create it
      $('body').append('<div id="mobileOverlay"><div id="mobileOverlayClose" onClick="closeMobileMenu()"><i class="icon-remove"></i></div></div>');
      $("#logoPlacement").clone(true).appendTo("#mobileOverlay");
      $("#mobileOverlay").append('<UL id="mobileOverlay_Primary"></UL>');
      $("#mobileOverlay_Primary").append($("#globalNav_Primary").html());
      $("#mobileOverlay").append($(".searchbar").html());
 
      if(lang === "AU"){
        $("#mobileOverlay_Primary").append( '<li class="item inactive"><a href="http://shop.nuance.com/store/scsoftAP/en_AU/DisplayHomePage">Shop the Nuance store</a></li>');
      } else if(lang === "NZ"){
        $("#mobileOverlay_Primary").append( '<li class="item inactive"><a href="http://shop.nuance.com/store/scsoftAP/en_NZ/home">Shop the Nuance store</a></li>');
      } else if(lang === "ENUK"){
         $("#mobileOverlay_Primary").append( '<li class="item inactive"><a href="http://shop.nuance.co.uk/">Shop the Nuance store</a></li>'); 
      } else if(lang === "DE"){
         $("#mobileOverlay_Primary").append( '<li class="item inactive"><a href="http://shop.nuance.de/">Shop the Nuance store</a></li>'); 
      } else if(lang === "FR"){
         $("#mobileOverlay_Primary").append( '<li class="item inactive"><a href="http://shop.nuance.fr/">Shop the Nuance store</a></li>');
      } else if(lang === "ES"){
         $("#mobileOverlay_Primary").append( '<li class="item inactive"><a href="http://shop.nuance.es/">Shop the Nuance store</a></li>');
      } else if(lang === "IT"){
         $("#mobileOverlay_Primary").append( '<li class="item inactive"><a href="http://shopit.nuance.com/">Shop the Nuance store</a></li>');
      } else if(lang === "NL"){
         $("#mobileOverlay_Primary").append( '<li class="item inactive"><a href="http://shopnl.nuance.com/">Shop the Nuance store</a></li>');
      } else if(lang === "JP"){
         $("#mobileOverlay_Primary").append( '<li class="item inactive"><a href="http://www.dragonspeechstore.jp/">Shop the Nuance store</a></li>');
      } else {
        $("#mobileOverlay_Primary").append( '<li class="item inactive"><a href="http://shop.nuance.com/store/nuanceus/DisplayHomePage?test=drso&sticky=425">Shop the Nuance store</a></li>');
      }
 
      $("#mobileOverlay #appendedInputButton").attr("id","mobileInput");
      $("#mobileInput").removeClass("span2").addClass("span8");

    } else{ // it exists, just show it
      $("#mobileOverlay").fadeIn('fast');
    }
 
  }


  function closeMobileMenu(){
    $("#mobileOverlay").fadeOut('fast');
  }

  function createMobileFooterSearchbar(){
    $("#countrySelector").before($("#globalNav_Tools .searchbar").html());
    $("#countrySelector #appendedInputButton").attr("id","mobileInputFooter");
    $("#mobileInputFooter").removeClass("span2").addClass("span8");
  }

    
	$(document).ready(function() {

		// HLI: set the last page visited division value. 
		(function() {
			if ( typeof window.division !== "undefined" && n_isASpecificDivision(window.division)) {
				var d = new Date();
				var strDt = d.getUTCFullYear() + "-" + n_ret2LeadingZero(d.getUTCMonth()+1) + "-" + n_ret2LeadingZero(d.getUTCDate()) + " " + n_ret2LeadingZero(d.getUTCHours())+":" + n_ret2LeadingZero(d.getUTCMinutes() ) +":" + n_ret2LeadingZero(d.getUTCSeconds());
				n_setTopCookies("lastpagediv", window.division);
				n_setTopCookies("lastpagedivdt", strDt);
			}
		})();	
		
		
		// === display a small version of image separately === //
		windowWidth = $(window).width();
		if(windowWidth <= 360){
			$('img#cellphone').attr('src', 'img/cellphone-small.jpg').removeAttr('height').removeAttr('width');
		}	
    	
    	// == AWHITE 2/5/2015 If email address entered, check with Eloqua servers and if already subscribed remove check box div
			$("[name$=email]").change(function(){
 			verbose("In email change in Nuance.js");
 			email = $("[name$=email]").val();
 				verbose("NUANCE.JS -- Email changed to " + email);
				elPrePop(email);
			});
			
			if( $.cookie("email")){
	 			email = $.cookie("email");
 				verbose("NUANCE.JS -- Email was populated on entry: " + email);
				elPrePop(email);			
			}
			
    	// console.log(division);
    	pdfTrackingEvent();
    	exploreMenuClick();
    	CTABtnClickEvent();
    	
    	// === Attach divisionVar to the querystring for the "Engage us" button links === //
    	engageusDivision();
	
    	// === expand top nav for China site === //
    	//expanded_nav").hide();
		if( $("#globalNav_Expand").length > 0 ) {
	
	   	var classtoToggle = $("#globalNav_Expand").attr('class').split(' ')[1];
	    	$("#globalNav_Expand").click(function () {
	        	$('#expanded_nav_container').slideToggle(600);
	        	//$(this).toggleClass("plus_cn");
	        	$(this).toggleClass(classtoToggle);
	    	});
		}

		// === read more / read less === //
		$(".expanded_section").hide();
		$(".read_more").css("cursor", "pointer");
		$(".read_more").click(function(){
			$(this).closest('div.row-fluid').next(".expanded_section").slideToggle(500, function() {
				var pos = $("#consumervoice_section").offset().top;
				//alert("pos=" + pos);
				$("#consumervoice-bg").css("top", pos);
			});
	
			if ($(this).text() == "Read more") {
				$(this).text("Read less");
				$(this).closest('div.row-fluid').next(".expanded_section").next("hr").addClass("hr-hide");
			} else {
				$(this).text("Read more");
				$(this).closest('div.row-fluid').next(".expanded_section").next("hr").removeClass("hr-hide");
			}
		}); 
	
		// === smooth scroll for anchor links === //
		 $('a.anchorLink').click(function(){
			$('html, body').animate({
				scrollTop: $( $(this).attr('href') ).offset().top -110
			}, 800);
			return false;
		});
	
		
		// === turn off carousel auto play === //
		// == MLIU 10/1/2014 comment out carousel code. This should be set at page-level == //
		/*if($('.carousel').length !== 0){
	      $('.carousel').carousel({
				 interval: false
			  });
	    }*/
		
		// === turn off shadowbox for iPhone ===
		 if (navigator.platform.indexOf("iPhone") != -1) {
			$("#letstalk").attr({
			  target: "_blank",
			  rel: ""
			});
			$("#letstalk2").attr({
			  target: "_blank",
			  rel: ""
			});			
		 } else {		  
			Shadowbox.init({
				players:    [
					"iframe"
				],
			  onOpen: function() { 
				$('#sb-title').after($('#sb-info')); 
			  } 
			});
		 }

	}); 
	
  		var lang = "ENUS";
		
		function showLang() {
			setTimeout("showRealLang()",100);
		}
		function showRealLang(){
			//document.getElementById('lang').style.display="block";
			//document.getElementById('lang').style.background = "#ffcc56";
			//document.getElementById('ncom_selectlang').className = "currentLang-over";
		}
		function hideLang(limba){
			//document.getElementById('lang').style.display = "none";
			//document.getElementById('ncom_selectlang').className = "currentLang";
			//if(limba!=undefined) { document.getElementById('currentLang').innerHTML = limba; }
		}
		$(function() {
			$('body').on('click touchstart', function () {
				hideLang();
			});
		});


    // === switch logo for presentation === //
  var oldLogo = 1;

   function switchLogo(){
    if(oldLogo){ 
      $("#logoPlacement").removeClass("oldLogo").addClass("newLogo"); 
      $("#collapsedSymbol").removeClass("oldSymbol").addClass("newSymbol");
    } else { 
      $("#logoPlacement").removeClass("newLogo").addClass("oldLogo"); 
      $("#collapsedSymbol").removeClass("newSymbol").addClass("oldSymbol");
    }
    oldLogo = !oldLogo;
   }


   // === creates the collapsedNav div for page shortcuts === //
   function createCollapsedNav(){
    if( $("#pageNavigation").length){  // only fill the stub if pageNav exists
      $('body').append('<div class="jumbotron" id="collapsedNav"><div class="wrapper" id="collapsedNavWrapper"></div></div>');
      //$("#collapsedNavWrapper").append('<div id="collapsedSymbol" onClick="switchLogo()" class="oldSymbol">&nbsp;</div>');
      if($("#masthead .page-title").length != 0){
        $("#collapsedNavWrapper").append('<div class="page-title">' +  $("#masthead .page-title").html() + '</div>');
      }
      
      $("#collapsedNavWrapper").append( $("#pageNavigation .wrapper").html() );
    }
   }

	// === creates the back-to-top button (id=backtop) === //
  function createBacktop(){
    $('body').append('<div id="backtop" data-toggle="tooltip" data-placement="left" title="Back to top" data-original-title="Back to top"><i class="icon-arrow-up"></i></div>');
    if($("#backtop").length !== 0){
      $('#backtop').click(function () {
        $('body,html').animate({
          scrollTop: 0
          }, 800);
          return false;
          });
      $("#backtop").tooltip();
    }
  }

  
  function countrySelect(){
    $("#countrySelectorOverlay").toggle();
    //$("#countrySelectorOverlay").toggle();
    //$("#footer").toggle();
  }

// HLI: added code to handle the honeypot and opt in for USA and opt out for other countries.
//if there is an Eloqua form on the page
	
  $(document).ready(function () {

	if ( $('form input[name$="elqSiteID"]').length > 0) {
		// honeyPot implementation to hide and set a default value if a user is inputing.
		// global variable for this page for eloqua form element
		var nuance_eloquaform = $('form input[name$="elqSiteID"]').parents('form').first();
		if ( nuance_eloquaform.find('input[name="skyColor"]').length > 0) {
			nuance_eloquaform.find('#skyDiv').hide();
			nuance_eloquaform.find('input').focus(function(){  
			nuance_eloquaform.find('input[name="skyColor"]').val('biue');  

		});  
			
			// hijack the submission and check for our field
			/* 06/27/2014 HLI: remove this because Eloqua is going to check this on their end
			nuance_eloquaform.submit(function () {
				if (nuance_eloquaform.find('input[name="skyColor"]').val() === "biue")  {
					return true;
				} else {
					return false;
				}
			});
			*/
		}
		
		// add the function to handle the opt-in uncheck if the visitor select Canada& EU Country 
		// do it only with country and emailOptOut field presents
		if ( ( nuance_eloquaform.find('select[name$="country"]').length > 0) && (nuance_eloquaform.find('input[name$="emailOptOut"]').length > 0)) {
			
			var nuance_eloquaform_emailOptOutInitChecked = nuance_eloquaform.find('input[name$="emailOptOut"]').is(':checked');
			
			nuance_eloquaform.find('select[name$="country"]').change(function() {

				var strVal = $(this).val();
				var strText = $(this).find('option:selected').text();

				// check if we have the emailOptOut check box:
				if ( strVal.toLowerCase().indexOf('canada') !=-1 || strText.toLowerCase().indexOf('canada') !=-1 ) {
					// uncheck the box
					nuance_eloquaform.find('input[name$="emailOptOut"]').prop("checked", false);
				} else {
					// HLI/20141112: make sure if it is US, we will check it. Note that even on the localized sites, Couple of the country names 
					// are not translated. so the comparison is in English.
					if ( strVal.toLowerCase().indexOf('usa') !=-1 || strText.toLowerCase().indexOf('united states of america') !=-1 ) {
						nuance_eloquaform.find('input[name$="emailOptOut"]').prop("checked", true);
					} else {
						nuance_eloquaform.find('input[name$="emailOptOut"]').prop("checked", nuance_eloquaform_emailOptOutInitChecked);
					}
				}
			});
		   
		}	
	}
		
});

  // Normalize Carousel Heights - pass in Bootstrap Carousel items.
  $.fn.carouselNormalize = function(interval, fade_arrows, enable_swipe) {
    interval = (typeof interval === "undefined") ? 5000 : interval;
    fade_arrows = (typeof fade_arrows === "undefined") ? true : fade_arrows;
    enable_swipe = (typeof enable_swipe === "undefined") ? true : enable_swipe;

    var $carousel = $(this);
    var $left_control = $carousel.find(".carousel-control.left");
    var $right_control = $carousel.find(".carousel-control.right");
    var items = $carousel.find(".item"); //grab all slides
    var heights = []; //create empty array to store height values
    var tallest; //create variable to make note of the tallest slide

    var normalizeHeights = function() {

      items.each(function() { //add heights to array
          heights.push($(this).height()); 
      });
      // console.log("heights list = " + heights);
      tallest = Math.max.apply(null, heights); //cache largest value
      // console.log("tallest = " + tallest);
      
      items.each(function() {           
          $(this).css('min-height',tallest + 'px');
      });

      // Set the carousel's Prev/Next arrow vertical position
      // Position is at half of (tallest + control-height)
      var control_height = $carousel.find(".carousel-control").height();
      var top_height = (tallest + control_height) / 2;
      
      $left_control.css('top', '-' + top_height + 'px');
      $right_control.css('top', '-' + top_height + 'px');

      if (fade_arrows) {
        // Show/Hide prev/next on hover
        max_width=1025;
        $carousel.hover(
            function(){  // mouseover
              // Show controls only if viewport width is 1025px or more
              // Below that, most likely a mobile device using swipe                  
              if ((window.innerWidth >= max_width ) || ( document.documentElement.clientWidth >= max_width) || (document.body.clientWidth >= max_width)) {  
                $left_control.fadeIn();
                $right_control.fadeIn();
              }
            },
            function(){ // mouseout
                $left_control.fadeOut();
                $right_control.fadeOut();
            }
        );
      }

      if (enable_swipe){
        $carousel.swiperight(function() {
          $carousel.carousel('prev');
        });
        $carousel.swipeleft(function() {
          $carousel.carousel('next');
        });
      }

      if (interval){
        $carousel.carousel({
          interval: interval
        });
      }
    };

    normalizeHeights();

    $(window).on('resize orientationchange', function () {
        //reset vars
        tallest = 0;
        heights.length = 0;

        items.each(function() {
            $(this).css('min-height','0'); //reset min-height
        }); 
        normalizeHeights(); //run it again 
    });
  };

	// GA Event Tracking for: 1) PDF download 2) top nav / expandable nav clicks
	function pdfTrackingEvent() {
	  var linkLocation = "";
      $("a[href$='pdf']").each(function(index) {
      	var linkLocation = $(this).attr('rel');
        pdfLabel = $(this).attr('href');
        if (typeof linkLocation !== typeof undefined && linkLocation !== false) {
		    pdfLabel = linkLocation + ": " + pdfLabel;
		}
        verbose("inside pdfTrackingEvent " + division);
        pdfOnClick = "_gaq.push(['_trackEvent', '" + division + " PDF', 'Download', '" + pdfLabel + "']);";
        $(this).attr("onClick", pdfOnClick);
      });
    }

    function exploreMenuClick() {
      $("#expanded_nav_container a").each(function(index) {
          var fromTo = location.pathname + ' -> ' + $(this).attr('href');
          //alert("fromTo = " + fromTo);
          navOnClick = "_gaq.push(['_trackEvent', '" + division + " TopNav', 'Navigation', '" + fromTo + "']);";
          $(this).attr("onClick", navOnClick);
      });
    }
    

	// === Eloqua Opt in/out: remove on email change === //	
	var jsonp;
	var optBox;
	var optLabel;
	function elPrePop(email){		
		optBox = $("[name$=mailOptOut]").parent( "div" );			    		
		optlabel = $("[name$=mailOptOut]").parent( "control-label" );			    		
		verbose("XXXXXXX elPrePop in Nuance.js has been called!! XXXXXX");
		verbose("optbox = "  + optBox.html());
				var inputdata = email;				
				$.ajax({
			  	type: 'Get',
			  	url: 'http://research.nuance.com/eloqua.php',
			  	dataType: 'jsonp',	
			  	data: {email : email},
			  	async: false,
			  	success:function(data,status,settings){
			    	// successful request; do something with the data
			    	verbose("elPrePop: htmlname in data?"+ data.isSubscribed);
			    	if (email && data.isSubscribed == "true" ) {
			    		verbose("elPrePop: " + email + " IS subscribed in eloqua? " + data.isSubscribed + " Is div present? " + (("#zzSFDCEmailOptOutDiv").length));
				    	  	$("input[name$=mailOptOut]").prop('checked', false);
				    	  	$("[name$=mailOptOut]").parent( ".control-label" ).css("visibility","hidden");
				    	  	$("[name$=mailOptOut]").parent( "div" ).css("visibility","hidden");
		    	} else {
			    		verbose("elPrePop: NOT subscribed?"+ data.email  +" and option box is: " + optBox);
							 $("[name$=mailOptOut]").parent( "div" ).css("visibility","visible");
			    	  		 $("[name$=mailOptOut]").parent( ".control-label" ).css("visibility","visible");
			    	}
			  	},
		      	error: function(json, status, error) {
		        	verbose('An error occurred in elPrePop: ' + error);
      			}
		});
}
				
    // for Engage Us
  	function engageusDivision() {
    	$("a").each(function(index) {
      		var linkURL = $(this).attr('href');
      		if ((linkURL !== undefined) &&((linkURL.indexOf("/engageus/") > -1) || (linkURL.indexOf("/engage_us/") > -1)) ){
        		
        		var queryString = "";
        		if(linkURL.indexOf("?") > -1) {
            		queryString = "&divisionVar=" + division;
        		} else {
            		queryString = "?divisionVar=" + division;
        		}
        		verbose("queryString = " + queryString);
        		$(this).attr("href", linkURL + queryString);
      		}
    	});
  	}
  	
  	
   function CTABtnClickEvent() {
    var ctaOnClick = "";
    var engage_us_link = "";
    var currentURL = window.location.pathname;
    var currTracking = "";
    $("a[class*='cta']").each(function(index) {
      engage_us_link = $(this).attr('href');
      currTracking = $(this).attr('onclick');
      //alert(currTracking);
      if (typeof engage_us_link !== typeof undefined && engage_us_link !== false) {
        if (engage_us_link.indexOf("/for-business/engage_us/") >= 0 && currTracking == "") {
          if ($(this).parents('div#pageNavigation').length) {
            ctaOnClick = "_gaq.push(['_trackEvent', 'CTA Button in StickyNav', 'Click', '" + currentURL + "']);";
          } else if ($(this).parents('div.flyout-content').length) {
            ctaOnClick = "_gaq.push(['_trackEvent', 'CTA Button in Flyout Bar', 'Click', '" + currentURL + "']);";
          } else {
            ctaOnClick = "_gaq.push(['_trackEvent', 'CTA Button in Pages', 'Click', '" + currentURL + "']);";
          }
          
          $(this).attr("onClick", ctaOnClick); 
        }
      }
    });
  }

// Equalize div height
// DIVs with the same class name selector will have their minimum-height set to 
// the “outer-height” of the DIVs with the maximum outer-height.  
// Example usage:  $('.equalHeightDivs').divNormalize();

$.fn.divNormalize = function() {
  
  // Get name of selector used to call this function
  var divselector = "div" + $(this).selector;

  var equalizeDivHeights = function(){
    var maxHeight = 0;
    
    // Get tallest element
    $(divselector).each(function(){
      // Compare OUTER heights!
      if ($(this).outerHeight() > maxHeight) { maxHeight = $(this).outerHeight(); }
    });

    // Normalize via min-height
    $(divselector).each(function(){
      $(divselector).css('min-height', maxHeight + 'px');
    });
  }

  equalizeDivHeights();

  $(window).on('resize orientationchange', function () {
    // Reset min-height
    $(divselector).each(function(){
      $(this).css('min-height','0'); 
    });
    equalizeDivHeights();
  });
} 

// new flyoutSlider function to replace old showFlyout() and hideFlyout()
$.fn.flyoutSlider = function (options) {
    var defaults = {
        idleTimeout: 15000,
        open: true,
        top: 280,
        hideOnScroll: true
    };

    var settings = $.extend({}, defaults, options);

    return this.each(function () {
        var that = this;

        this.flyoutWrapper = $(".flyout-wrapper");
        this.flyoutContent = this.flyoutWrapper.find(".flyout-content");
        this.flyoutTrigger = this.flyoutWrapper.find(".flyout-trigger");
        
        //showFlyout
        this.showFlyout = function () {
            if (this.flyoutContent.length > 0) {
                this.flyoutContent.animate({
                    marginRight: '0px'
                }, 500);
            }
        };

        this.hideFlyout = function () {
            //using 'that' instead of 'this' to get proper reference from settimeout function
            var rPos = "-" + that.flyoutContent.innerWidth() + "px";
            if (that.flyoutContent.length > 0) {
                that.flyoutContent.animate({
                    marginRight: rPos
                }, 500);
                that.flyoutTrigger.animate({
                    marginRight: '0px'
                }, 500);
            }
        };

        this.setPosition = function () {
            if (defaults.top != settings.top) {
                this.flyoutWrapper.css({
                    "top": settings.top
                });
            }
        };

        this.init = function () {
            //set position
            this.setPosition();
            //if we want to open flyout by default on pageload
            if (settings.open) {
                this.showFlyout();
            }
            //to bind window scroll on instantiation of the flyout for hiding
            if (settings.hideOnScroll) {
                $(window).scroll(function () {
                  if (!(that.flyoutWrapper.is(':hover'))){
                    if (that.flyoutContent.css('margin-right') == "0px") {
                        that.hideFlyout();
                    }
                  }
                });
            }

            // toggle sidebar with trigger-clicking
            this.flyoutTrigger.on("click", $.proxy(function () {
                this.flyoutContent.css('display', 'block');
                if (this.flyoutContent.css('margin-right') != "0px") {
                    this.showFlyout();
                } else {
                    this.hideFlyout();
                }
            }, this));

            // hide sidebar if no action after 15s
            setTimeout(this.hideFlyout, settings.idleTimeout);
        };
        //initialize
        this.init();

        return this;
    });
} // end flyoutSlider();

function hideFlyout() {
  var rPos = "-" + $(".flyout-content").innerWidth() + "px";
  if( $(".flyout-content").length > 0 ) {
    $('.flyout-content').animate({ marginRight: rPos}, 500);
    $('.flyout-trigger').animate({ marginRight: '0px'}, 500);
  }
}

function showFlyout() {
  if( $(".flyout-content").length > 0 ) {
    $('.flyout-content').animate({ marginRight: '0px'}, 500);
  }
}

function FlyoutSidebarTracking() {
  var currentURL = window.location.pathname;

  // Enterprise
   $("div.flyout-wrapper.ent a").each(function(index) {
    var linkText = $(this).text();
    var linkOnClick = "_gaq.push(['_trackEvent', 'Enterprise Flyout Sidebar', 'Click', '" + linkText + ": " + currentURL + "']);";
    $(this).attr("onClick", linkOnClick); 
  });

   // Dragon
  $("div.flyout-wrapper.dragon a").each(function(index) {
    var linkText = $(this).text();
    var linkOnClick = "_gaq.push(['_trackEvent', 'Dragon Flyout Sidebar', 'Click', '" + linkText + ": " + currentURL + "']);";
    $(this).attr("onClick", linkOnClick); 
  });

  // Imaging
  $("div.flyout-wrapper.imgaging a").each(function(index) {
    var linkText = $(this).text();
    var linkOnClick = "_gaq.push(['_trackEvent', 'Imaging Flyout Sidebar', 'Click', '" + linkText + ": " + currentURL + "']);";
    $(this).attr("onClick", linkOnClick); 
  });

  // Healthcare
  $("div.flyout-wrapper.healthcare a").each(function(index) {
    var linkText = $(this).text();
    var linkOnClick = "_gaq.push(['_trackEvent', 'Healthcare Flyout Sidebar', 'Click', '" + linkText + ": " + currentURL + "']);";
    $(this).attr("onClick", linkOnClick); 
  });
  
}

// Dragon Volumn Purchasing
function volumePricing(singlePrice, volMin, volMax, priceDis, strShopLink) {

    var updateBuyVolume = function($upDown) {
    
        var nUnits= $("#volumeNum").text();

        if ($upDown) { ++nUnits; } else { --nUnits; }
        if ( nUnits < volMin) {nUnits = volMin;}
        if ( nUnits > volMax) {nUnits = volMax;}
        
        var volPrice = (nUnits * singlePrice * priceDis).toFixed(2);
        volPrice = "$" + volPrice.toString();

        //set inner text 
        $("#volPrice").text(volPrice);
        $("#volumeNum").text(nUnits);
        
        //set shoping link
        $("#volBuyLink").attr("href", strShopLink.replace("###",nUnits.toString()));
    }       
    
    $( "#volumeDown" ).click(function(event) {
        updateBuyVolume( false )
        event.stopPropagation();
    });

    $( "#volumeUp" ).click(function(event) {
        updateBuyVolume( true )
        event.stopPropagation();
    });
  }
