/*
File name: nuance_utility.js
Author:   Harry LI
Description: Please add all common form related code into this file. 
Change history: 
03/25/2015/HLI: initial draft to start the JS file
*/

function n_getParameterByName(name) {
    name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
    var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
        results = regex.exec(location.search);
    return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
}

function n_isStringBlank( val) {
  return (typeof(val) === 'undefined' || val === null || val == "") ? true : false;
}
function n_ret2LeadingZero(num) {
	return ( num < 10 ? "0" + num : "" + num);
}
// set cookies
function n_setTopCookies(name, value, cDur) {
	if ( typeof cDur === 'undefined' || cDur === null)
		n_setCookies(name, value, 30, "/");
	else 
		n_setCookies(name, value, cDur, "/");
}
function n_setCookies(name, val, cDur, cPath, cDomain) {
	if ( typeof jQuery.fn.cookie === 'undefined') {
			// without using JQuery cookie
		var cookieStr = name + "=" + val;

		if ( typeof cDur !== 'undefined') { 
			var d = new Date();  
			d.setDate(d.getDate() + cDur);
			cookieStr += "; expires=" + d.toUTCString();
		}
		if ( typeof cPath !== 'undefined') { cookieStr += "; path=" + cPath; }
		if ( typeof cDomain !== 'undefined') { cookieStr +=  ";domain=" + cDomain;	}
		document.cookie = cookieStr; 
	} else {
		// if jquery cookie object exists
		var jsonExtra = {}; 
		if ( typeof cDur !== 'undefined') { jsonExtra.expires = cDur; }
		if ( typeof cPath !== 'undefined') { jsonExtra.path = cPath; }
		if ( typeof cDomain !== 'undefined') { jsonExtra.domain = cDomain; }

		$.cookie(name, val, jsonExtra);
	}
}
// read cookies
function n_getCookies(name) {
	if ( typeof jQuery.fn.cookie === 'undefined') {
			// without using JQuery cookie
		var na = name + "=";
		var ca = document.cookie.split(';');
		for(var i=0; i<ca.length; i++) {
			var c = ca[i];
			while (c.charAt(0)==' ') c = c.substring(1);
			if (c.indexOf(na) == 0) return c.substring(na.length,c.length);
		}
	} else {
		// if jquery cookie object exists
		return $.cookie(name);
	}
	return "";
}
// we set cookie and read cookie with the same .Cookie object configuration
function n_getCookieinRaw(name) {
		// make sure .cookie is set to raw and JSON
	    var buf = [];
		buf.push($.cookie.raw);
		buf.push($.cookie.json);
		$.cookie.raw = true;
		$.cookie.json = false;
		var cookieObj = $.cookie(name);
		$.cookie.json = buf.pop();
		$.cookie.raw = buf.pop();
		return cookieObj;
}
function n_setCookieinRaw(name, value, settings) {
		// make sure .cookie is set to raw and JSON
	    var buf = [];
		buf.push($.cookie.raw);
		buf.push($.cookie.json);
		$.cookie.raw = true;
		$.cookie.json = false;
		$.cookie(name, value, settings);
		$.cookie.json = buf.pop();
		$.cookie.raw = buf.pop();
}

// check if the page contains Eloqua forms ( including forms post it to Eloqua )
/* Checking on the following 2 scenarios
	1. Check form + eloqua hidden input fields
	2. Form has an attribute: isEloquaForm=true
*/
function n_pageHasEloquaForm() {
	var $retSet = n_getEloquaForms();
	return $retSet.length > 0;
}
// this one return a JQuery set contain all eloqua forms
// note this one rely on JQuery
function n_getEloquaForms() {
	return $('form[isEloquaForm!=false]:has(input[name$="elqSiteID"]), form[isEloquaForm=true]');
}
var nuance_divisions = [ "dragon", "healthcare", "enterprise", "imaging", "mobile", "automotive" ];
function n_isASpecificDivision( divVal) {
      return (!n_isStringBlank(divVal)) && (nuance_divisions.indexOf(divVal.toLowerCase()) >= 0);
}
function n_isNuanceCorpDivision(divVal) {
      return (!n_isStringBlank(divVal)) && ( "corp" === divVal.toLowerCase());
}