/////////////////////////////////////////////////////////////////////////////
// Function : NavNode (constructor)
// Comments :
/////////////////////////////////////////////////////////////////////////////
function NavNode(id, label, href, parent)
{
	this.m_parent = null;
	this.m_level = 0;

	if (parent)
	{
		this.m_parent = parent;
		this.m_level = parent.m_level+1;
	}

	this.m_id = id;

	// assume that m_label will most often be used directly as HTML
	this.m_rawlabel = label;

	label = label.replace(/&/g, '&amp;');
	label = label.replace(/</g, '&lt;');
	label = label.replace(/>/g, '&gt;');
	label = label.replace(/"/g, '&quot;');

	this.m_label = label;

	this.m_href = href;
	this.m_subNodes = new Array();

	var argValues = NavNode.arguments;
	var argCount = NavNode.arguments.length;

	for (i = 4 ; i < argCount ; i++)
	{
		var eqPos = argValues[i].indexOf("==");
		var attrName = argValues[i].substring(0,eqPos);
		var attrValue = argValues[i].substring(eqPos+2);

		eval("this.cp_" + attrName + " = '" + attrValue + "';");
	}

	NavNode.prototype.addNode = addNode;
	NavNode.prototype.isSelected = isSelected;
}

/////////////////////////////////////////////////////////////////////////////
// Function : addNode
// Comments :
/////////////////////////////////////////////////////////////////////////////
function addNode(id, label, href)
{
	var newIndex = this.m_subNodes.length;
	var newNode = new NavNode(id, label, href, this);

	var argValues = addNode.arguments;
	var argCount = addNode.arguments.length;

	for (i = 3 ; i < argCount ; i++)
	{
		var eqPos = argValues[i].indexOf("==");
		var attrName = argValues[i].substring(0,eqPos);
		var attrValue = argValues[i].substring(eqPos+2);

		eval("newNode.cp_" + attrName + " = '" + attrValue + "';");
	}

	this.m_subNodes[newIndex] = newNode;
	return newNode;
}

/////////////////////////////////////////////////////////////////////////////
// Function : isSelected
// Comments :
/////////////////////////////////////////////////////////////////////////////
function isSelected()
{
    var pos = window.location.href.lastIndexOf("/");
    var docname = window.location.href.substring(pos+1, window.location.href.length);

    pos = this.m_href.lastIndexOf("/");
    var myname = this.m_href.substring(pos+1, this.m_href.length);

    if (docname == myname)
		return true;
	else
		return false;
}

/////////////////////////////////////////////////////////////////////////////
// Function : customSectionPropertyExists
// Comments :
/////////////////////////////////////////////////////////////////////////////
function customSectionPropertyExists(csp)
{
	return (typeof csp != _U && csp != null);
}

/////////////////////////////////////////////////////////////////////////////
// Function : getCustomSectionProperty
// Comments :
/////////////////////////////////////////////////////////////////////////////
function getCustomSectionProperty(csp)
{
	if (customSectionPropertyExists(csp))
	{
		return csp;
	}
	else
	{
		return "";
	}
}

/////////////////////////////////////////////////////////////////////////////

var g_navNode_Root = new NavNode('ncom_home','Home',ssUrlPrefix + 'index.htm',null,'searchDispDesc==Our innovations in voice, natural language understanding, reasoning and systems integration come together to create more human technology. Learn more.');
g_navNode_0=g_navNode_Root.addNode('ncom_support','Support',ssUrlPrefix + 'support/index.htm','searchDispDesc==Get support for our most popular support product categories');
g_navNode_0_0=g_navNode_0.addNode('ncom_supp_prod_vsuite','VSuite and VoiceMode',ssUrlPrefix + 'support/vsuite/index.htm');
g_navNode_0_1=g_navNode_0.addNode('ncom_supp_prod_veriphy','PowerScribe360',ssUrlPrefix + 'support/powerscribe-360-critical-results/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_0_2=g_navNode_0.addNode('ncom_supp_prod_textbridge','TextBridge',ssUrlPrefix + 'support/TextBridge/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_0_5=g_navNode_0.addNode('ncom_supp_prod_simplifyscan','SimplifyScan',ssUrlPrefix + 'support/simplifyscan/index.htm');
g_navNode_0_6=g_navNode_0.addNode('ncom_supp_prod_scanflowstore','ScanFlowStore',ssUrlPrefix + 'support/scanflowstore/index.htm');
g_navNode_0_8=g_navNode_0.addNode('ncom_supp_prod_powerscribe','PowerScribe 360 Reporting',ssUrlPrefix + 'support/powerscribe360-reporting/index.htm');
g_navNode_0_9=g_navNode_0.addNode('ncom_supp_prod_omniform','OmniForm',ssUrlPrefix + 'support/omniform/index.htm','searchDispDesc==Get support for OmniForm');
g_navNode_0_10=g_navNode_0.addNode('ncom_supp_prod_escription','eScription',ssUrlPrefix + 'support/escription/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_0_11=g_navNode_0.addNode('ncom_supp_prod_entspeechsols','Enterprise Speech Solutions',ssUrlPrefix + 'support/enterprise-speech-solutions/index.htm');
if (SSContributor)
{
g_navNode_0_12=g_navNode_0.addNode('ncom_supp_prod_embedspeechsols','Embedded Speech Solutions',ssUrlPrefix + 'support/embedded-speech-solutions/index.htm','contributorOnly==TRUE');
}
g_navNode_0_13=g_navNode_0.addNode('ncom_supp_prod_dns','Dragon NaturallySpeaking',ssUrlPrefix + 'support/dragon-naturallyspeaking/index.htm');
g_navNode_0_14=g_navNode_0.addNode('ncom_supp_prod_dragmed','Dragon Medical',ssUrlPrefix + 'support/dragon-medical/index.htm','nonViewableCountries==ENUS, ENUK, DE, FR, AU');
if (SSContributor)
{
g_navNode_0_15=g_navNode_0.addNode('ncom_supp_prod_dragmedmobile','Dragon Medical Mobile Search',ssUrlPrefix + 'support/dragon-medical-mobile/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
g_navNode_0_16=g_navNode_0.addNode('ncom_supp_prod_dragmobileapps','Dragon Mobile Applications',ssUrlPrefix + 'support/dragon-mobile-applications/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_0_17=g_navNode_0.addNode('ncom_supp_prod_omnipage','OmniPage',ssUrlPrefix + 'support/omnipage/index.htm');
g_navNode_0_18=g_navNode_0.addNode('ncom_supp_prod_dictentspsol','Dictaphone Enterprise Speech System',ssUrlPrefix + 'support/dictaphone-enterprise-speech-solution/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_0_18_0=g_navNode_0_18.addNode('ncom_support_depot_repair_form','Depot Repair',ssUrlPrefix + 'support/dictaphone-enterprise-speech-solution/depot-repair/index.htm','contributorOnly==false','nonViewableCountries==ENUK,DE,FR');
g_navNode_0_19=g_navNode_0.addNode('ncom_supp_prod_paperport','PaperPort',ssUrlPrefix + 'support/paperport/index.htm');
if (SSContributor)
{
g_navNode_0_20=g_navNode_0.addNode('ncom_supp_prod_smartofficescan','Smart Office Scan',ssUrlPrefix + 'support/smart-office-scan/index.htm','contributorOnly==TRUE');
}
g_navNode_0_21=g_navNode_0.addNode('ncom_supp_prod_digidocflow','DigiDocFlow',ssUrlPrefix + 'support/digidocflow/index.htm');
g_navNode_0_22=g_navNode_0.addNode('ncom_supp_prod_ecopy','eCopy',ssUrlPrefix + 'support/ecopy/index.htm');
g_navNode_0_22_1=g_navNode_0_22.addNode('ncom_supp_ecopy_devices','Supported Devices',ssUrlPrefix + 'support/ecopy/supported-devices/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_0_22_2=g_navNode_0_22.addNode('ncom_supp_prod_versions','Supported Versions',ssUrlPrefix + 'support/ecopy/supported-versions/index.htm','nonViewableCountries==ENUK,DE,FR','searchDispDesc==eCopy Support - Desktop/eCopy PaperWorks Supported Versions');
g_navNode_0_22_3=g_navNode_0_22.addNode('ncom_supp_prod_ecopy_onsite','eCopy OnSite',ssUrlPrefix + 'support/ecopy/eCopyOnSite/index.htm','nonViewableCountries==ENUK,DE,FR','searchDispDesc==eCopy OnSite provides installation, configuration, and training for eCopy products \u2013 remote access or OnSite\x21');
g_navNode_0_22_4=g_navNode_0_22.addNode('ncom_supp_ecopy_training','Training',ssUrlPrefix + 'support/ecopy/training/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_0_22_5=g_navNode_0_22.addNode('ncom_supp_prod_ecopy_enhance','Product Enhancements',ssUrlPrefix + 'support/ecopy/product-enhancements/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_0_22_6=g_navNode_0_22.addNode('ncom_sup_maint_supp','Maintenance and Support',ssUrlPrefix + 'support/ecopy/maintenance-and-support/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_0_23=g_navNode_0.addNode('ncom_sup_sol_pdfconv','PDF Converter',ssUrlPrefix + 'support/pdf-converter/index.htm','searchDispDesc==Get support for our PDF Converter');
g_navNode_0_24=g_navNode_0.addNode('ncom_supp_prod_t9','T9',ssUrlPrefix + 'support/t9/index.htm');
g_navNode_0_25=g_navNode_0.addNode('ncom_support_talks_zooms','TALKS and ZOOMS Support',ssUrlPrefix + 'support/talks/index.htm');
g_navNode_0_26=g_navNode_0.addNode('ncom_support_pdfreader7','PDF Reader 7',ssUrlPrefix + 'support/pdf-reader-7/index.htm');
g_navNode_0_27=g_navNode_0.addNode('ncom_support_powerscribe','Powerscribe',ssUrlPrefix + 'support/powerscribe/index.htm');
g_navNode_0_28=g_navNode_0.addNode('ncom_support_radwhere','Radwhere',ssUrlPrefix + 'support/radwhere/index.htm');
g_navNode_0_29=g_navNode_0.addNode('ncom_support_pdfmac','PDF Mac',ssUrlPrefix + 'support/pdf-mac/index.htm');
g_navNode_0_30=g_navNode_0.addNode('ncom_support_radport','RadPort',ssUrlPrefix + 'support/powerscribe-360-decision-support/index.htm');
g_navNode_0_31=g_navNode_0.addNode('ncom_support_radcube','RadCube',ssUrlPrefix + 'support/powerscribe-360-analytics/index.htm');
g_navNode_0_34=g_navNode_0.addNode('ncom_support_loquendo','Loquendo',ssUrlPrefix + 'support/loquendo/index.htm');
g_navNode_0_36=g_navNode_0.addNode('ncom_support_DMEE','Dragon Medical Enterprise Edition',ssUrlPrefix + 'support/dragon-medical-enterprise-edition/index.htm');
g_navNode_0_37=g_navNode_0.addNode('ncom_DMNE','Dragon Medical Network Edition',ssUrlPrefix + 'support/dragon-medical-network-edition/index.htm');
g_navNode_0_39=g_navNode_0.addNode('ncom_support_dragonsdk','Dragon Medical SDK',ssUrlPrefix + 'support/dragon-medical-sdk/index.htm');
g_navNode_0_41=g_navNode_0.addNode('ncom_DNSM','Dragon Naturally Speaking Medical',ssUrlPrefix + 'support/dragon-naturally-speaking-medical/index.htm');
g_navNode_0_42=g_navNode_0.addNode('ncom_support_reqreplmedi','Request Replacement Media',ssUrlPrefix + 'support/request-replacement-media/index.htm');
g_navNode_0_43=g_navNode_0.addNode('ncom_supp_reqseragrequot','Request a Maintenance Service Agreement Quote',ssUrlPrefix + 'support/request-maintenance-service-agreement-quote/index.htm','contributorOnly==FALSE');
g_navNode_0_44=g_navNode_0.addNode('ncom_supp_360speechm','360 SpeechMagic SDK',ssUrlPrefix + 'support/360-speechmagic-sdk/index.htm','contributorOnly==FALSE');
g_navNode_0_45=g_navNode_0.addNode('ncom_support_omnipagesdk','Omnipage SDK',ssUrlPrefix + 'support/omnipage-sdk/index.htm');
g_navNode_0_46=g_navNode_0.addNode('ncom_supp_dragassist','Dragon Assistant',ssUrlPrefix + 'support/dragon-assistant/index.htm');
g_navNode_0_47=g_navNode_0.addNode('ncom_supp_quantim','Clintegrity360 Quantim Commercial',ssUrlPrefix + 'support/clintegrity360-quantim-commercial/index.htm');
g_navNode_0_48=g_navNode_0.addNode('ncom_support_pdfreader8','PDF Reader 8',ssUrlPrefix + 'support/pdf-reader-8/index.htm');
g_navNode_0_49=g_navNode_0.addNode('Ncom_supp_clinte360','Clintegrity 360 Government',ssUrlPrefix + 'support/clintegrity360-government/index.htm');
g_navNode_0_50=g_navNode_0.addNode('ncom_supp_clint360qualmana','Clintegrity 360 Quality Management Solutions ',ssUrlPrefix + 'support/clintegrity360-quality-management-solutions/index.htm');
g_navNode_0_51=g_navNode_0.addNode('ncom_sup_dragnotes','Dragon Notes',ssUrlPrefix + 'support/dragon-notes/index.htm');
g_navNode_0_52=g_navNode_0.addNode('ncom_support_copitrak','Copitrak',ssUrlPrefix + 'support/copitrak/index.htm','contributorOnly==FALSE');
g_navNode_0_53=g_navNode_0.addNode('ncom_supp_clinic360_transcript','Clinic 360 Transcription',ssUrlPrefix + 'support/clinic360-transcription/index.htm');
if (SSContributor)
{
g_navNode_0_54=g_navNode_0.addNode('ncom_support_safecom','SafeCom',ssUrlPrefix + 'support/safecom/index.htm','contributorOnly==TRUE');
}
if (SSContributor)
{
g_navNode_0_55=g_navNode_0.addNode('ncom_support_equitrac','Equitrac',ssUrlPrefix + 'support/equitrac/index.htm','contributorOnly==TRUE');
}
g_navNode_0_56=g_navNode_0.addNode('ncom_support_powerpdf','Power PDF',ssUrlPrefix + 'support/power-pdf/index.htm','xmlQueryText==imagingSupportOveride');
g_navNode_0_57=g_navNode_0.addNode('ncom_supp_clintegrity_cdi','Clintegrity CDI',ssUrlPrefix + 'support/clintegrity-cdi/index.htm');
g_navNode_0_58=g_navNode_0.addNode('ncom_support_imaging','imaging',ssUrlPrefix + 'support/imaging/index.htm');
g_navNode_0_59=g_navNode_0.addNode('ncom_supp_mpower_analytics','mPower Analytics',ssUrlPrefix + 'support/mpower-analytics/index.htm');
g_navNode_1=g_navNode_Root.addNode('ncom_forpeople','For people',ssUrlPrefix + 'for-individuals/index.htm','searchDispDesc==From products that make it more simple to study to ones that give you command in your car, Nuance makes all of your technology work for you.','secondaryUrlVariableField==PRODUCT_CONTENT');
g_navNode_1_0=g_navNode_1.addNode('ncom_idv_byindustry','By Industry',ssUrlPrefix + 'for-individuals/by-industry/index.htm');
g_navNode_1_0_0=g_navNode_1_0.addNode('ncom_idv_ind_automotive','Automotive Solutions',ssUrlPrefix + 'for-individuals/by-industry/automotive-solutions/index.htm');
g_navNode_1_0_0_0=g_navNode_1_0_0.addNode('ncom_indi_ind_autsol_2ha','2hands2eyes',ssUrlPrefix + 'for-individuals/by-industry/automotive-solutions/2-hands-2-eyes/index.htm');
g_navNode_1_0_0_1=g_navNode_1_0_0.addNode('ncom_indiv_auto_automotive_dri','Driver Distraction Study',ssUrlPrefix + 'for-individuals/by-industry/automotive-solutions/driver-distraction-study/index.htm');
g_navNode_1_0_0_2=g_navNode_1_0_0.addNode('ncom_indiv_indu_auto_Nuance_Au','Speech Solutions Keeping drivers safe - remove',ssUrlPrefix + 'for-individuals/by-industry/automotive-solutions/speech-solutions-keeping-drivers-safe/index.htm');
g_navNode_1_0_1=g_navNode_1_0.addNode('ncom_idv_ind_education','Education Solutions',ssUrlPrefix + 'for-individuals/by-industry/education-solutions/index.htm');
g_navNode_1_0_1_0=g_navNode_1_0_1.addNode('indi_indu_drag_education','Dragon Education Solutions',ssUrlPrefix + 'for-individuals/by-industry/education-solutions/dragon-education-solutions/index.htm');
g_navNode_1_0_1_1=g_navNode_1_0_1.addNode('ncom_ind_sol_edu_lectint','Lecture Interview',ssUrlPrefix + 'for-individuals/by-industry/education-solutions/lecture-interview/index.htm','RedirectTo==/dragon/transcription-solutions/');
g_navNode_1_0_1_2=g_navNode_1_0_1.addNode('ncom_indv_ind_educ_trans','Transcribing Interview',ssUrlPrefix + 'for-individuals/by-industry/education-solutions/transcribing-interview/index.htm','RedirectTo==/dragon/transcription-solutions/');
g_navNode_1_0_2=g_navNode_1_0.addNode('ncom_idv_ind_financial','Financial Solutions',ssUrlPrefix + 'for-individuals/by-industry/financial-solutions/index.htm');
g_navNode_1_0_3=g_navNode_1_0.addNode('ncom_idv_ind_government','Government Solutions',ssUrlPrefix + 'for-individuals/by-industry/government-solutions/index.htm');
g_navNode_1_0_4=g_navNode_1_0.addNode('ncom_idv_ind_healthcare','Healthcare Solutions',ssUrlPrefix + 'for-individuals/by-industry/healthcare-solutions/index.htm');
g_navNode_1_0_5=g_navNode_1_0.addNode('ncom_idv_ind_insurance','Insurance Solutions',ssUrlPrefix + 'for-individuals/by-industry/insurance-solutions/index.htm');
g_navNode_1_0_5_0=g_navNode_1_0_5.addNode('indi_indu_drag_insurance','Dragon Insurance Solutions',ssUrlPrefix + 'for-individuals/by-industry/insurance-solutions/insurance/index.htm');
g_navNode_1_0_6=g_navNode_1_0.addNode('ncom_idv_ind_legal','Legal Solutions',ssUrlPrefix + 'for-individuals/by-industry/legal-solution/index.htm');
g_navNode_1_0_6_0=g_navNode_1_0_6.addNode('indi_indu_drag_legal','Dragon Legal Solutions',ssUrlPrefix + 'for-individuals/by-industry/legal-solution/legal/index.htm');
g_navNode_1_0_7=g_navNode_1_0.addNode('ncom_indiv_indu_dragon','Dragon',ssUrlPrefix + 'for-individuals/by-industry/dragon/index.htm');
g_navNode_1_0_7_0=g_navNode_1_0_7.addNode('ncom_indiv_indu_dragon_accessi','Accessibility',ssUrlPrefix + 'for-individuals/by-industry/dragon/accessibility/index.htm','RedirectTo==http\x3a//www.nuance.com/dragon/accessibility-solutions/index.htm');
g_navNode_1_1=g_navNode_1.addNode('ncom_idv_bysolution','By Solution',ssUrlPrefix + 'for-individuals/by-solution/index.htm','mainNavSeparatorClass==site-map-separator two-list','secondaryUrlVariableField==PRODUCT_CONTENT');
g_navNode_1_1_0=g_navNode_1_1.addNode('ncom_indivi_indus_mobile','Mobile Solution',ssUrlPrefix + 'for-individuals/by-solution/mobile-solution/index.htm');
g_navNode_1_1_0_0=g_navNode_1_1_0.addNode('ncom_indi_solu_mob_auton','Automotive Newsletter',ssUrlPrefix + 'for-individuals/by-solution/mobile-solution/automotive-newsletter/index.htm');
g_navNode_1_1_0_1=g_navNode_1_1_0.addNode('ncom_ind_sol_mob_neltjan','Newsletter Automotive January',ssUrlPrefix + 'for-individuals/by-solution/mobile-solution/newsletter-automotive-january/index.htm');
g_navNode_1_1_0_2=g_navNode_1_1_0.addNode('ncom_ind_sol_mob_neltmar','Newletter Automotive March',ssUrlPrefix + 'for-individuals/by-solution/mobile-solution/newsletter-automotive-march/index.htm');
g_navNode_1_1_0_3=g_navNode_1_1_0.addNode('ncom_ind_sol_mob_neltapr','Newletter Automotive April',ssUrlPrefix + 'for-individuals/by-solution/mobile-solution/newletter-automotive-april/index.htm');
g_navNode_1_1_0_4=g_navNode_1_1_0.addNode('ncom_ind_sol_mob_neltaug','Newletter Automotive August',ssUrlPrefix + 'for-individuals/by-solution/mobile-solution/newletters-automotive-august/index.htm');
g_navNode_1_1_0_5=g_navNode_1_1_0.addNode('ncom_ind_sol_mo_newsdec','Newletter Automotive December',ssUrlPrefix + 'for-individuals/by-solution/mobile-solution/newsletter-automotive-december/index.htm');
g_navNode_1_1_0_6=g_navNode_1_1_0.addNode('ncom_ind_sol_mob_newfeb','Newsletter Automotive February',ssUrlPrefix + 'for-individuals/by-solution/mobile-solution/newsletter-automotive-february/index.htm');
g_navNode_1_1_0_7=g_navNode_1_1_0.addNode('ncom_ind_sol_moso_nema','Newsletter Automotive March 2013',ssUrlPrefix + 'for-individuals/by-solution/mobile-solution/newsletter-automotive-march-2013/index.htm');
g_navNode_1_1_1=g_navNode_1_1.addNode('ncom_idv_sol_accessibility','Accessibility',ssUrlPrefix + 'for-individuals/by-solution/accessibility/index.htm');
g_navNode_1_1_2=g_navNode_1_1.addNode('ncom_idv_sol_docmgmt','Document Scanning \x26 Conversion',ssUrlPrefix + 'for-individuals/by-solution/document-management/index.htm');
g_navNode_1_1_7=g_navNode_1_1.addNode('ncom_indiv_solu_talkszooms','Talks \x26 Zooms',ssUrlPrefix + 'for-individuals/by-solution/talks-zooms/index.htm');
g_navNode_1_1_7_0=g_navNode_1_1_7.addNode('ncom_indi_prod_daisy2go','Daisy 2 Go',ssUrlPrefix + 'for-individuals/by-solution/talks-zooms/daisy/index.htm');
g_navNode_1_1_7_1=g_navNode_1_1_7.addNode('ncom_indivi_solu_takzoo_phones','Phones',ssUrlPrefix + 'for-individuals/by-solution/talks-zooms/phones/index.htm');
g_navNode_1_1_7_2=g_navNode_1_1_7.addNode('ncom_indivi_solu_takzoom_dowlo','Downloads',ssUrlPrefix + 'for-individuals/by-solution/talks-zooms/downloads/index.htm');
g_navNode_1_1_7_3=g_navNode_1_1_7.addNode('ncom_indi_solu_talzoom_dealers','Dealers',ssUrlPrefix + 'for-individuals/by-solution/talks-zooms/dealers/index.htm');
g_navNode_1_1_7_4=g_navNode_1_1_7.addNode('ncom_indi_sol_talkzoo_premedit','Premium Edition Key Benefits',ssUrlPrefix + 'for-individuals/by-solution/talks-zooms/key-benefits/index.htm');
g_navNode_1_1_7_5=g_navNode_1_1_7.addNode('ncom_indiv_sol_talzoom_flashmp','Media',ssUrlPrefix + 'for-individuals/by-solution/talks-zooms/media/index.htm');
g_navNode_1_2=g_navNode_1.addNode('ncom_idv_byproduct','By Product',ssUrlPrefix + 'for-individuals/by-product/index.htm','mainNavSeparatorClass==site-map-separator','secondaryUrlVariableField==PRODUCT_CONTENT');
g_navNode_1_2_0=g_navNode_1_2.addNode('ncom_ind_prod_flext9adr','Flex T9 for Android',ssUrlPrefix + 'for-individuals/by-product/flex-t9-for-android/index.htm','RedirectTo==http\x3a//www.nuance.com/landing-pages/products/swype/ ','RedirectURL==http\x3a//www.nuance.com/landing-pages/products/swype/ ','contributorOnly==FALSE');
g_navNode_1_2_1=g_navNode_1_2.addNode('ncom_indi_prod_jott_v2tservice','Voicemail to Text Services',ssUrlPrefix + 'for-individuals/by-product/voicemai-to-text-services/index.htm');
g_navNode_1_2_2=g_navNode_1_2.addNode('ncom_indiv_prod_drag_forpc','Dragon for PC',ssUrlPrefix + 'for-individuals/by-product/dragon-for-pc/index.htm');
g_navNode_1_2_2_2=g_navNode_1_2_2.addNode('ncom_indiv_solu_drag_pc_homeve','Dragon Home Version',ssUrlPrefix + 'for-individuals/by-product/dragon-for-pc/home-version/index.htm');
if (SSContributor)
{
g_navNode_1_2_2_3=g_navNode_1_2_2.addNode('ncom_indiv_solu_drag_pc_spekse','Add Ons Speak See',ssUrlPrefix + 'for-individuals/by-product/dragon-for-pc/add-ons-speak-see/index.htm','contributorOnly==TRUE');
}
g_navNode_1_2_2_7=g_navNode_1_2_2.addNode('ncom_indiv_prod_drag_forpcdemo','How To Demos',ssUrlPrefix + 'for-individuals/by-product/dragon-for-pc/how-to-demos/index.htm');
g_navNode_1_2_2_8=g_navNode_1_2_2.addNode('ncom_indiv_prod_drag_forpcde12','How To Demos DNS12',ssUrlPrefix + 'for-individuals/by-product/dragon-for-pc/how-to-demos-version12/index.htm');
g_navNode_1_2_2_9=g_navNode_1_2_2.addNode('ncom_indiv_solu_drag_pc_premve','Dragon Premium Version',ssUrlPrefix + 'for-individuals/by-product/dragon-for-pc/premium-version/index.htm');
g_navNode_1_2_3=g_navNode_1_2.addNode('ncom_indiv_prod_drag_ForMAC','Dragon for Mac',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/index.htm');
g_navNode_1_2_3_0=g_navNode_1_2_3.addNode('ncom_drag_whatne_whatn25','What\'s New Dictate 2.5',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/whats-new-dictate-2-5/index.htm');
g_navNode_1_2_3_1=g_navNode_1_2_3.addNode('ncom_drag_maclion','Mac Lion',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/mac-lion/index.htm','RedirectTo==http\x3a//www.nuance.com/for-individuals/by-product/dragon-for-mac/compatibility/index.htm');
g_navNode_1_2_3_5=g_navNode_1_2_3.addNode('ncom_indi_prod_drag_mac_legal','MacSpeech Dictate Legal',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/mac-speech-dictate-legal/index.htm');
g_navNode_1_2_3_7=g_navNode_1_2_3.addNode('ncom_indi_drama_macspcom','MacSpeech Compatability',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/mac-compatability/index.htm');
g_navNode_1_2_3_8=g_navNode_1_2_3.addNode('ncom_indi_pro_dramac_how','How To Demos',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/how-to-demos/index.htm','secondaryUrlVariableField==PRODUCT_CONTENT');
g_navNode_1_2_3_9=g_navNode_1_2_3.addNode('ncom_ind_pro_drm_dictfea','Dictate 2.5 Features',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/dictate-2-5-features/index.htm');
g_navNode_1_2_3_10=g_navNode_1_2_3.addNode('ncom_ind_pro_mac_dictupg','Dictate Upgrade',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/dictate-upgrade/index.htm');
g_navNode_1_2_3_14=g_navNode_1_2_3.addNode('ncom_drag_compatibility','Mac Compatibility',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/compatibility/index.htm');
g_navNode_1_2_3_15=g_navNode_1_2_3.addNode('ncom_indi_prod_drag_macdic_sof','Dragon for Mac Software',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/software/index.htm');
g_navNode_1_2_3_16=g_navNode_1_2_3.addNode('ncom_indi_prod_drag_macdic_med','Dragon for Mac Medical',ssUrlPrefix + 'for-individuals/by-product/dragon-for-mac/dragon-for-mac-medical/index.htm');
if (SSContributor)
{
g_navNode_1_2_5=g_navNode_1_2.addNode('ncom_idv_pro_vocalizer','Nuance Vocalizer',ssUrlPrefix + 'for-individuals/by-product/vocalizer/index.htm','contributorOnly==TRUE');
}
g_navNode_1_2_6=g_navNode_1_2.addNode('ncom_idv_pro_voicemode','Nuance VoiceMode',ssUrlPrefix + 'for-individuals/by-product/voice-mode/index.htm');
if (SSContributor)
{
g_navNode_1_2_7=g_navNode_1_2.addNode('ncom_idv_pro_vsuite','VSuite',ssUrlPrefix + 'for-individuals/by-product/vsuite/index.htm','contributorOnly==TRUE');
}
g_navNode_1_2_8=g_navNode_1_2.addNode('ncom_idv_pro_omnipage','OmniPage',ssUrlPrefix + 'for-individuals/by-product/omnipage/index.htm');
g_navNode_1_2_9=g_navNode_1_2.addNode('ncom_idv_pro_paperport','PaperPort',ssUrlPrefix + 'for-individuals/by-product/paperport/index.htm','searchDispDesc==PaperPort Profession 14 is the leading choice for scanning, organizing, and sharing all your documents.');
g_navNode_1_2_9_0=g_navNode_1_2_9.addNode('ncom_ind_prod_paprpt_ppt','PaperPort notes',ssUrlPrefix + 'for-individuals/by-product/paperport/paperport-notes/index.htm');
g_navNode_1_2_11=g_navNode_1_2.addNode('ncom_indi_prod_t9nav','T9Nav',ssUrlPrefix + 'for-individuals/by-product/t9nav/index.htm','RedirectTo==http\x3a//www.nuance.com/landing-pages/products/swype/ ','RedirectURL==http\x3a//www.nuance.com/landing-pages/products/swype/ ');
if (SSContributor)
{
g_navNode_1_2_12=g_navNode_1_2.addNode('ncom_indiv_prod_Series9500','Nokia Communicator Series 9500',ssUrlPrefix + 'for-individuals/by-product/nokia-communicator-series-9500/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
if (SSContributor)
{
g_navNode_1_2_13=g_navNode_1_2.addNode('ncom_indiv_prod_Series9200','Nokia Communicator Series 9200',ssUrlPrefix + 'for-individuals/by-product/nokia-communicator-series-9200/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
if (SSContributor)
{
g_navNode_1_2_14=g_navNode_1_2.addNode('ncom_indivi_prod_edition1','Series 60 Edition 1',ssUrlPrefix + 'for-individuals/by-product/series-60-edition-1/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
g_navNode_1_2_15=g_navNode_1_2.addNode('ncom_indivi_prod_edition2','Series 60 Edition 2',ssUrlPrefix + 'for-individuals/by-product/series-60-edition-2/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_1_2_16=g_navNode_1_2.addNode('ncom_indivi_prod_edition3','Series 60 Edition 3',ssUrlPrefix + 'for-individuals/by-product/series-60-edition-3/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_1_2_17=g_navNode_1_2.addNode('ncom_indi_prod_jott','Voice to Text',ssUrlPrefix + 'for-individuals/by-product/voice-to-text/index.htm');
g_navNode_1_2_18=g_navNode_1_2.addNode('ncom_indi_prod_t9','T9',ssUrlPrefix + 'for-individuals/by-product/t9/index.htm','RedirectTo==http\x3a//www.nuance.com/landing-pages/products/swype/ ','RedirectURL==http\x3a//www.nuance.com/landing-pages/products/swype/ ','contributorOnly==FALSE');
g_navNode_1_2_19=g_navNode_1_2.addNode('ncom_indi_prod_t9trace','T9 Trace',ssUrlPrefix + 'for-individuals/by-product/t9-trace/index.htm','RedirectTo==http\x3a//www.nuance.com/landing-pages/products/swype/ ','RedirectURL==http\x3a//www.nuance.com/landing-pages/products/swype/ ','contributorOnly==FALSE');
g_navNode_1_2_20=g_navNode_1_2.addNode('ncom_indi_prod_t9write','T9 Write',ssUrlPrefix + 'for-individuals/by-product/t9-write/index.htm','RedirectTo==http\x3a//www.nuance.com/landing-pages/products/swype/ ','RedirectURL==http\x3a//www.nuance.com/landing-pages/products/swype/ ','contributorOnly==FALSE');
g_navNode_1_2_21=g_navNode_1_2.addNode('ncom_indi_prod_XT9','XT9',ssUrlPrefix + 'for-individuals/by-product/xt9/index.htm','RedirectTo==http\x3a//www.nuance.com/landing-pages/products/swype/ ','RedirectURL==http\x3a//www.nuance.com/landing-pages/products/swype/ ','contributorOnly==FALSE');
g_navNode_1_2_22=g_navNode_1_2.addNode('ncom_indi_prod_dragdictationip','Dragon Dictation\x3a iPhone',ssUrlPrefix + 'for-individuals/by-product/dragon-dictation-iphone/index.htm','contributorOnly==FALSE');
if (SSContributor)
{
g_navNode_1_2_23=g_navNode_1_2.addNode('ncom_indi_prod_dragonsearchiph','Dragon Search\x3a iPhone',ssUrlPrefix + 'for-individuals/by-product/dragon-search-iphone/index.htm','contributorOnly==TRUE');
}
if (SSContributor)
{
g_navNode_1_2_24=g_navNode_1_2.addNode('ncom_indi_prod_dragemailblackb','Dragon for Email\x3a Blackberry',ssUrlPrefix + 'for-individuals/by-product/dragon-for-email-blackberry/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
g_navNode_1_2_25=g_navNode_1_2.addNode('ncom_indi_prod_t9output','T9 Output',ssUrlPrefix + 'for-individuals/by-product/t9-output/index.htm','RedirectTo==http\x3a//www.nuance.com/landing-pages/products/swype/ ','RedirectURL==http\x3a//www.nuance.com/landing-pages/products/swype/ ','contributorOnly==FALSE');
g_navNode_1_2_26=g_navNode_1_2.addNode('ncom_indi_prod_bmw','BMW',ssUrlPrefix + 'for-individuals/by-product/bmw/index.htm');
g_navNode_1_2_26_0=g_navNode_1_2_26.addNode('ncom_ind_pro_bmw_ddmstcon','Stay Connected',ssUrlPrefix + 'for-individuals/by-product/bmw/stay-connected/index.htm');
g_navNode_1_2_26_1=g_navNode_1_2_26.addNode('ncom_ind_pro_bmw_voicomm','Voice Commands',ssUrlPrefix + 'for-individuals/by-product/bmw/voice-commands/index.htm');
g_navNode_1_2_26_2=g_navNode_1_2_26.addNode('ncom_ind_pro_bmw_sysreq','System Requirements',ssUrlPrefix + 'for-individuals/by-product/bmw/system-requirements/index.htm');
g_navNode_1_2_26_3=g_navNode_1_2_26.addNode('ncom_ind_pro_bmw_howtog','How to get Dragon Drive',ssUrlPrefix + 'for-individuals/by-product/bmw/how-to/index.htm');
g_navNode_1_2_26_4=g_navNode_1_2_26.addNode('ncom_ind_pro_bmw_tiatri','Tips and Tricks',ssUrlPrefix + 'for-individuals/by-product/bmw/tips-and-tricks/index.htm');
g_navNode_1_2_26_5=g_navNode_1_2_26.addNode('ncom_prod_ind_bmw_greuse','Great Uses',ssUrlPrefix + 'for-individuals/by-product/bmw/great-uses/index.htm');
g_navNode_1_2_26_6=g_navNode_1_2_26.addNode('ncom_ind_pro_bmw_faq','FAQ',ssUrlPrefix + 'for-individuals/by-product/bmw/faqs/index.htm');
g_navNode_1_2_28=g_navNode_1_2.addNode('ncom_indiv_prod_drag_apps','Dragon Accessories',ssUrlPrefix + 'for-individuals/by-product/dragon-accessories/index.htm');
g_navNode_1_4=g_navNode_1.addNode('ncom_indiv_mobileapps','Mobile Applications',ssUrlPrefix + 'for-individuals/mobile-applications/index.htm');
g_navNode_1_4_0=g_navNode_1_4.addNode('ncom_indiv_mobileapps_mobileas','Dragon Mobile Assistant',ssUrlPrefix + 'for-individuals/mobile-applications/dragon-mobile-assistant/index.htm');
g_navNode_1_4_1=g_navNode_1_4.addNode('ncom_indiv_mobileapps_dictatio','Dragon Dictation',ssUrlPrefix + 'for-individuals/mobile-applications/dragon-dictation/index.htm');
g_navNode_1_4_2=g_navNode_1_4.addNode('ncom_prod_dragongoinacti','Dragon Go',ssUrlPrefix + 'for-individuals/mobile-applications/dragon-go/index.htm');
g_navNode_1_4_3=g_navNode_1_4.addNode('ncom_indiv_mobileapps_talkszoo','Mobile Accessibility \x28TALKS \x26 ZOOMS\x29',ssUrlPrefix + 'for-individuals/mobile-applications/talks-zooms/index.htm');
g_navNode_2=g_navNode_Root.addNode('ncom_forbusiness','For Business',ssUrlPrefix + 'for-business/index.htm','searchDispDesc==Nuance offers a wide range of solutions and products for businesses of all types.');
g_navNode_2_0=g_navNode_2.addNode('ncom_bus_byindustry','By Industry',ssUrlPrefix + 'for-business/by-industry/index.htm');
g_navNode_2_0_0=g_navNode_2_0.addNode('ncom_bus_ind_automotive','Automotive',ssUrlPrefix + 'for-business/by-industry/automotive/index.htm');
g_navNode_2_0_1=g_navNode_2_0.addNode('ncom_bus_ind_education','Education',ssUrlPrefix + 'for-business/by-industry/education/index.htm');
g_navNode_2_0_1_0=g_navNode_2_0_1.addNode('bus_solu_drag_indu_education','Dragon Education Solutions',ssUrlPrefix + 'for-business/by-industry/education/dragon-education-solutions/index.htm');
g_navNode_2_0_1_1=g_navNode_2_0_1.addNode('bus_solu_drag_indu_edu_val','Education Validation',ssUrlPrefix + 'for-business/by-industry/education/education-validation/index.htm');
g_navNode_2_0_1_1_0=g_navNode_2_0_1_1.addNode('ncom_bus_sol_drag_ind_edu_elig','Eligibility Definitions',ssUrlPrefix + 'for-business/by-industry/education/education-validation/eligibility_definitions/index.htm');
g_navNode_2_0_1_2=g_navNode_2_0_1.addNode('ncom_bus_industry_edu_edusolu','Education Solution',ssUrlPrefix + 'for-business/by-industry/education/education-solutions/index.htm');
g_navNode_2_0_3=g_navNode_2_0.addNode('ncom_bus_ind_finanservice','Financial',ssUrlPrefix + 'for-business/by-industry/financial-services/index.htm');
g_navNode_2_0_3_1=g_navNode_2_0_3.addNode('ncom_industry_finan_finan_solu','Financial Solution',ssUrlPrefix + 'for-business/by-industry/financial-services/financial-solutions/index.htm');
g_navNode_2_0_4=g_navNode_2_0.addNode('ncom_bus_ind_government','Government',ssUrlPrefix + 'for-business/by-industry/government/index.htm');
g_navNode_2_0_4_0=g_navNode_2_0_4.addNode('ncom_bus_indstry_gov_govsolutn','Government Solution',ssUrlPrefix + 'for-business/by-industry/government/government-solution/index.htm');
g_navNode_2_0_4_1=g_navNode_2_0_4.addNode('ncom_bus_ind_gov_veteran','VA',ssUrlPrefix + 'for-business/by-industry/government/va/index.htm');
g_navNode_2_0_5=g_navNode_2_0.addNode('ncom_bus_ind_healthcare','Healthcare',ssUrlPrefix + 'for-business/by-industry/healthcare/index.htm');
g_navNode_2_0_5_0=g_navNode_2_0_5.addNode('ncom_bus_indt_hc_healthcaresol','Healthcare Solution',ssUrlPrefix + 'for-business/by-industry/healthcare/healthcare-solution/index.htm');
g_navNode_2_0_6=g_navNode_2_0.addNode('ncom_bus_ind_insurance','Insurance',ssUrlPrefix + 'for-business/by-industry/insurance/index.htm');
g_navNode_2_0_6_0=g_navNode_2_0_6.addNode('bus_solu_drag_indu_insurance','Dragon Insurance Solutions',ssUrlPrefix + 'for-business/by-industry/insurance/Insurance/index.htm');
g_navNode_2_0_6_1=g_navNode_2_0_6.addNode('ncom_bus_indstry_ins_inssol','Insurance Solution',ssUrlPrefix + 'for-business/by-industry/insurance/insurance-solution/index.htm');
g_navNode_2_0_7=g_navNode_2_0.addNode('ncom_bus_ind_journalism','Journalism',ssUrlPrefix + 'for-business/by-industry/journalism/index.htm');
g_navNode_2_0_8=g_navNode_2_0.addNode('ncom_bus_ind_legal','Legal',ssUrlPrefix + 'for-business/by-industry/legal/index.htm');
g_navNode_2_0_8_0=g_navNode_2_0_8.addNode('bus_solu_drag_indus_legal','Dragon Legal Solutions',ssUrlPrefix + 'for-business/by-industry/legal/Legal/index.htm');
g_navNode_2_0_8_1=g_navNode_2_0_8.addNode('ncom_bus_indstry_legal_lglsol','Legal Solution',ssUrlPrefix + 'for-business/by-industry/legal/legal-solution/index.htm');
g_navNode_2_0_9=g_navNode_2_0.addNode('ncom_bus_ind_mobileoem','Mobile OEMs',ssUrlPrefix + 'for-business/by-industry/mobile-oems/index.htm');
g_navNode_2_0_10=g_navNode_2_0.addNode('ncom_bus_ind_retail','Retail',ssUrlPrefix + 'for-business/by-industry/retail/index.htm');
g_navNode_2_0_11=g_navNode_2_0.addNode('ncom_bus_ind_servproviders','Telco / Service Providers',ssUrlPrefix + 'for-business/by-industry/service-providers/index.htm');
g_navNode_2_0_12=g_navNode_2_0.addNode('ncom_bus_ind_travelhosp','Travel / Hospitality',ssUrlPrefix + 'for-business/by-industry/travel-hospitality/index.htm');
g_navNode_2_0_13=g_navNode_2_0.addNode('ncom_bus_industry_construction','Construction',ssUrlPrefix + 'for-business/by-industry/construction/index.htm');
g_navNode_2_0_13_0=g_navNode_2_0_13.addNode('ncom_bus_indsty_const_constsol','Construction Solution',ssUrlPrefix + 'for-business/by-industry/construction/construction-solution/index.htm');
g_navNode_2_0_14=g_navNode_2_0.addNode('ncom_busi_indu_dragon','Dragon',ssUrlPrefix + 'for-business/by-industry/dragon/index.htm');
g_navNode_2_0_14_0=g_navNode_2_0_14.addNode('bus_solu_drag_indu_socialservi','Dragon Social Services',ssUrlPrefix + 'for-business/by-industry/dragon/social-services/index.htm');
g_navNode_2_0_14_1=g_navNode_2_0_14.addNode('bus_solu_drag_indu_publicsafet','Dragon Public Safety',ssUrlPrefix + 'for-business/by-industry/dragon/public-safety/index.htm');
g_navNode_2_0_14_1_1=g_navNode_2_0_14_1.addNode('ncom_bu_in_dr_pubsafbrief','Public Safety Brief',ssUrlPrefix + 'for-business/by-industry/dragon/public-safety/public-safety-brief/index.htm');
g_navNode_2_0_14_2=g_navNode_2_0_14.addNode('bus_solu_drag_indu_allindustri','All Industries',ssUrlPrefix + 'for-business/by-industry/dragon/AllIndustries/index.htm');
g_navNode_2_0_14_3=g_navNode_2_0_14.addNode('bus_solu_drag_indus_accessibil','Dragon Accessibility',ssUrlPrefix + 'for-business/by-industry/dragon/Accessibility/index.htm','searchDispDesc==Dragon speech recognition lets individuals with accessibility issues that can make typing difficult or painful work virtually hands-free. ');
g_navNode_2_0_14_4=g_navNode_2_0_14.addNode('bus_ind_dragon_financial','Dragon Financial Services',ssUrlPrefix + 'for-business/by-industry/dragon/financial-services/index.htm');
g_navNode_2_0_14_5=g_navNode_2_0_14.addNode('ncom_dragon_law_enforcement','Law Enforcement',ssUrlPrefix + 'for-business/by-industry/dragon/dragon-law-enforcement/index.htm');
g_navNode_2_0_15=g_navNode_2_0.addNode('ncom_busi_indu_employeeproduct','Employee Productivity',ssUrlPrefix + 'for-business/by-industry/employee-productivity/index.htm');
g_navNode_2_0_16=g_navNode_2_0.addNode('ncom_bus_indstry_Manufacturing','Manufacturing',ssUrlPrefix + 'for-business/by-industry/manufacturing/index.htm');
g_navNode_2_0_16_0=g_navNode_2_0_16.addNode('ncom_bus_indsrty_manu_manusolu','Manufacturing Solution',ssUrlPrefix + 'for-business/by-industry/manufacturing/manufacturing-solution/index.htm');
g_navNode_2_1=g_navNode_2.addNode('ncom_bus_bysolution','By Solution',ssUrlPrefix + 'for-business/by-solution/index.htm','mainNavSeparatorClass==site-map-separator','secondaryUrlVariableField==PRODUCT_CONTENT');
g_navNode_2_1_0=g_navNode_2_1.addNode('ncom_part_prod_jott','Voice to Text',ssUrlPrefix + 'for-business/by-solution/Voice-to-text/index.htm');
g_navNode_2_1_1=g_navNode_2_1.addNode('ncom_bus_sol_custservic','Customer Service Solutions',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/index.htm');
g_navNode_2_1_1_1=g_navNode_2_1_1.addNode('cccc_strategic_partners','Strategic Partners Overview',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/strategic-partners-overview/index.htm');
g_navNode_2_1_1_1_0=g_navNode_2_1_1_1.addNode('ncom_bus_sol_cccc_prt_avaya','Avaya',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/strategic-partners-overview/avaya/index.htm');
g_navNode_2_1_1_1_1=g_navNode_2_1_1_1.addNode('ncom_bus_sol_cccc_prt_cisco','Cisco',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/strategic-partners-overview/cisco/index.htm');
g_navNode_2_1_1_1_2=g_navNode_2_1_1_1.addNode('ncom_bus_sol_cccc_prt_genesys','Genesys',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/strategic-partners-overview/genesys/index.htm');
g_navNode_2_1_1_1_3=g_navNode_2_1_1_1.addNode('ncom_bus_sol_cccc_prt_ibm','IBM',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/strategic-partners-overview/ibm/index.htm');
g_navNode_2_1_1_2=g_navNode_2_1_1.addNode('cccc_solutions_services','Solutions and Services',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/index.htm','searchDispDesc==Nuance helps organizations deliver intelligent self-service solutions so customers can access what they need from contact centers, websites or mobile apps.');
g_navNode_2_1_1_2_0=g_navNode_2_1_1_2.addNode('ncom_bus_sol_mccs_numoad','Mobile Customer Service',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/mobile-customer-service/index.htm','nonViewableCountries==ENUS,ENUK,AU,NZ,FR,DE');
g_navNode_2_1_1_2_0_0=g_navNode_2_1_1_2_0.addNode('ncom_css_ccss_nma_mcs_ni','Nina',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/mobile-customer-service/nina/index.htm','RedirectTo==http\x3a//www.nuance.com/landing-pages/products/nina/','RedirectURL==http\x3a//www.nuance.com/landing-pages/products/nina/');
g_navNode_2_1_1_2_0_5=g_navNode_2_1_1_2_0.addNode('ncom_bus_sol_css_ccss_nma_nm','NaturallyMobile',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/mobile-customer-service/naturallymobile/index.htm');
g_navNode_2_1_1_2_0_6=g_navNode_2_1_1_2_0.addNode('ncom_bus_sol_cs_ccs_nma_moau','Mobile Authentication',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/mobile-customer-service/mobile-authentication/index.htm');
g_navNode_2_1_1_2_0_7=g_navNode_2_1_1_2_0.addNode('ncom_bus_sol_cs_ccs_nma_chbg','Channel Bridge',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/mobile-customer-service/channel-bridge/index.htm');
g_navNode_2_1_1_2_0_8=g_navNode_2_1_1_2_0.addNode('ncom_bus_sol_ninaweb','Nina Web',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/mobile-customer-service/nina-web/index.htm','RedirectTo==http\x3a//www.nuance.com/landing-pages/products/nina-web/','RedirectURL==http\x3a//www.nuance.com/landing-pages/products/nina-web/');
g_navNode_2_1_1_2_1=g_navNode_2_1_1_2.addNode('ncom_bus_sol_accessibility','Accessibility',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/accessibility/index.htm');
g_navNode_2_1_1_2_2=g_navNode_2_1_1_2.addNode('ncom_bus_sol_cccc_wcreqform','Webcast Request Form',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/wc-request-form/index.htm');
g_navNode_2_1_1_2_3=g_navNode_2_1_1_2.addNode('ncom_bus_sol_cccc_wpgatedform','Whitepaper Request Form',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/wp-request-form/index.htm');
g_navNode_2_1_1_2_5=g_navNode_2_1_1_2.addNode('ncom_bus_sol_cccc_bygoal','By Goals',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/by-goals/index.htm');
g_navNode_2_1_1_2_5_1=g_navNode_2_1_1_2_5.addNode('ncom_bu_so_cccc_go_nat','Natural Caller Interactions',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/by-goals/natural-caller-interactions/index.htm');
g_navNode_2_1_1_2_5_5=g_navNode_2_1_1_2_5.addNode('ncom_bu_so_cccc_go_low','Lower Operating Costs',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/by-goals/lower-operating-costs/index.htm');
g_navNode_2_1_1_2_9=g_navNode_2_1_1_2.addNode('ncom_bus_sol_cccc_entservices','Enterprise Services',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/enterprise-services/index.htm');
g_navNode_2_1_1_2_9_0=g_navNode_2_1_1_2_9.addNode('ncom_bus_sol_buscon','Business Consulting',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/enterprise-services/business-consulting/index.htm');
g_navNode_2_1_1_2_9_0_1=g_navNode_2_1_1_2_9_0.addNode('ncom_bus_sol_cccc_es_bc_busop','Business Optimization',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/enterprise-services/business-consulting/business-optimization/index.htm');
g_navNode_2_1_1_2_9_3=g_navNode_2_1_1_2_9.addNode('ncom_bus_sol_cccc_es_profserv','Professional Services',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/enterprise-services/professional-services/index.htm');
g_navNode_2_1_1_2_9_3_0=g_navNode_2_1_1_2_9_3.addNode('ncom_bus_sol_cccc_es_ps_desfr','Design Framework',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/enterprise-services/professional-services/design-framework/index.htm');
g_navNode_2_1_1_2_9_3_1=g_navNode_2_1_1_2_9_3.addNode('ncom_bus_sol_cccc_es_ps_devfr','Development Framework',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/enterprise-services/professional-services/development-framework/index.htm');
g_navNode_2_1_1_2_9_3_2=g_navNode_2_1_1_2_9_3.addNode('ncom_bus_sol_cccc_es_ps_aprep','Application Reporting',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/enterprise-services/professional-services/application-reporting/index.htm');
g_navNode_2_1_1_2_9_3_4=g_navNode_2_1_1_2_9_3.addNode('ncom_bus_sol_cccc_es_ps_repfr','Reporting Framework',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/enterprise-services/professional-services/reporting-framework/index.htm');
g_navNode_2_1_1_2_9_3_5=g_navNode_2_1_1_2_9_3.addNode('ncom_bus_sol_cccc_ss_es_ps_ds','Delivery System',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/enterprise-services/professional-services/delivery-system/index.htm');
g_navNode_2_1_1_2_11=g_navNode_2_1_1_2.addNode('ncom_bus_sol_cccc_inboundsol','Inbound Solutions',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/index.htm');
g_navNode_2_1_1_2_11_2=g_navNode_2_1_1_2_11.addNode('ncom_bus_sol_cccc_ccss_slfsrv','Self-Service Automation',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/self-service-automation/index.htm');
g_navNode_2_1_1_2_11_2_0=g_navNode_2_1_1_2_11_2.addNode('ncom_bus_prod_ccs_inbd_ssa_dm','Nuance Dialog Modules',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/self-service-automation/dialog-modules/index.htm');
g_navNode_2_1_1_2_11_2_0_0=g_navNode_2_1_1_2_11_2_0.addNode('ncom_bus_prod_ccs_inbd_ssa_dma','Advanced Dialog Modules',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/self-service-automation/dialog-modules/advanced-dialog-modules/index.htm');
g_navNode_2_1_1_2_11_2_0_1=g_navNode_2_1_1_2_11_2_0.addNode('ncom_bus_prod_ccs_inbd_ssa_dmc','Core Dialog Modules',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/self-service-automation/dialog-modules/core-dialog-modules/index.htm');
g_navNode_2_1_1_2_11_2_1=g_navNode_2_1_1_2_11_2.addNode('ncom_bus_prod_ccs_inbd_ssa_rec','Nuance Recognizer',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/self-service-automation/recognizer/index.htm');
g_navNode_2_1_1_2_11_2_1_2=g_navNode_2_1_1_2_11_2_1.addNode('ncom_bus_prod_ccs_in_ssa_rc_rl','Recognizer Languages',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/self-service-automation/recognizer/recognizer-languages/index.htm');
g_navNode_2_1_1_2_11_2_2=g_navNode_2_1_1_2_11_2.addNode('ncom_bus_prod_ccs_inbd_ssa_voc','Nuance Vocalizer',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/self-service-automation/vocalizer/index.htm','RedirectTo==http\x3a//www.nuance.com/for-business/text-to-speech/vocalizer/index.htm');
g_navNode_2_1_1_2_11_2_2_0=g_navNode_2_1_1_2_11_2_2.addNode('ncom_busi_solu_mobiapp_text9','Text Input Applications',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/self-service-automation/vocalizer/t9/index.htm');
g_navNode_2_1_1_2_11_2_2_4=g_navNode_2_1_1_2_11_2_2.addNode('ncom_bus_prod_ccs_in_ssa_vo_vs','Vocalizer Studio',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/self-service-automation/vocalizer/vocalizer-studio/index.htm');
g_navNode_2_1_1_2_11_2_3=g_navNode_2_1_1_2_11_2.addNode('ncom_bus_sol_cccc_ccss_ssa_nl','Natural Language',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/inbound-solutions/self-service-automation/natural-language/index.htm');
g_navNode_2_1_1_2_13=g_navNode_2_1_1_2.addNode('ncom_bus_sol_cccc_ccss_instsp','Industry Standards Support',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/industry-standards-support/index.htm');
g_navNode_2_1_1_2_15=g_navNode_2_1_1_2.addNode('ncom_bus_css_ccss_ncrp','Nuance Customer Recognition Program',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/nuance-customer-recognition-program/index.htm');
g_navNode_2_1_1_2_16=g_navNode_2_1_1_2.addNode('ncom_bus_css_ccss_newssi','Newsletter Sign up',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/solutions-services/newsletter-signup/index.htm');
g_navNode_2_1_1_3=g_navNode_2_1_1.addNode('ncom_bus_so_cussersol_n1','News Letter Issue 1',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/newsletter-issue-1/index.htm');
g_navNode_2_1_1_4=g_navNode_2_1_1.addNode('ncom_bus_so_cussersol_n2','News Letter Issue 2',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/newsletter-issue-2/index.htm');
g_navNode_2_1_1_5=g_navNode_2_1_1.addNode('ncom_bus_so_cussersol_n3','News Letter Issue 3',ssUrlPrefix + 'for-business/by-solution/customer-service-solutions/newsletter-issue-3/index.htm');
g_navNode_2_1_2=g_navNode_2_1.addNode('ncom_bus_sol_empproductivity','Employee Productivity Suite',ssUrlPrefix + 'for-business/by-solution/employee-productivity-solutions/index.htm','secondaryUrlVariableField==PRODUCT_CONTENT');
g_navNode_2_1_2_0=g_navNode_2_1_2.addNode('ncom_bus_sol_cccc_ccss_eps_sa','SpeechAttendant',ssUrlPrefix + 'for-business/by-solution/employee-productivity-solutions/speech-attendant/index.htm','secondaryUrlVariableField==PRODUCT_CONTENT');
g_navNode_2_1_2_1=g_navNode_2_1_2.addNode('ncom_bus_sol_cccc_ccss_eps_apr','Automated Password Reset',ssUrlPrefix + 'for-business/by-solution/employee-productivity-solutions/automated-password-reset/index.htm');
g_navNode_2_1_2_2=g_navNode_2_1_2.addNode('ncom_bus_sol_eps_contactus','Contact Us',ssUrlPrefix + 'for-business/by-solution/employee-productivity-solutions/contact-us/index.htm');
g_navNode_2_1_4=g_navNode_2_1.addNode('ncom_bus_sol_docscanconvert','Document Scanning \x26 Conversion',ssUrlPrefix + 'for-business/by-solution/document-imaging-and-scanning/index.htm');
g_navNode_2_1_4_0=g_navNode_2_1_4.addNode('ncom_bus_pro_scan_contact','Contact Us',ssUrlPrefix + 'for-business/by-solution/document-imaging-and-scanning/contact-us/index.htm');
g_navNode_2_1_4_1=g_navNode_2_1_4.addNode('ncom_bus_sol_dsc_mfproicalc','MFP ROI Calculator Inquiry',ssUrlPrefix + 'for-business/by-solution/document-imaging-and-scanning/mfp-roi-calculator-inquiry/index.htm');
g_navNode_2_1_4_2=g_navNode_2_1_4.addNode('ncom_bus_DocScanCon_volpri','Volume Pricing',ssUrlPrefix + 'for-business/by-solution/document-imaging-and-scanning/volume-pricing/index.htm');
g_navNode_2_1_5=g_navNode_2_1.addNode('ncom_bus_sol_mobileapps','Mobile Applications',ssUrlPrefix + 'for-business/by-solution/mobile-application/index.htm');
g_navNode_2_1_6=g_navNode_2_1.addNode('ncom_bus_sol_pdf','PDF',ssUrlPrefix + 'for-business/by-solution/pdf/index.htm');
g_navNode_2_1_6_0=g_navNode_2_1_6.addNode('ncom_bus_pdf_download_wp','Download PDF Whitepager',ssUrlPrefix + 'for-business/by-solution/pdf/download-pdf-whitepaper/index.htm','contributorOnly==FALSE');
g_navNode_2_1_6_1=g_navNode_2_1_6.addNode('ncom_bus_sol_pdf_webrep','Webinar Replay',ssUrlPrefix + 'for-business/by-solution/pdf/webinar-replay/index.htm');
g_navNode_2_1_7=g_navNode_2_1.addNode('ncom_bus_sol_speechrecog','Speech Recognition',ssUrlPrefix + 'for-business/by-solution/speech-recognition/index.htm');
g_navNode_2_1_9=g_navNode_2_1.addNode('ncom_auto_busi_solu','Automotive Products and Solutions',ssUrlPrefix + 'for-business/by-solution/automotive-products-and-solutions/index.htm');
g_navNode_2_1_9_0=g_navNode_2_1_9.addNode('ncom_busi_solu_autoprodsolu_au','Automotive Gate Form',ssUrlPrefix + 'for-business/by-solution/automotive-products-and-solutions/automotive-gate-form/index.htm');
g_navNode_2_1_9_1=g_navNode_2_1_9.addNode('ncom_bus_sol_autprosol_c','Contact Us',ssUrlPrefix + 'for-business/by-solution/automotive-products-and-solutions/contact-us/index.htm');
g_navNode_2_1_9_2=g_navNode_2_1_9.addNode('ncom_bu_pro_auto_newssig','Newsletter Signup Form',ssUrlPrefix + 'for-business/by-solution/automotive-products-and-solutions/newsletter-signup-form/index.htm');
g_navNode_2_1_9_3=g_navNode_2_1_9.addNode('ncom_bus_sol_autopro_bmw','BMW',ssUrlPrefix + 'for-business/by-solution/automotive-products-and-solutions/bmw/index.htm');
g_navNode_2_1_9_4=g_navNode_2_1_9.addNode('ncom_bus_sol_autopro_aud','Audi',ssUrlPrefix + 'for-business/by-solution/automotive-products-and-solutions/audi/index.htm');
g_navNode_2_1_9_5=g_navNode_2_1_9.addNode('ncom_bus_sol_autopro_chr','Chrysler',ssUrlPrefix + 'for-business/by-solution/automotive-products-and-solutions/chrysler/index.htm');
g_navNode_2_1_9_6=g_navNode_2_1_9.addNode('ncom_bus_sol_autopro_for','Ford',ssUrlPrefix + 'for-business/by-solution/automotive-products-and-solutions/ford/index.htm');
g_navNode_2_1_10=g_navNode_2_1.addNode('ncom_busi_solu_dragon','Dragon Enterprise',ssUrlPrefix + 'for-business/by-solution/dragon-enterprise/index.htm');
g_navNode_2_1_11=g_navNode_2_1.addNode('ncom_bus_sol_cusvoi','Custom Voices',ssUrlPrefix + 'for-business/by-solution/custom-voices/index.htm','contributorOnly==FALSE');
g_navNode_2_1_12=g_navNode_2_1.addNode('ncom_bus_sol_safecom','SafeCom',ssUrlPrefix + 'for-business/by-solution/safecom/index.htm','contributorOnly==FALSE','searchDispDesc==SafeCom records all devices and print activity information down to individual jobs and users to help you optimize costs and print services. Learn more.');
g_navNode_2_1_12_0=g_navNode_2_1_12.addNode('ncom_bus_sol_sfcm_smapri','SafeCom Smart Printing',ssUrlPrefix + 'for-business/by-solution/safecom/safecome-smart-printing/index.htm');
g_navNode_2_1_12_1=g_navNode_2_1_12.addNode('ncom_bus_sol_sfcm_serv','SafeCom Server',ssUrlPrefix + 'for-business/by-solution/safecom/safecome-server/index.htm');
g_navNode_2_1_12_2=g_navNode_2_1_12.addNode('ncom_bu_so_sfcm_prt_trck','SafeCom Print Tracker',ssUrlPrefix + 'for-business/by-solution/safecom/safecom-print-tracker/index.htm');
g_navNode_2_1_12_3=g_navNode_2_1_12.addNode('ncom_bu_so_sfcm_sfcmgo','SafeCom Go',ssUrlPrefix + 'for-business/by-solution/safecom/safecom-go/index.htm');
g_navNode_2_1_12_4=g_navNode_2_1_12.addNode('ncom_bus_sol_safecom_suppt','Supported Devices',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/index.htm');
g_navNode_2_1_12_4_0=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_can','Canon',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/canon/index.htm');
g_navNode_2_1_12_4_1=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_fjxr','Fuji Xerox',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/fuji-xerox/index.htm');
g_navNode_2_1_12_4_2=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_nomin','Konica Minolta',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/minolta/index.htm');
g_navNode_2_1_12_4_3=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_kyoc','Kyocera',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/kyocera/index.htm');
g_navNode_2_1_12_4_4=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_lex','Lexmark',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/lexmark/index.htm');
g_navNode_2_1_12_4_5=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_oce','OCE',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/oce/index.htm');
g_navNode_2_1_12_4_6=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_rich','RICOH',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/ricoh/index.htm');
g_navNode_2_1_12_4_7=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_sam','Samsung',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/samsung/index.htm');
g_navNode_2_1_12_4_8=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_sharp','Sharp',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/sharp/index.htm');
g_navNode_2_1_12_4_9=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_xer','Xerox',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/xerox/index.htm');
g_navNode_2_1_12_4_10=g_navNode_2_1_12_4.addNode('ncom_bu_safecom_vendor_hpnew','HP',ssUrlPrefix + 'for-business/by-solution/safecom/supported-devices/hp/index.htm');
g_navNode_2_1_13=g_navNode_2_1.addNode('ncom_bus_sol_manprtser','Managed Print Services',ssUrlPrefix + 'for-business/by-solution/managed-print-services/index.htm','contributorOnly==FALSE');
g_navNode_2_1_13_0=g_navNode_2_1_13.addNode('ncom_bus_mps_wp','Download MPS Whitepaper',ssUrlPrefix + 'for-business/by-solution/managed-print-services/download-mps-whitepaper/index.htm');
g_navNode_2_1_13_1=g_navNode_2_1_13.addNode('ncom_bus_sol_capt_workflow','Capture and Workflow',ssUrlPrefix + 'for-business/by-solution/managed-print-services/capture-and-workflow/index.htm');
g_navNode_2_1_13_2=g_navNode_2_1_13.addNode('ncom_bus_sol_conv_workflow','Conversion and workflow',ssUrlPrefix + 'for-business/by-solution/managed-print-services/conversion-and-workflow/index.htm');
g_navNode_2_1_13_3=g_navNode_2_1_13.addNode('ncom_bus_sol_manpri_conus','Contact us',ssUrlPrefix + 'for-business/by-solution/managed-print-services/contact-us/index.htm');
g_navNode_2_1_15=g_navNode_2_1.addNode('ncom_bus_sol_dragon_smallbiz','Dragon for Small Business',ssUrlPrefix + 'for-business/by-solution/dragon-small-business/index.htm');
g_navNode_2_2=g_navNode_2.addNode('ncom_bus_byproduct','By Product',ssUrlPrefix + 'for-business/by-product/index.htm');
g_navNode_2_2_0=g_navNode_2_2.addNode('ncom_4bus_prod_powerpdf_res','Power PDF Resources',ssUrlPrefix + 'for-business/by-product/power-pdf-resources/index.htm');
g_navNode_2_2_2=g_navNode_2_2.addNode('ncom_busi_prod_xt9_t9','T9',ssUrlPrefix + 'for-business/by-product/t9/index.htm');
g_navNode_2_2_3=g_navNode_2_2.addNode('ncom_busi_pro_jott_v2ts','Voice Mail to Text Services',ssUrlPrefix + 'for-business/by-product/voice-mail-to-text-services/index.htm');
g_navNode_2_2_4=g_navNode_2_2.addNode('ncom_busi_prod_mobiapp_dragdci','Dragon Dictation\x3a iPhone',ssUrlPrefix + 'for-business/by-product/dragon-dictation-iphone/index.htm');
g_navNode_2_2_5=g_navNode_2_2.addNode('ncom_busi_prod_mobiapp_dragsea','Dragon Search\x3a iPhone',ssUrlPrefix + 'for-business/by-product/dragon-search-iphone/index.htm');
g_navNode_2_2_6=g_navNode_2_2.addNode('ncom_busi_prod_mobiapp_dragema','Dragon for Email\x3a Blackberry',ssUrlPrefix + 'for-business/by-product/dragon-for-email-blackberry/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_2_2_8=g_navNode_2_2.addNode('ncom_busi_produ_xt9_t9write','T9 Write',ssUrlPrefix + 'for-business/by-product/t9-write/index.htm');
g_navNode_2_2_10=g_navNode_2_2.addNode('ncom_busi_prod_xt9_vsuite','VSuite',ssUrlPrefix + 'for-business/by-product/vsuite/index.htm');
g_navNode_2_2_11=g_navNode_2_2.addNode('ncom_busi_prod_xt9_xt9','XT9',ssUrlPrefix + 'for-business/by-product/xt9/index.htm');
g_navNode_2_2_13=g_navNode_2_2.addNode('ncom_busi_solu_mobiapp_nvc','Nuance Voice Control',ssUrlPrefix + 'for-business/by-product/nuance-voice-control/index.htm');
g_navNode_2_2_14=g_navNode_2_2.addNode('ncom_bus_pro_dragon','Dragon',ssUrlPrefix + 'for-business/by-product/dragon/index.htm','RedirectTo==http\x3a//www.nuance.com/for-business/by-solution/dragon-enterprise/index.htm');
g_navNode_2_2_14_0=g_navNode_2_2_14.addNode('ncom_busi_prod_drag_smbu_FrMac','Dragon For Mac',ssUrlPrefix + 'for-business/by-product/dragon/for-mac/index.htm');
g_navNode_2_2_14_0_0=g_navNode_2_2_14_0.addNode('ncom_bus_sol_sm_mac_dictamedic','MacSpeech Dictate Medical',ssUrlPrefix + 'for-business/by-product/dragon/for-mac/macspeech-dictate-medical/index.htm');
g_navNode_2_2_14_0_1=g_navNode_2_2_14_0.addNode('ncom_bus_sol_sm_mac_dictalegal','MacSpeech Dictate Legal',ssUrlPrefix + 'for-business/by-product/dragon/for-mac/macspeech-dictate-legal/index.htm');
g_navNode_2_2_14_0_2=g_navNode_2_2_14_0.addNode('ncom_bus_sol_sm_mac_scribe','MacSpeech Scribe',ssUrlPrefix + 'for-business/by-product/dragon/for-mac/macspeech-scribe/index.htm');
g_navNode_2_2_14_0_3=g_navNode_2_2_14_0.addNode('ncom_bus_sol_sm_mac_dictate','Dragon Dictate',ssUrlPrefix + 'for-business/by-product/dragon/for-mac/dragon-dictate/index.htm');
g_navNode_2_2_14_1=g_navNode_2_2_14.addNode('ncom_busi_prod_drag_smalbus_pc','Dragon For the PC',ssUrlPrefix + 'for-business/by-product/dragon/dragon-for-the-pc/index.htm');
g_navNode_2_2_14_1_0=g_navNode_2_2_14_1.addNode('ncom_busi_prod_smabus_legversi','Dragon Legal ',ssUrlPrefix + 'for-business/by-product/dragon/dragon-for-the-pc/legal-edition/index.htm');
g_navNode_2_2_14_1_1=g_navNode_2_2_14_1.addNode('ncom_bus_solu_dra_sb_pc_proffe','Dragon Professional',ssUrlPrefix + 'for-business/by-product/dragon/dragon-for-the-pc/dragon-professional/index.htm');
g_navNode_2_2_14_1_2=g_navNode_2_2_14_1.addNode('ncom_bus_sol_dra_sb_pc_premium','Dragon Premium',ssUrlPrefix + 'for-business/by-product/dragon/dragon-for-the-pc/dragon-premium/index.htm');
g_navNode_2_2_14_1_3=g_navNode_2_2_14_1.addNode('ncom_bus_dra_pc_profgroup','Dragon Professional Group',ssUrlPrefix + 'for-business/by-product/dragon/dragon-for-the-pc/dragon-professional-group/index.htm');
g_navNode_2_2_14_1_4=g_navNode_2_2_14_1.addNode('ncom_bus_solu_dra_sb_pc_profin','Dragon Professional Individual',ssUrlPrefix + 'for-business/by-product/dragon/dragon-for-the-pc/dragon-professional-individual/index.htm');
g_navNode_2_2_14_1_5=g_navNode_2_2_14_1.addNode('ncom_busi_prod_dra_leggroup','Dragon Legal Group',ssUrlPrefix + 'for-business/by-product/dragon/dragon-for-the-pc/dragon-legal-group/index.htm');
g_navNode_2_2_14_1_6=g_navNode_2_2_14_1.addNode('ncom_bus_dra_sb_pc_legal_ind','Dragon Legal Individual',ssUrlPrefix + 'for-business/by-product/dragon/dragon-for-the-pc/dragon-legal-individual/index.htm');
g_navNode_2_2_14_2=g_navNode_2_2_14.addNode('ncom_bus_prod_smalbus_prodreso','Product Resources',ssUrlPrefix + 'for-business/by-product/dragon/product-resources/index.htm','RedirectTo==/dragon/index.htm');
g_navNode_2_2_14_2_0=g_navNode_2_2_14_2.addNode('ncom_prod_pc_cus_faq','Frequently Asked Questions',ssUrlPrefix + 'for-business/by-product/dragon/product-resources/frequently-asked-questions/index.htm');
g_navNode_2_2_14_2_1=g_navNode_2_2_14_2.addNode('ncom_bus_prod_drag_pc_prores_u','User Documentation',ssUrlPrefix + 'for-business/by-product/dragon/product-resources/user-documentation/index.htm','RedirectTo==/support/dragon-naturallyspeaking/');
g_navNode_2_2_14_2_2=g_navNode_2_2_14_2.addNode('ncom_bus_prod_dra_pc_prores_fe','Features and Demos',ssUrlPrefix + 'for-business/by-product/dragon/product-resources/features-and-demos/index.htm','RedirectTo==/for-individuals/by-product/dragon-for-pc/how-to-demos/');
g_navNode_2_2_14_2_3=g_navNode_2_2_14_2.addNode('ncom_bus_pro_dra_pc_prores_com','Edition Comparison',ssUrlPrefix + 'for-business/by-product/dragon/product-resources/edition-comparison/index.htm');
g_navNode_2_2_14_2_4=g_navNode_2_2_14_2.addNode('ncom_bus_pro_dra_prodreso_dawh','Datasheets and whitepapers',ssUrlPrefix + 'for-business/by-product/dragon/product-resources/datasheets-whitepapers/index.htm');
g_navNode_2_2_14_2_5=g_navNode_2_2_14_2.addNode('ncom_bus_pro_prodreso_sysrequi','System Requirements',ssUrlPrefix + 'for-business/by-product/dragon/product-resources/system-requirements/index.htm','RedirectTo==/dragon/index.htm');
g_navNode_2_2_14_2_6=g_navNode_2_2_14_2.addNode('ncom_bus_pro_dra_prodreso_what','What\'s New version 11',ssUrlPrefix + 'for-business/by-product/dragon/product-resources/whats-new-version-11/index.htm');
g_navNode_2_2_14_3=g_navNode_2_2_14.addNode('ncom_busi_prod_drag_anywhere','Dragon Anywhere',ssUrlPrefix + 'for-business/by-product/dragon/dragon-anywhere/index.htm','nonViewableCountries==AU,NZ');
g_navNode_2_2_14_3_0=g_navNode_2_2_14_3.addNode('ncom_busi_prod_drag_any_suppor','Support',ssUrlPrefix + 'for-business/by-product/dragon/dragon-anywhere/support/index.htm');
g_navNode_2_2_14_3_0_0=g_navNode_2_2_14_3_0.addNode('ncom_busi_prod_drag_any_sup_e','English',ssUrlPrefix + 'for-business/by-product/dragon/dragon-anywhere/support/english/index.htm');
g_navNode_2_2_14_3_1=g_navNode_2_2_14_3.addNode('ncom_busi_prod_drag_iOS','iOS',ssUrlPrefix + 'for-business/by-product/dragon/dragon-anywhere/iOS/index.htm');
g_navNode_2_2_14_3_1_0=g_navNode_2_2_14_3_1.addNode('ncom_busi_prod_drag_iOS_sup','Support',ssUrlPrefix + 'for-business/by-product/dragon/dragon-anywhere/iOS/support/index.htm');
g_navNode_2_2_14_3_1_0_0=g_navNode_2_2_14_3_1_0.addNode('ncom_busi_prod_drag_iOS_sup_e','English',ssUrlPrefix + 'for-business/by-product/dragon/dragon-anywhere/iOS/support/english/index.htm');
g_navNode_2_2_14_3_2=g_navNode_2_2_14_3.addNode('ncom_busi_prod_drag_any_demo','Feature Demos',ssUrlPrefix + 'for-business/by-product/dragon/dragon-anywhere/feature-demos/index.htm');
g_navNode_2_2_14_3_3=g_navNode_2_2_14_3.addNode('ncom_busi_prod_drag_any_blog','Blog',ssUrlPrefix + 'for-business/by-product/dragon/dragon-anywhere/blog/index.htm','secondaryUrlVariableField==Brick2','xmlQueryText==xDocSubType \x3cMATCHES\x3e \x60Dragon Blog\x60 \x3cand\x3e \x28dExtension \x3cMATCHES\x3e \x60doc\x60 \x3cor\x3e dExtension \x3cMATCHES\x3e \x60docx\x60\x29');
g_navNode_2_2_14_3_4=g_navNode_2_2_14_3.addNode('ncom_busi_prod_drag_ola','OLA',ssUrlPrefix + 'for-business/by-product/dragon/dragon-anywhere/ola/index.htm');
g_navNode_2_2_14_4=g_navNode_2_2_14.addNode('ncom_bus_prod_drag_anywheregrp','Dragon Anywhere Group',ssUrlPrefix + 'for-business/by-product/dragon/dragon-anywhere-group/index.htm');
g_navNode_2_2_16=g_navNode_2_2.addNode('ncom_bus_pro_ecopy','eCopy',ssUrlPrefix + 'for-business/by-product/ecopy/index.htm','searchDispDesc==Audrey\x3a eCopy delivers secure, streamlined records and document capture and collaboration workflows for your organization');
g_navNode_2_2_16_1=g_navNode_2_2_16.addNode('ncom_bus_pro_eco_ecocompsheet','eCopy Comparison Sheet',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-comparison-sheet/index.htm');
g_navNode_2_2_16_2=g_navNode_2_2_16.addNode('bus_prod_ecop_shasca_station','ScanStation v4',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-station-v4/index.htm','RedirectTo==http\x3a//www.nuance.com/for-business/by-product/ecopy/ecopy-comparison-sheet/index.htm');
g_navNode_2_2_16_2_0=g_navNode_2_2_16_2.addNode('ncom_bus_prd_ecy_scs_sss_htpf','How To Purchase Form',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-station-v4/how-to-purchase-form/index.htm');
g_navNode_2_2_16_2_1=g_navNode_2_2_16_2.addNode('ncom_bus_prd_ecy_ss_sss_radf','Request A Demo Form',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-station-v4/request-a-demo-form/index.htm');
g_navNode_2_2_16_4=g_navNode_2_2_16.addNode('ncom_bus_prod_ecop_ikon','IKON Power Pack',ssUrlPrefix + 'for-business/by-product/ecopy/ikon-power-pack/index.htm');
g_navNode_2_2_16_5=g_navNode_2_2_16.addNode('ncom_bus_pro_eco_shascanv5','eCopy ShareScan Suite v5',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-sharescan-suite-v5/index.htm');
g_navNode_2_2_16_5_0=g_navNode_2_2_16_5.addNode('ncom_bus_prd_ecy_ss_ss5_radfm','Request A Demo Form',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-sharescan-suite-v5/request-a-demo-form/index.htm');
g_navNode_2_2_16_6=g_navNode_2_2_16.addNode('bus_prod_ecop_shasca_suite','ShareScan Suite v4',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-suite/index.htm','searchDispDesc==With ShareScan Suite, you can use multifunction peripherals \x28MFPs\x29 or scanners for a wide range of secure document scanning processes with seamless integration into business applications that support automated workflows.');
g_navNode_2_2_16_6_0=g_navNode_2_2_16_6.addNode('ncom_bus_prd_ecy_ss_sss_htpf','How To Purchase Form',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-suite/how-to-purchase-form/index.htm');
g_navNode_2_2_16_6_1=g_navNode_2_2_16_6.addNode('ncom_bus_prd_ecy_ss_sss_radfm','Request A Demo Form',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-suite/request-a-demo-form/index.htm');
g_navNode_2_2_16_7=g_navNode_2_2_16.addNode('bus_prod_ecop_sharsca_sdk','ShareScan SDK',ssUrlPrefix + 'for-business/by-product/ecopy/ShareScanSDK/index.htm');
g_navNode_2_2_16_8=g_navNode_2_2_16.addNode('bus_prod_eco_shasca_essentials','ShareScan Essentials v4',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-essentials-v4/index.htm');
g_navNode_2_2_16_8_0=g_navNode_2_2_16_8.addNode('ncom_bus_prd_ecy_ss_sse_htpf','How To Purchase form',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-essentials-v4/how-to-purchase-form/index.htm');
g_navNode_2_2_16_8_1=g_navNode_2_2_16_8.addNode('ncom_bus_prd_ecy_ss_sse_radfm','Request A Demo Form',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-essentials-v4/request-a-demo-form/index.htm');
g_navNode_2_2_16_9=g_navNode_2_2_16.addNode('ncom_bus_prod_ecopy_conandext','eCopy Connectors and Extenders',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/index.htm');
g_navNode_2_2_16_9_0=g_navNode_2_2_16_9.addNode('ncom_bus_pr_ecpy_prctsrvflllst','Partner Connectors and Extenders',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/index.htm');
g_navNode_2_2_16_9_0_4=g_navNode_2_2_16_9_0.addNode('ncom_bus_pro_ecpy_capt_alclof','Captaris_Alchemy\x28Loffler\x29',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/captaris-alchemy-loffler/index.htm');
g_navNode_2_2_16_9_0_5=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_capalchgh','Captaris Alchemy \x28Highland\x29',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/captaris_alchemy-highland/index.htm');
g_navNode_2_2_16_9_0_6=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecopy_con_ciceron','CICERON',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/ciceron/index.htm');
g_navNode_2_2_16_9_0_7=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_clior_sib','CLIOR',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/clior-summation-iblaze/index.htm');
g_navNode_2_2_16_9_0_8=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_dtbd_epcs','DataBuilder_ePCS',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/databuilder_epcs/index.htm');
g_navNode_2_2_16_9_0_9=g_navNode_2_2_16_9_0.addNode('ncom_bus_prod_ecopy_digitalone','DigitalOne',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/digitalone/index.htm');
g_navNode_2_2_16_9_0_10=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecpy_con_copitrak','Copitrak',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/copitrak/index.htm');
g_navNode_2_2_16_9_0_11=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_ctsumiblz','CT Summation iBlaze',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/ct-summation-iblaze/index.htm');
g_navNode_2_2_16_9_0_12=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_digoneweb','DigitalOne WebCoding',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/digitalone-webcoding/index.htm');
g_navNode_2_2_16_9_0_13=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_docubase','Docubase',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/docubase/index.htm');
g_navNode_2_2_16_9_0_14=g_navNode_2_2_16_9_0.addNode('ncom_bus_prod_ecpy_con_docuged','DOCUGED',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/docuged/index.htm');
g_navNode_2_2_16_9_0_15=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_docloc','Document Locator',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/document-locator/index.htm');
g_navNode_2_2_16_9_0_16=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_docman','Document Manager',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/document-manager/index.htm');
g_navNode_2_2_16_9_0_17=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_docmnd','DOCUMIND',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/documind/index.htm');
g_navNode_2_2_16_9_0_18=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_docvrsl','Docuversal',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/docuversal/index.htm');
g_navNode_2_2_16_9_0_19=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_docware','DocuWare',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/docuware/index.htm');
g_navNode_2_2_16_9_0_20=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_esyent','Easy Enterprise',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/easy-enterprise/index.htm');
g_navNode_2_2_16_9_0_21=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_ebible','eBible',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/ebible/index.htm');
g_navNode_2_2_16_9_0_22=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_emasclfir','eMason  Clarifire',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/emason-clarifire/index.htm');
g_navNode_2_2_16_9_0_23=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_emccapina','EMC Captiva InputAccel',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/emc-captiva-input-accel/index.htm');
g_navNode_2_2_16_9_0_24=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_emcdocax','EMC Documentum AX',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/emc-documentum-ax/index.htm');
g_navNode_2_2_16_9_0_25=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_facsys','FACsys',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/facsys/index.htm');
g_navNode_2_2_16_9_0_26=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_faxcom','FAXCOM',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/faxcom/index.htm');
g_navNode_2_2_16_9_0_27=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_faxpress','FaxPress',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/faxpress/index.htm');
g_navNode_2_2_16_9_0_28=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_filedirec','FileDirector',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/filedirector/index.htm');
g_navNode_2_2_16_9_0_29=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_filemarsh','FileMarshal',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/filemarshal/index.htm');
g_navNode_2_2_16_9_0_30=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_fnetp8mgr','FileNet P8 ContentManager',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/filenet-p8-content-manager/index.htm');
g_navNode_2_2_16_9_0_31=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_formicfus','FormicFusion',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/formicfusion/index.htm');
g_navNode_2_2_16_9_0_32=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_fortis','Fortis',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/fortis/index.htm');
g_navNode_2_2_16_9_0_33=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_gedexprt','GED-Expert',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/ged-expert/index.htm');
g_navNode_2_2_16_9_0_34=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_genapi','GenApi',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/genapi/index.htm');
g_navNode_2_2_16_9_0_35=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_glbcmsrv','GlobalComServer',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/globalcomserver/index.htm');
g_navNode_2_2_16_9_0_36=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_heliaste','Heliaste',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/heliaste/index.htm');
g_navNode_2_2_16_9_0_37=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_hubimgcln','Hub-Image CleanUp',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/hub-image-cleanup/index.htm');
g_navNode_2_2_16_9_0_38=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_hubprint','HubPrint',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/hubprint/index.htm');
g_navNode_2_2_16_9_0_39=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_hylonbase','Hyland OnBase',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/hyland-onbase/index.htm');
g_navNode_2_2_16_9_0_40=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_hyperwave','Hyperwave',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/hyperwave/index.htm');
g_navNode_2_2_16_9_0_41=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_ibm_cntmr','IBM ContentManager',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/ibm-contentmanager/index.htm');
g_navNode_2_2_16_9_0_42=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_ibm_lddm','IBM LotusDominoDocumentManager',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/ibm-lotusdominodocumentmanager/index.htm');
g_navNode_2_2_16_9_0_43=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_imgnow','ImageNow',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/imagenow/index.htm');
g_navNode_2_2_16_9_0_44=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_immediacy','Immediacy',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/immediacy/index.htm');
g_navNode_2_2_16_9_0_45=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_interstar','Interstar',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/interstar/index.htm');
g_navNode_2_2_16_9_0_46=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_intwsmp','Interwoven Worksite MP',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/interwoven-worksite-mp/index.htm');
g_navNode_2_2_16_9_0_47=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_invu','INVU',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/invu/index.htm');
g_navNode_2_2_16_9_0_48=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_isenergy','ISynergy',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/isynergy/index.htm');
g_navNode_2_2_16_9_0_49=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_k2','K2 Workflow',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/k2/index.htm');
g_navNode_2_2_16_9_0_50=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_kofax','Kofax',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/kofax/index.htm');
g_navNode_2_2_16_9_0_51=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_lserfiche','Laserfiche',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/laserfiche/index.htm');
g_navNode_2_2_16_9_0_52=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_lexnis_ax','LexisNexis Axxia',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/lexisnexis-axxia/index.htm');
g_navNode_2_2_16_9_0_53=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_lexnis_tm','LexisNexis TimeMatters',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/lexisnexis-timematters/index.htm');
g_navNode_2_2_16_9_0_54=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_libnet','LibertyNET',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/libertynet/index.htm');
g_navNode_2_2_16_9_0_55=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_ldflcrt','Load File Creator',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/load-file-creator/index.htm');
g_navNode_2_2_16_9_0_56=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_logitoge','LOGITOGE',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/logitoge/index.htm');
g_navNode_2_2_16_9_0_57=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_micdynnav','Microsoft Dynamics NAV',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/microsoft-dynamics-nav/index.htm');
g_navNode_2_2_16_9_0_58=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_microgpln','Microsoft GreatPlains',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/microsoft-greatplains/index.htm');
g_navNode_2_2_16_9_0_59=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_novaxel','Novaxel',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/novaxel/index.htm');
g_navNode_2_2_16_9_0_60=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_ora_loflr','Oracle\x28loffler\x29',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/Oracle-loffler/index.htm');
g_navNode_2_2_16_9_0_61=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_orasftlnx','Oracle\x28Softlinx\x29',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/oracle-softlinx/index.htm');
g_navNode_2_2_16_9_0_62=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_qdtscan','QDirect.SCAN',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/qdirect.scan/index.htm');
g_navNode_2_2_16_9_0_63=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_questys','Questys',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/questys/index.htm');
g_navNode_2_2_16_9_0_64=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_remprnt','RemotePrinter',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/remoteprinter/index.htm');
if (SSContributor)
{
g_navNode_2_2_16_9_0_65=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_ricdocmal','Ricoh DocumentMall',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/ricoh-documentmail/index.htm','contributorOnly==TRUE');
}
if (SSContributor)
{
g_navNode_2_2_16_9_0_66=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_ricohecab','Ricoh eCabinet',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/ricoh-ecabinet/index.htm','contributorOnly==TRUE');
}
g_navNode_2_2_16_9_0_67=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_rimage','Rimage',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/rimage/index.htm');
g_navNode_2_2_16_9_0_68=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_r-kyv','R-KYV',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/r-kyv/index.htm');
g_navNode_2_2_16_9_0_69=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_safecom','Safecom',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/safecom/index.htm');
g_navNode_2_2_16_9_0_70=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_sge50acct','Sage50Accounts',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/sage50accounts/index.htm');
g_navNode_2_2_16_9_0_71=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_sge50act!','Sage50ACT\x21',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/sage50act\x21/index.htm');
g_navNode_2_2_16_9_0_72=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_sagecrm','SageCRM',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/sagecrm/index.htm');
g_navNode_2_2_16_9_0_73=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_sagel100','SageL100',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/sagel100/index.htm');
g_navNode_2_2_16_9_0_74=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_saperion','SAPERION',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/saperion/index.htm');
g_navNode_2_2_16_9_0_75=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_scanfile','ScanFile',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/scanfile/index.htm');
g_navNode_2_2_16_9_0_76=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_simplcap','SimpleCapture',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/simplecapture/index.htm');
g_navNode_2_2_16_9_0_77=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_sims.net','SIMS.net',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/sims.net/index.htm');
g_navNode_2_2_16_9_0_78=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_stpleware','StapleWare',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/stapleware/index.htm');
g_navNode_2_2_16_9_0_79=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_sureclse','SureClose',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/surecose/index.htm');
g_navNode_2_2_16_9_0_80=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_targtfax','TargetFax',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/targetfax/index.htm');
g_navNode_2_2_16_9_0_81=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_therefore','Therefore',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/therefore/index.htm');
g_navNode_2_2_16_9_0_82=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_unicon','UniConnect',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/uniconnect/index.htm');
g_navNode_2_2_16_9_0_83=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_w4bpm','W4BPM',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/w4bpm/index.htm');
g_navNode_2_2_16_9_0_84=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_windream','windream',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/windream/index.htm');
g_navNode_2_2_16_9_0_85=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_wrldlox','WORLDOX',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/worldox/index.htm');
g_navNode_2_2_16_9_0_86=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_xroxdocsh','Xerox DocuShare',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/xerox-docushare/index.htm');
g_navNode_2_2_16_9_0_87=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_xythos','Xythos',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/xythos/index.htm');
g_navNode_2_2_16_9_0_88=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_con_zetafax','ZetaFax',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/zetafax/index.htm');
g_navNode_2_2_16_9_0_90=g_navNode_2_2_16_9_0.addNode('ecom_bus_prd_ecy_conex_con_equ','Equitrac',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/equitrac/index.htm');
g_navNode_2_2_16_9_0_91=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_coxt_cn_nqueu','nQueue',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/nqueue/index.htm');
g_navNode_2_2_16_9_0_92=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_cnxt_con_zyim','ZyImage',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/zyimage/index.htm');
g_navNode_2_2_16_9_0_93=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_cne_ct_M64CDt','M\x26\x2338\x3b\x2364\x3bCDent',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/M64CDent/index.htm');
g_navNode_2_2_16_9_0_94=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecy_cne_cn_ibmln','IBM Lotus Notes',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/ibm-lotusnotes/index.htm');
g_navNode_2_2_16_9_0_96=g_navNode_2_2_16_9_0.addNode('ncom_bus_prd_ecopy_con_xmedius','XMediusDax-LightningFAX',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/XMediusDax-LightningFAX/index.htm');
g_navNode_2_2_16_9_0_97=g_navNode_2_2_16_9_0.addNode('ncom_bus_pr_ec_cnex_sale','Salesforce Connector',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/salesforce-connector/index.htm');
g_navNode_2_2_16_9_0_98=g_navNode_2_2_16_9_0.addNode('ncom_bu_pr_coex_par_goog','Google Docs Connector ',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/google-docs-connector/index.htm');
g_navNode_2_2_16_9_0_99=g_navNode_2_2_16_9_0.addNode('ncom_bu_pr_eco_con_gi_co','Open GI Connector ',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/open-gl-connector/index.htm');
g_navNode_2_2_16_9_0_111=g_navNode_2_2_16_9_0.addNode('ncom_bus_pr_ecpy_prcts_nexgen','Next Gen',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/partner-connectors-and-extenders/nextgen/index.htm');
g_navNode_2_2_16_9_1=g_navNode_2_2_16_9.addNode('ncom_bus_prod_ecopy_cne_nuadev','Nuance Developed',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/index.htm');
g_navNode_2_2_16_9_1_0=g_navNode_2_2_16_9_1.addNode('ncom_bus_prod_ecopy_extenders','Extenders',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/index.htm');
g_navNode_2_2_16_9_1_0_0=g_navNode_2_2_16_9_1_0.addNode('ncom_bus_prod_ecopy_xtndr','Barcode Recognition Extender',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/barcode-recognition-extender/index.htm');
g_navNode_2_2_16_9_1_0_1=g_navNode_2_2_16_9_1_0.addNode('ncom_bus_prd_ecopy_bates_xtndr','Bates Extender',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/bates-extender/index.htm');
g_navNode_2_2_16_9_1_0_2=g_navNode_2_2_16_9_1_0.addNode('ncom_bus_prd_ecopy_bizautosrvc','Business Automation Services',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/business-automation-services/index.htm');
g_navNode_2_2_16_9_1_0_2_0=g_navNode_2_2_16_9_1_0_2.addNode('n.com_bz_pd_ey_ce_nd_ex_bs_htp','How To Purchase Form',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/business-automation-services/how-to-purchase-form/index.htm');
g_navNode_2_2_16_9_1_0_3=g_navNode_2_2_16_9_1_0.addNode('bus_prd_ecopy_xtndr_imgenheext','Image Enhancement Extender',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/image-enhancement-extender/index.htm');
g_navNode_2_2_16_9_1_0_4=g_navNode_2_2_16_9_1_0.addNode('ncom_bus_prod_ecopy_ext_CAC','CAC Extender',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/cac-extender/index.htm');
g_navNode_2_2_16_9_1_0_5=g_navNode_2_2_16_9_1_0.addNode('ncom_bus_pord_ecopy_ext_formpr','Forms Processing Extender ',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/forms-processing-extender/index.htm');
g_navNode_2_2_16_9_1_0_6=g_navNode_2_2_16_9_1_0.addNode('ncom_bus_prod_ecpy_ext_highred','Highlight Redact Extender  ',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/highlight-redact-extender/index.htm');
g_navNode_2_2_16_9_1_0_7=g_navNode_2_2_16_9_1_0.addNode('ncom_bus_prd_ecy_ext_cstrec','Cost Recovery',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/costrecovery/index.htm');
g_navNode_2_2_16_9_1_0_7_0=g_navNode_2_2_16_9_1_0_7.addNode('ncom_bus_prod_ecopy_printaudit','PrintAudit',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/costrecovery/printaudit/index.htm');
g_navNode_2_2_16_9_1_0_7_1=g_navNode_2_2_16_9_1_0_7.addNode('ncom_bus_prod_ecopy_nqueue','NQueue',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/costrecovery/nqueue/index.htm');
g_navNode_2_2_16_9_1_0_7_2=g_navNode_2_2_16_9_1_0_7.addNode('ncom_bus_prod_pport_billback','Billback',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/costrecovery/billback/index.htm');
g_navNode_2_2_16_9_1_0_7_3=g_navNode_2_2_16_9_1_0_7.addNode('ncom_bus_prod_ecopy_copitrak','Copitrak',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/costrecovery/copitrak/index.htm');
g_navNode_2_2_16_9_1_0_7_4=g_navNode_2_2_16_9_1_0_7.addNode('ncom_bus_prod_ecopy_sepiaargos','SepialineArgos',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/costrecovery/sepialineargos/index.htm');
g_navNode_2_2_16_9_1_0_7_5=g_navNode_2_2_16_9_1_0_7.addNode('ncom_bus_prd_ecopy_equitrac','Equitrac',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/extenders/costrecovery/equitrac/index.htm');
g_navNode_2_2_16_9_1_1=g_navNode_2_2_16_9_1.addNode('ncom_bus_prod_ecopy_cne_nd_cn','Connectors',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/index.htm');
g_navNode_2_2_16_9_1_1_0=g_navNode_2_2_16_9_1_1.addNode('ncom_bus_prod_ecop_conn_qukcon','Quick Connect',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/quick-connect/index.htm');
g_navNode_2_2_16_9_1_1_1=g_navNode_2_2_16_9_1_1.addNode('ncombus_prod_ecop_conn_shptcon','SharePoint',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/sharepoint-connector/index.htm');
g_navNode_2_2_16_9_1_1_2=g_navNode_2_2_16_9_1_1.addNode('ncom_bus_prd_ecy_con_msft_exch','Microsoft Exchange',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/microsoft-exchange/index.htm');
g_navNode_2_2_16_9_1_1_3=g_navNode_2_2_16_9_1_1.addNode('ncom_bus_prod_ecop_conn_iwdocm','Canon iW Document Manager',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/iw-document-manager-extender/index.htm');
g_navNode_2_2_16_9_1_1_4=g_navNode_2_2_16_9_1_1.addNode('ncom_bus_prd_ecy_con_imgwrkste','IManage Worksite',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/imanage-worksite/index.htm');
g_navNode_2_2_16_9_1_1_5=g_navNode_2_2_16_9_1_1.addNode('ncom_bus_prd_ecy_con_openrfx','OpenText Document Management',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/opentext-rightfax/index.htm');
g_navNode_2_2_16_9_1_1_6=g_navNode_2_2_16_9_1_1.addNode('ncom_bus_prd_cxt_con_otlldm','Open Text Document Management, eDOCS Edition',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/opentext-livelinkecm-edocsdm/index.htm');
g_navNode_2_2_16_9_1_1_7=g_navNode_2_2_16_9_1_1.addNode('ncom_bus_prd_cne_con_ciw','Canon imageWARE',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/Canon-imageWARE/index.htm');
g_navNode_2_2_16_9_1_1_8=g_navNode_2_2_16_9_1_1.addNode('ncom_bus_prd_ecy_cne_con_emccs','EMC Documentum Content Server',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/emc-documentum-contentserver/index.htm');
g_navNode_2_2_16_9_1_1_9=g_navNode_2_2_16_9_1_1.addNode('ncom_bus_prd_ecy_cne_nd_cn_crf','Captaris Right Fax',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/captaris-rightfax/index.htm');
g_navNode_2_2_16_9_1_1_10=g_navNode_2_2_16_9_1_1.addNode('ncom_bu_pr_ec_coex_nd_sp','eCopy Connector for Microsoft\xae SharePoint, Server Edition',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/ecopy-connector-for-microsoft-sharepoint-server-edition/index.htm');
g_navNode_2_2_16_9_1_1_11=g_navNode_2_2_16_9_1_1.addNode('ncom_bu_pr_ec_coex_nd_sf','eCopy Connector for Salesforce',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/ecopy-connector-for-salesforce/index.htm');
g_navNode_2_2_16_9_1_1_12=g_navNode_2_2_16_9_1_1.addNode('ncom_bu_pr_ec_coex_nd_hp','eCopy Connector for HP TRIM',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/ecopy-connector-for-hp-trim/index.htm');
g_navNode_2_2_16_9_1_1_13=g_navNode_2_2_16_9_1_1.addNode('ncom_bu_pr_ec_coex_nd_sa','eCopy Connector for Sage 50 Accounts',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/ecopy-connector-for-sage-50-accounts/index.htm');
g_navNode_2_2_16_9_1_1_14=g_navNode_2_2_16_9_1_1.addNode('ncom_bu_pr_ec_coex_nd_ac','eCopy Connector for Sage ACT\x21',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/esopy-connector-for-sage-act/index.htm');
g_navNode_2_2_16_9_1_1_15=g_navNode_2_2_16_9_1_1.addNode('ncom_bu_pr_ec_coex_nd_xr','eCopy Connector for Xerox DocuShare',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-connectors-and-extenders/nuance-developed/connectors/ecopy-connector-for-xerox-docushare/index.htm');
g_navNode_2_2_16_10=g_navNode_2_2_16.addNode('ncom_bus_prd_ey_ey_pdf_pro_of','eCopy PDF Pro Office',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-pdf-pro-office/index.htm');
g_navNode_2_2_16_10_0=g_navNode_2_2_16_10.addNode('ncom_bs_pr_eco_prooff_ev','Download eCopy PDF Pro Office',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-pdf-pro-office/download-ecopy-pdf-pro-office/index.htm');
g_navNode_2_2_16_10_1=g_navNode_2_2_16_10.addNode('ncom_bus_prd_ey_eppo_demo-vid','View Demo Videos',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-pdf-pro-office/demo-videos/index.htm');
g_navNode_2_2_16_11=g_navNode_2_2_16.addNode('ncom_bus_pro_eco_ecossv5','eCopy ScanStation v5',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-scanstation-v5/index.htm');
g_navNode_2_2_16_12=g_navNode_2_2_16.addNode('ncom_bus_pro_eco_sselement','eCopy ShareScan Element v5',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-sharescan-element-v5/index.htm');
g_navNode_2_2_16_13=g_navNode_2_2_16.addNode('ncom_bus_pro_eco_shascav5','eCopy ShareScan Office v5',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-sharescan-office-v5/index.htm');
g_navNode_2_2_16_14=g_navNode_2_2_16.addNode('ncom_bus_pro_eco_sharscanv5','eCopy SharScan v5',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-sharescan-v5/index.htm');
g_navNode_2_2_16_15=g_navNode_2_2_16.addNode('ncom_bus_pro_ecopy_sharescanv5','ShareScan v5',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-v5/index.htm');
g_navNode_2_2_16_16=g_navNode_2_2_16.addNode('ncom_bus_prod_eco_csdkev','CSDK Evaluation',ssUrlPrefix + 'for-business/by-product/ecopy/csdk-evaluation/index.htm');
g_navNode_2_2_16_17=g_navNode_2_2_16.addNode('ncom_bus_pro_eco_ctus','General ContactUs',ssUrlPrefix + 'for-business/by-product/ecopy/contact-us/index.htm');
g_navNode_2_2_16_18=g_navNode_2_2_16.addNode('ncom_bus_pr_ec_shsc_cont','ShareScan Contact Us',ssUrlPrefix + 'for-business/by-product/ecopy/sharescan-contact-us/index.htm');
g_navNode_2_2_16_19=g_navNode_2_2_16.addNode('ncom_bus_pro_ec_ppo_cont','eCopy PDF Pro Office Contact Us',ssUrlPrefix + 'for-business/by-product/ecopy/ecopy-pdf-pro-office-contact-us/index.htm');
if (SSContributor)
{
g_navNode_2_2_17=g_navNode_2_2.addNode('ncom_bus_pro_mobspeech','Nuance Mobile Speech',ssUrlPrefix + 'for-business/by-product/nuance-mobile-speech/index.htm','contributorOnly==TRUE');
}
if (SSContributor)
{
g_navNode_2_2_18=g_navNode_2_2.addNode('ncom_bus_pro_opintframe','Nuance Open Interface Framework',ssUrlPrefix + 'for-business/by-product/nuance-open-interface-framework/index.htm','contributorOnly==TRUE');
}
if (SSContributor)
{
g_navNode_2_2_19=g_navNode_2_2.addNode('ncom_bus_pro_voicemode','Nuance VoiceMode',ssUrlPrefix + 'for-business/by-product/voice-mode/index.htm','contributorOnly==TRUE');
}
g_navNode_2_2_20=g_navNode_2_2.addNode('ncom_bus_pro_vsuite','Nuance VSuite',ssUrlPrefix + 'for-business/by-product/vsuite/index.htm');
g_navNode_2_2_21=g_navNode_2_2.addNode('ncom_bus_pro_omnipage','OmniPage',ssUrlPrefix + 'for-business/by-product/omnipage/index.htm');
g_navNode_2_2_21_0=g_navNode_2_2_21.addNode('ncom_bu_pr_eco_con_n_con','Nuance Cloud Connector',ssUrlPrefix + 'for-business/by-product/omnipage/nuance-cloud-connector/index.htm');
g_navNode_2_2_21_1=g_navNode_2_2_21.addNode('4','digitalriver',ssUrlPrefix + 'for-business/by-product/omnipage/digitalriver/index.htm','searchDispDesc==Don\u2019t convert those documents, transform them using OmniPage Professional.');
g_navNode_2_2_21_2=g_navNode_2_2_21.addNode('ncom_bus_prod_omnipage_csdk','csdk',ssUrlPrefix + 'for-business/by-product/omnipage/csdk/index.htm');
g_navNode_2_2_21_6=g_navNode_2_2_21.addNode('ncom_bus_prod_omnipage_standrd','standard',ssUrlPrefix + 'for-business/by-product/omnipage/standard/index.htm');
g_navNode_2_2_21_7=g_navNode_2_2_21.addNode('ncom_bus_prod_omnipage_upgrade','upgrade',ssUrlPrefix + 'for-business/by-product/omnipage/upgrade/index.htm');
g_navNode_2_2_21_8=g_navNode_2_2_21.addNode('ncom_bus_pro_omni_testim','Testimonials',ssUrlPrefix + 'for-business/by-product/omnipage/testimonials/index.htm');
g_navNode_2_2_21_8_0=g_navNode_2_2_21_8.addNode('ncom_bus_pro_omn_test_su','Submit a review',ssUrlPrefix + 'for-business/by-product/omnipage/testimonials/submit-review/index.htm');
g_navNode_2_2_21_9=g_navNode_2_2_21.addNode('ncom_bus_prod_omni_feedb','Feedback Form',ssUrlPrefix + 'for-business/by-product/omnipage/feedback-form/index.htm');
g_navNode_2_2_21_10=g_navNode_2_2_21.addNode('ncom_bu_pro_omi_ompaupgr','Omnipage Upgrade',ssUrlPrefix + 'for-business/by-product/omnipage/OmnipageUpgrade/index.htm');
g_navNode_2_2_21_11=g_navNode_2_2_21.addNode('ncom_bus_prod_omni_clsvs','Omnipage Cloud Services',ssUrlPrefix + 'for-business/by-product/omnipage/omnipage-cloud-services/index.htm');
g_navNode_2_2_21_12=g_navNode_2_2_21.addNode('ncom_bus_pro_omni_contact','Contact Us',ssUrlPrefix + 'for-business/by-product/omnipage/contact-us/index.htm');
g_navNode_2_2_21_13=g_navNode_2_2_21.addNode('ncom_bu_pr_om_ompgeval','Omnipage Evaluation',ssUrlPrefix + 'for-business/by-product/omnipage/omnipage-evaluation/index.htm');
g_navNode_2_2_21_14=g_navNode_2_2_21.addNode('ncom_bus_pro_omni_oedo','OEM Downloads',ssUrlPrefix + 'for-business/by-product/omnipage/oem-downloads/index.htm');
g_navNode_2_2_21_15=g_navNode_2_2_21.addNode('ncom_bus_pro_omni_ultim','Ultimate',ssUrlPrefix + 'for-business/by-product/omnipage/ultimate/index.htm');
g_navNode_2_2_21_15_0=g_navNode_2_2_21_15.addNode('ncom_bus_prod_opult-trial','Trial version',ssUrlPrefix + 'for-business/by-product/omnipage/ultimate/trial-version/index.htm');
g_navNode_2_2_21_16=g_navNode_2_2_21.addNode('ncom_bus_prod_omnipage_fordev','For Developers',ssUrlPrefix + 'for-business/by-product/omnipage/for-developers/index.htm');
g_navNode_2_2_21_16_0=g_navNode_2_2_21_16.addNode('ncom_bus_prod_omnipage_csdkwin','CSDK for Windows',ssUrlPrefix + 'for-business/by-product/omnipage/for-developers/csdk-for-windows/index.htm');
g_navNode_2_2_21_16_1=g_navNode_2_2_21_16.addNode('ncom_bus_prod_omnipage_csdklin','CSDK for Linus',ssUrlPrefix + 'for-business/by-product/omnipage/for-developers/csdk-for-linux/index.htm');
g_navNode_2_2_21_16_2=g_navNode_2_2_21_16.addNode('ncom_bus_prod_omnipage_csdkmac','CSDK for Mac',ssUrlPrefix + 'for-business/by-product/omnipage/for-developers/csdk-for-mac/index.htm');
g_navNode_2_2_21_16_3=g_navNode_2_2_21_16.addNode('ncom_bus_prod_omnipage_server','Server for Developers',ssUrlPrefix + 'for-business/by-product/omnipage/for-developers/server-for-developers/index.htm');
g_navNode_2_2_21_16_4=g_navNode_2_2_21_16.addNode('ncom_bus_prod_omnipage_serverb','Server for Business',ssUrlPrefix + 'for-business/by-product/omnipage/for-developers/server-for-business/index.htm');
g_navNode_2_2_22=g_navNode_2_2.addNode('ncom_bus_pro_paperport','PaperPort',ssUrlPrefix + 'for-business/by-product/paperport/index.htm');
g_navNode_2_2_22_0=g_navNode_2_2_22.addNode('ncom_bus_prod_pport_enterprise','enterprise',ssUrlPrefix + 'for-business/by-product/paperport/enterprise/index.htm');
g_navNode_2_2_22_1=g_navNode_2_2_22.addNode('ncom_bus_prod_pport_kofax','kofax',ssUrlPrefix + 'for-business/by-product/paperport/kofax/index.htm');
g_navNode_2_2_22_2=g_navNode_2_2_22.addNode('ncom_bus_prod_pport_odma','odma',ssUrlPrefix + 'for-business/by-product/paperport/odma/index.htm');
g_navNode_2_2_22_3=g_navNode_2_2_22.addNode('ncom_bus_prod_pport_webdav','webdav',ssUrlPrefix + 'for-business/by-product/paperport/webdav/index.htm');
g_navNode_2_2_22_4=g_navNode_2_2_22.addNode('ncom_bus_prod_pport_yousendit','yousendit',ssUrlPrefix + 'for-business/by-product/paperport/yousendit/index.htm');
g_navNode_2_2_22_5=g_navNode_2_2_22.addNode('ncom_bus_prod_pport_pro','professional',ssUrlPrefix + 'for-business/by-product/paperport/professional/index.htm');
g_navNode_2_2_22_6=g_navNode_2_2_22.addNode('ncom_bus_prod_pport_standrd','standard',ssUrlPrefix + 'for-business/by-product/paperport/standard/index.htm');
g_navNode_2_2_22_7=g_navNode_2_2_22.addNode('ncom_bus_prod_pport_upgrade','upgrade',ssUrlPrefix + 'for-business/by-product/paperport/upgrade/index.htm');
g_navNode_2_2_22_8=g_navNode_2_2_22.addNode('ncom_bus_prod_ppt_pporttlinks','PaperPort Links',ssUrlPrefix + 'for-business/by-product/paperport/paperport-links/index.htm');
g_navNode_2_2_24=g_navNode_2_2.addNode('ncom_bus_pro_speechatt','SpeechAttendant',ssUrlPrefix + 'for-business/by-product/speech-attendant/index.htm');
g_navNode_2_2_25=g_navNode_2_2.addNode('ncom_busi_prod_auto_busi_portf','Automotive Products and Services',ssUrlPrefix + 'for-business/by-product/automotive-products-services/index.htm','RedirectTo==http\x3a//www.nuance.com/for-business/mobile-solutions/dragon-drive/index.htm');
g_navNode_2_2_25_0=g_navNode_2_2_25.addNode('ncom_bus_pro_voconhybrid','VoCon Hybrid',ssUrlPrefix + 'for-business/by-product/automotive-products-services/vocon-hybrid/index.htm');
g_navNode_2_2_25_1=g_navNode_2_2_25.addNode('ncom_busi_prod_autobusport_pro','Professionial Services',ssUrlPrefix + 'for-business/by-product/automotive-products-services/professionial-services/index.htm');
g_navNode_2_2_25_2=g_navNode_2_2_25.addNode('ncom_busi_prod_autobusport_t9','T9',ssUrlPrefix + 'for-business/by-product/automotive-products-services/t9/index.htm');
g_navNode_2_2_25_3=g_navNode_2_2_25.addNode('ncom_busi_prod_autobusport_voc','Vocalizer for Automotive',ssUrlPrefix + 'for-business/by-product/automotive-products-services/vocalizer-for-automotive/index.htm','RedirectTo==/for-business/by-product/vocalizer-for-embedded/index.htm');
if (SSContributor)
{
g_navNode_2_2_25_4=g_navNode_2_2_25.addNode('ncom_bus_prod_autbuspor_vocon3','VoCon 3200',ssUrlPrefix + 'for-business/by-product/automotive-products-services/vocon3200/index.htm','RedirectTo==/for-business/by-product/automotive-products-services/vocon-hybrid/index.htm','contributorOnly==TRUE');
}
g_navNode_2_2_25_5=g_navNode_2_2_25.addNode('ncom_bus_prod_autbuspor_vconss','VoCon 3200 SSE',ssUrlPrefix + 'for-business/by-product/automotive-products-services/vocon-3200-sse/index.htm');
g_navNode_2_2_26=g_navNode_2_2.addNode('ncom_bus_prod_scan2pc','Xerox Scan to PC',ssUrlPrefix + 'for-business/by-product/xerox-scan2pc/index.htm');
g_navNode_2_2_26_0=g_navNode_2_2_26.addNode('ncom_bus_prod_xeroxscan2pc_edu','Education',ssUrlPrefix + 'for-business/by-product/xerox-scan2pc/education/index.htm');
g_navNode_2_2_26_1=g_navNode_2_2_26.addNode('ncom_bus_prod_xeroxscan2pc_gov','Government',ssUrlPrefix + 'for-business/by-product/xerox-scan2pc/government/index.htm');
g_navNode_2_2_26_2=g_navNode_2_2_26.addNode('ncom_bus_prod_xeroxscan2pc_lgl','Legal',ssUrlPrefix + 'for-business/by-product/xerox-scan2pc/legal/index.htm');
g_navNode_2_2_26_3=g_navNode_2_2_26.addNode('ncom_bus_prd_xeroxstpc','Xerox Scan To PC',ssUrlPrefix + 'for-business/by-product/xerox-scan2pc/xerox-scan-to-pc/index.htm');
g_navNode_2_2_26_4=g_navNode_2_2_26.addNode('ncom_bus_prd_scantopcdeskuniv','Scan to PC Desktop University',ssUrlPrefix + 'for-business/by-product/xerox-scan2pc/scan-to-pc-desktop-university/index.htm');
g_navNode_2_2_27=g_navNode_2_2.addNode('ncom_bus_prod_paperportpsp','PaperPort PSP',ssUrlPrefix + 'for-business/by-product/paperportpsp/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_2_2_27_0=g_navNode_2_2_27.addNode('ncom_bus_prd_ppt_psphpordrinfo','psp hp order info',ssUrlPrefix + 'for-business/by-product/paperportpsp/psp-hp-orderinfo/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_2_2_27_1=g_navNode_2_2_27.addNode('ncom_bus_prod_pport_psp-hp','psp-hp',ssUrlPrefix + 'for-business/by-product/paperportpsp/psp-hp/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_2_2_29=g_navNode_2_2.addNode('ncom_bus_prod_downcsdkwe','Download CSDK Webinar',ssUrlPrefix + 'for-business/by-product/download-csdk-webinar/index.htm','contributorOnly==FALSE','nonViewableCountries==ENUK,DE,FR');
g_navNode_2_2_30=g_navNode_2_2.addNode('ncom_bus_prod_officewhit','Office Copiers Pay for themselves - Whitepaper',ssUrlPrefix + 'for-business/by-product/office-copiers-pay-for-themselves-whitepaper/index.htm');
g_navNode_2_2_33=g_navNode_2_2.addNode('ncom_bus_prod_equitrac','Equitrac',ssUrlPrefix + 'for-business/by-product/equitrac/index.htm');
g_navNode_2_2_33_1=g_navNode_2_2_33.addNode('ncom_bus_prod_equi_prof','Equitrac Professional',ssUrlPrefix + 'for-business/by-product/equitrac/equitrac-professional/index.htm');
g_navNode_2_2_33_3=g_navNode_2_2_33.addNode('ncom_bus_prod_eq_eqtpt','Equitrac TouchPoint Console',ssUrlPrefix + 'for-business/by-product/equitrac/equitrac-touchpoint-console/index.htm');
g_navNode_2_2_33_4=g_navNode_2_2_33.addNode('ncom_bus_pro_equ_contact','Contact Us',ssUrlPrefix + 'for-business/by-product/equitrac/contact-us/index.htm');
g_navNode_2_2_33_5=g_navNode_2_2_33.addNode('ncom_bus_pro_equi_supdev','Supported Devices',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/index.htm');
g_navNode_2_2_33_5_0=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_can','Canon',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/canon/index.htm');
g_navNode_2_2_33_5_1=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_del','Dell',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/dell/index.htm');
g_navNode_2_2_33_5_2=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_fjxr','Fuji Xerox',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/fuji-xerox/index.htm');
g_navNode_2_2_33_5_3=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_hp','HP',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/hp/index.htm');
g_navNode_2_2_33_5_4=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_nomin','Konica Minolta',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/konica-minolta/index.htm');
g_navNode_2_2_33_5_5=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_kyoc','Kyocera',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/kyocera/index.htm');
g_navNode_2_2_33_5_6=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_lex','Lexmark',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/Lexmark/index.htm');
g_navNode_2_2_33_5_7=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_oce','OCE',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/oce/index.htm');
g_navNode_2_2_33_5_8=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_rich','Ricoh',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/ricoh/index.htm');
g_navNode_2_2_33_5_9=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_sam','Samsung',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/samsung/index.htm');
g_navNode_2_2_33_5_10=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_shar','Sharp',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/sharp/index.htm');
g_navNode_2_2_33_5_11=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_xer','Xerox',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/xerox/index.htm');
g_navNode_2_2_33_5_12=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_triumph','Triumph Adler',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/triumph-adler/index.htm');
g_navNode_2_2_33_5_13=g_navNode_2_2_33_5.addNode('ncom_bu_pro_eq_spdv_utax','UTAX',ssUrlPrefix + 'for-business/by-product/equitrac/supported-devices/utax/index.htm');
g_navNode_2_2_33_6=g_navNode_2_2_33.addNode('ncom_bu_pro_equ_supp','Support',ssUrlPrefix + 'for-business/by-product/equitrac/support/index.htm');
g_navNode_2_2_33_7=g_navNode_2_2_33.addNode('ncom_bu_pro_equ_impser','Implementation Services',ssUrlPrefix + 'for-business/by-product/equitrac/implementation-services/index.htm');
g_navNode_2_2_33_8=g_navNode_2_2_33.addNode('74','Product Registration',ssUrlPrefix + 'for-business/by-product/equitrac/product-registration/index.htm');
g_navNode_2_2_33_9=g_navNode_2_2_33.addNode('ncom_bu_pro_equ_supser','Support Services',ssUrlPrefix + 'for-business/by-product/equitrac/support-services/index.htm');
g_navNode_2_2_33_10=g_navNode_2_2_33.addNode('ncom_bu_pro_equ_contsup','Contact Support',ssUrlPrefix + 'for-business/by-product/equitrac/contact-support/index.htm');
if (SSContributor)
{
g_navNode_2_2_33_11=g_navNode_2_2_33.addNode('ncom_bu_pro_equ_cardreader','Supported Card Readers',ssUrlPrefix + 'for-business/by-product/equitrac/supported-card-readers/index.htm','contributorOnly==TRUE');
}
g_navNode_2_2_33_12=g_navNode_2_2_33.addNode('ncom_bu_pro_equ_becomepartner','Become a Partner',ssUrlPrefix + 'for-business/by-product/equitrac/become-a-partner/index.htm');
g_navNode_2_2_33_13=g_navNode_2_2_33.addNode('ncom_bu_pro_equ_hardware_softw','Hardware Software',ssUrlPrefix + 'for-business/by-product/equitrac/hardware-software/index.htm');
g_navNode_2_2_33_14=g_navNode_2_2_33.addNode('ncom_bu_pro_equ_contoffice','Contact Office',ssUrlPrefix + 'for-business/by-product/equitrac/contact-office/index.htm');
g_navNode_2_2_34=g_navNode_2_2.addNode('ncom_bus_pro_vocfembedde','Vocalizer Expressive',ssUrlPrefix + 'for-business/by-product/vocalizer-for-embedded/index.htm');
g_navNode_2_2_35=g_navNode_2_2.addNode('ncom_bus_prod_copitrak','Copitrak',ssUrlPrefix + 'for-business/by-product/copitrak/index.htm');
g_navNode_2_2_36=g_navNode_2_2.addNode('ncom_bus_pro_copsyssoft','Copitrak System Software',ssUrlPrefix + 'for-business/by-product/copitrak-system-software/index.htm');
g_navNode_2_2_37=g_navNode_2_2.addNode('ncom_bus_pro_costreco','Cost Recovery',ssUrlPrefix + 'for-business/by-product/cost-recovery/index.htm');
g_navNode_2_2_38=g_navNode_2_2.addNode('ncom_bus_prod_copitrak_modules','Additional Copitrak Solutions and Modules',ssUrlPrefix + 'for-business/by-product/copitrak-modules/index.htm');
g_navNode_2_2_39=g_navNode_2_2.addNode('ncom_bus_prod_doccapture','DocCapture',ssUrlPrefix + 'for-business/by-product/doccapture/index.htm','searchDispDesc==Learn how Nuance\x26rsquo\x3bs solutions are tailor-made for your industry \x26ndash\x3b and made to solve your toughest document management and workflow challenges.');
g_navNode_2_2_40=g_navNode_2_2.addNode('ncom_bus_pdf_doc_conversion','PDF and document conversion',ssUrlPrefix + 'for-business/by-product/pdf-document-conversion/index.htm');
g_navNode_2_5=g_navNode_2.addNode('ncom_engageus','Engage us',ssUrlPrefix + 'for-business/engage_us/index.htm');
g_navNode_2_6=g_navNode_2.addNode('ncom_bus_mobilesolutions','Mobile Solutions',ssUrlPrefix + 'for-business/mobile-solutions/index.htm');
g_navNode_2_6_0=g_navNode_2_6.addNode('ncom_prod_dragtv','Dragon TV',ssUrlPrefix + 'for-business/mobile-solutions/dragon-tv/index.htm','contributorOnly==FALSE');
g_navNode_2_6_1=g_navNode_2_6.addNode('ncom_bus_pro_aut_dragond','Dragon Drive',ssUrlPrefix + 'for-business/mobile-solutions/dragon-drive/index.htm');
g_navNode_2_6_1_0=g_navNode_2_6_1.addNode('ncom_bu_pr_aus_drdr_lerm','Dragon Drive Learn More',ssUrlPrefix + 'for-business/mobile-solutions/dragon-drive/dragon-drive-learn-more/index.htm');
g_navNode_2_6_1_1=g_navNode_2_6_1.addNode('ncom_bus_mobilesol_dd_related','Related Products',ssUrlPrefix + 'for-business/mobile-solutions/dragon-drive/related-products/index.htm');
g_navNode_2_6_2=g_navNode_2_6.addNode('ncom_bus_mobilesol_text_input','Text Input Solutions',ssUrlPrefix + 'for-business/mobile-solutions/text-input-solutions/index.htm');
g_navNode_2_6_3=g_navNode_2_6.addNode('ncom_bus_mobilesol_v_to_t','Voice to Text',ssUrlPrefix + 'for-business/mobile-solutions/voice-to-text-services/index.htm');
g_navNode_2_6_4=g_navNode_2_6.addNode('ncom_bus_mobilesol_oem-toolkit','OEM Toolkit',ssUrlPrefix + 'for-business/mobile-solutions/oem-toolkit/index.htm');
g_navNode_2_6_5=g_navNode_2_6.addNode('ncom_bus_mobilesol_vocaexpress','Vocalizer Expressive',ssUrlPrefix + 'for-business/mobile-solutions/vocalizer-expressive/index.htm');
g_navNode_2_6_6=g_navNode_2_6.addNode('ncom_bus_mobilesol_subscriber','Mobile Operator Services',ssUrlPrefix + 'for-business/mobile-solutions/mobile-operator-services/index.htm');
g_navNode_2_7=g_navNode_2.addNode('ncom_bus_custservice','Customer Service Solutions',ssUrlPrefix + 'for-business/customer-service-solutions/index.htm');
g_navNode_2_7_0=g_navNode_2_7.addNode('ncom_bus_custserv_profs_cloudd','Cloud Dialer',ssUrlPrefix + 'for-business/customer-service-solutions/cloud-dialer/index.htm');
g_navNode_2_7_1=g_navNode_2_7.addNode('ncom_bus_custserv_connectconv','Connected conversation',ssUrlPrefix + 'for-business/customer-service-solutions/multichannel-conversations/index.htm');
g_navNode_2_7_2=g_navNode_2_7.addNode('ncom_bus_custserv_inboundivr','Conversational IVR',ssUrlPrefix + 'for-business/customer-service-solutions/conversational-ivr/index.htm');
g_navNode_2_7_2_0=g_navNode_2_7_2.addNode('ncom_bus_custserv_ivr_infograp','Top Customer IVR Headaches Infographics',ssUrlPrefix + 'for-business/customer-service-solutions/conversational-ivr/top-customer-ivr-headaches/index.htm');
g_navNode_2_7_3=g_navNode_2_7.addNode('ncom_bus_custserv_custexperien','Customer Experience',ssUrlPrefix + 'for-business/customer-service-solutions/customer-experience/index.htm');
g_navNode_2_7_4=g_navNode_2_7.addNode('ncom_bus_custserv_coretech','Core Technologies',ssUrlPrefix + 'for-business/customer-service-solutions/speech-technology/index.htm');
g_navNode_2_7_5=g_navNode_2_7.addNode('ncom_bus_custserv_engagesol','Engagement Solutions',ssUrlPrefix + 'for-business/customer-service-solutions/customer-engagement-solutions/index.htm');
g_navNode_2_7_6=g_navNode_2_7.addNode('ncom_bus_custserv_financialser','Financial Services',ssUrlPrefix + 'for-business/customer-service-solutions/banking-mortgage-insurance/index.htm');
g_navNode_2_7_7=g_navNode_2_7.addNode('ncom_bus_custserv_gov','Government',ssUrlPrefix + 'for-business/customer-service-solutions/government/index.htm');
g_navNode_2_7_8=g_navNode_2_7.addNode('ncom_bus_custserv_healthcare','Healthcare',ssUrlPrefix + 'for-business/customer-service-solutions/healthcare/index.htm');
g_navNode_2_7_9=g_navNode_2_7.addNode('ncom_bus_custserv_hostedplatfo','Hosted Platform',ssUrlPrefix + 'for-business/customer-service-solutions/hosted-contact-center-solutions/index.htm');
g_navNode_2_7_10=g_navNode_2_7.addNode('ncom_bus_custserv_industsol','Industry Expertise',ssUrlPrefix + 'for-business/customer-service-solutions/customer-interaction-solutions/index.htm');
g_navNode_2_7_11=g_navNode_2_7.addNode('ncom_bus_custserv_loquendo','Loquendo Small Business Bundle',ssUrlPrefix + 'for-business/customer-service-solutions/loquendo-small-business-bundle/index.htm');
g_navNode_2_7_12=g_navNode_2_7.addNode('ncom_bus_custserv_outboundivr','Proactive Engagement Solutions',ssUrlPrefix + 'for-business/customer-service-solutions/proactive-engagement/index.htm');
g_navNode_2_7_12_0=g_navNode_2_7_12.addNode('ncom_bus_custserv_reminder_inf','Reminders Matter Inforgraphic',ssUrlPrefix + 'for-business/customer-service-solutions/proactive-engagement/reminders-matter-infographic/index.htm');
g_navNode_2_7_13=g_navNode_2_7.addNode('ncom_bus_custserv_profservices','Professional Services',ssUrlPrefix + 'for-business/customer-service-solutions/professional-services/index.htm');
g_navNode_2_7_13_0=g_navNode_2_7_13.addNode('ncom_bus_custserv_profs_manage','Managed Services',ssUrlPrefix + 'for-business/customer-service-solutions/professional-services/contact-center-services/index.htm');
g_navNode_2_7_13_1=g_navNode_2_7_13.addNode('ncom_bus_custserv_profs_bizcon','Business Consulting',ssUrlPrefix + 'for-business/customer-service-solutions/professional-services/business-consulting/index.htm');
g_navNode_2_7_13_2=g_navNode_2_7_13.addNode('ncom_bus_custserv_profs_packag','Packaged Applications',ssUrlPrefix + 'for-business/customer-service-solutions/professional-services/packaged-applications/index.htm');
g_navNode_2_7_13_3=g_navNode_2_7_13.addNode('ncom_bus_custserv_profs_userex','User Experience',ssUrlPrefix + 'for-business/customer-service-solutions/professional-services/contact-center-customer-solutions/index.htm');
g_navNode_2_7_13_4=g_navNode_2_7_13.addNode('ncom_bus_custserv_profs_sys','Systems Integration',ssUrlPrefix + 'for-business/customer-service-solutions/professional-services/contact-center-system-integration/index.htm');
g_navNode_2_7_13_5=g_navNode_2_7_13.addNode('ncom_bus_custserv_profs_improv','Continuous Improvement',ssUrlPrefix + 'for-business/customer-service-solutions/professional-services/customer-service-automation/index.htm');
g_navNode_2_7_13_6=g_navNode_2_7_13.addNode('ncom_bus_custserv_profs_u','Nuance University',ssUrlPrefix + 'for-business/customer-service-solutions/professional-services/training/index.htm');
g_navNode_2_7_14=g_navNode_2_7.addNode('ncom_bus_custserv_retail','Retail',ssUrlPrefix + 'for-business/customer-service-solutions/retail/index.htm');
g_navNode_2_7_15=g_navNode_2_7.addNode('ncom_bus_custserv_telecomm','Telecommunications',ssUrlPrefix + 'for-business/customer-service-solutions/telecommunications/index.htm');
g_navNode_2_7_16=g_navNode_2_7.addNode('ncom_bus_custserv_travel','Travel \x26 Transportation',ssUrlPrefix + 'for-business/customer-service-solutions/travel/index.htm');
g_navNode_2_7_17=g_navNode_2_7.addNode('ncom_bus_custserv_utilities','Utilities',ssUrlPrefix + 'for-business/customer-service-solutions/utilities/index.htm');
g_navNode_2_7_18=g_navNode_2_7.addNode('ncom_bus_custserv_nina','Nina',ssUrlPrefix + 'for-business/customer-service-solutions/nina/index.htm','contributorOnly==FALSE');
g_navNode_2_7_18_0=g_navNode_2_7_18.addNode('ncom_bus_custserv_ninaweb','Nina Web',ssUrlPrefix + 'for-business/customer-service-solutions/nina/nina-web/index.htm','contributorOnly==FALSE');
g_navNode_2_7_18_1=g_navNode_2_7_18.addNode('ncom_bus_custserv_ninamobile','Nina Mobile',ssUrlPrefix + 'for-business/customer-service-solutions/nina/nina-mobile/index.htm','contributorOnly==FALSE');
g_navNode_2_7_18_2=g_navNode_2_7_18.addNode('ncom_bus_custserv_ninamsg','Nina Messaging',ssUrlPrefix + 'for-business/customer-service-solutions/nina/nina-messaging/index.htm');
g_navNode_2_7_18_3=g_navNode_2_7_18.addNode('ncom_bus_custserv_ninaid','Nina ID',ssUrlPrefix + 'for-business/customer-service-solutions/nina/ninaid/index.htm');
g_navNode_2_7_19=g_navNode_2_7.addNode('ncom_bus_custserv_vbio','Voice biometrics',ssUrlPrefix + 'for-business/customer-service-solutions/voice-biometrics/index.htm');
g_navNode_2_7_19_0=g_navNode_2_7_19.addNode('ncom_bus_custserv_fspeech','FreeSpeech',ssUrlPrefix + 'for-business/customer-service-solutions/voice-biometrics/freespeech/index.htm');
g_navNode_2_7_19_1=g_navNode_2_7_19.addNode('ncom_bus_custserv_vpass','VocalPassword',ssUrlPrefix + 'for-business/customer-service-solutions/voice-biometrics/vocalpassword/index.htm');
g_navNode_2_7_19_2=g_navNode_2_7_19.addNode('ncom_bus_cust_vbio_infographic','Account Fraud Infographic',ssUrlPrefix + 'for-business/customer-service-solutions/voice-biometrics/account-fraud-infographic/index.htm');
g_navNode_2_7_19_3=g_navNode_2_7_19.addNode('ncom_bus_custserv_vbio_infogra','Infographic',ssUrlPrefix + 'for-business/customer-service-solutions/voice-biometrics/voice-biometrics-myths-infographic/index.htm');
g_navNode_2_7_20=g_navNode_2_7.addNode('ncom_bus_custserv_sales','Customer Acquisition',ssUrlPrefix + 'for-business/customer-service-solutions/sales/index.htm');
g_navNode_2_7_21=g_navNode_2_7.addNode('ncom_bus_custserv_care','Live Chat',ssUrlPrefix + 'for-business/customer-service-solutions/live-chat/index.htm');
g_navNode_2_7_22=g_navNode_2_7.addNode('ncom_bus_custserv_agent_assist','Agent-Assisted Products',ssUrlPrefix + 'for-business/customer-service-solutions/agent-assisted/index.htm');
g_navNode_2_7_23=g_navNode_2_7.addNode('ncom_bus_custserv_selfservice','Self-Service Products',ssUrlPrefix + 'for-business/customer-service-solutions/self-service/index.htm');
g_navNode_2_7_24=g_navNode_2_7.addNode('ncom_bus_custserv_incidentcomm','Incident Communications',ssUrlPrefix + 'for-business/customer-service-solutions/incident-communications/index.htm');
g_navNode_2_7_25=g_navNode_2_7.addNode('ncom_bus_custserv_fraudminer','Fraud Miner',ssUrlPrefix + 'for-business/customer-service-solutions/fraudminer/index.htm');
g_navNode_2_7_26=g_navNode_2_7.addNode('ncom_cust_omni_channel','Omni-channel engagement',ssUrlPrefix + 'for-business/customer-service-solutions/omni-channel-engagement/index.htm');
g_navNode_2_8=g_navNode_2.addNode('ncom_bus_speechsolutions','Speech Recognition Solutions',ssUrlPrefix + 'for-business/speech-recognition-solutions/index.htm');
g_navNode_2_8_0=g_navNode_2_8.addNode('ncom_bus_speechsol_voconsse','VoCon SSE',ssUrlPrefix + 'for-business/speech-recognition-solutions/vocon-sse/index.htm');
g_navNode_2_8_1=g_navNode_2_8.addNode('ncom_bus_speechsol_voconhybrid','VoCon Hybrid',ssUrlPrefix + 'for-business/speech-recognition-solutions/vocon-hybrid/index.htm');
g_navNode_2_9=g_navNode_2.addNode('ncom_bus_docscanconvert','Document Imaging and Scanning',ssUrlPrefix + 'for-business/document-imaging-and-scanning/index.htm');
g_navNode_2_9_0=g_navNode_2_9.addNode('ncom_bus_sol_printmanagement','Print Management',ssUrlPrefix + 'for-business/document-imaging-and-scanning/print-management-solutions/index.htm');
g_navNode_2_9_7=g_navNode_2_9.addNode('ncom_bus_outputmanager','Output Manager',ssUrlPrefix + 'for-business/document-imaging-and-scanning/outputmanager/index.htm');
g_navNode_2_10=g_navNode_2.addNode('ncom_bus_texttospeech','Text to Speech',ssUrlPrefix + 'for-business/text-to-speech/index.htm');
g_navNode_2_10_0=g_navNode_2_10.addNode('ncom_bus_texttospeech_vocalize','Vocalizer',ssUrlPrefix + 'for-business/text-to-speech/vocalizer/index.htm');
g_navNode_2_12=g_navNode_2.addNode('ncom_bus_asr','Automatic Speech Recognition',ssUrlPrefix + 'for-business/automatic-speech-recognition/index.htm');
g_navNode_2_12_0=g_navNode_2_12.addNode('ncom_bus_asr_recognizer','Nuance Recognizer',ssUrlPrefix + 'for-business/automatic-speech-recognition/automated-ivr/index.htm');
g_navNode_2_13=g_navNode_2.addNode('ncom_bus_nlu','Natural Language Understanding',ssUrlPrefix + 'for-business/natural-language-understanding/index.htm');
g_navNode_2_13_0=g_navNode_2_13.addNode('ncom_bus_nlu_callsteering','Call Steering',ssUrlPrefix + 'for-business/natural-language-understanding/call-steering/index.htm');
g_navNode_2_14=g_navNode_2.addNode('ncom_bus_autostore','Auto Store',ssUrlPrefix + 'for-business/autostore/index.htm','searchDispDesc==Nuance autostore - paper, electronic and mobile capture workflow solutions');
g_navNode_2_15=g_navNode_2.addNode('ncom_reslib','Resource Library',ssUrlPrefix + 'for-business/resource_library/index.htm');
g_navNode_2_16=g_navNode_2.addNode('ncom_bus_workflowprinting','Workflow and Printing',ssUrlPrefix + 'for-business/print-capture-pdf-solutions/index.htm');
g_navNode_2_16_0=g_navNode_2_16.addNode('ncom_bus_nsimobile','Business Connect',ssUrlPrefix + 'for-business/print-capture-pdf-solutions/business-connect/index.htm');
g_navNode_2_17=g_navNode_2.addNode('ncom_bus_industrysolutions','Industry Solutions',ssUrlPrefix + 'for-business/industry-solutions/index.htm');
g_navNode_2_17_0=g_navNode_2_17.addNode('ncom_bus_indussol_healthcare','Document Healthcare Solutions',ssUrlPrefix + 'for-business/industry-solutions/healthcare/index.htm');
g_navNode_2_17_1=g_navNode_2_17.addNode('ncom_bus_indussol_legal','Document legal \x26 professional services solutions',ssUrlPrefix + 'for-business/industry-solutions/legal-professional/index.htm');
g_navNode_2_17_2=g_navNode_2_17.addNode('ncom_bus_indussol_financial','Document financial solutions',ssUrlPrefix + 'for-business/industry-solutions/financial/index.htm');
g_navNode_2_17_3=g_navNode_2_17.addNode('ncom_bus_indussol_government','Document government solutions',ssUrlPrefix + 'for-business/industry-solutions/government/index.htm');
g_navNode_2_17_4=g_navNode_2_17.addNode('ncom_bus_indussol_manufacturin','Manufacturing',ssUrlPrefix + 'for-business/industry-solutions/manufacturing/index.htm');
g_navNode_2_19=g_navNode_2.addNode('ncom_bus_imgsol','Imaging Solutions',ssUrlPrefix + 'for-business/imaging-solutions/index.htm');
g_navNode_2_19_0=g_navNode_2_19.addNode('ncom_bus_training_img_partners','Imaging Partners',ssUrlPrefix + 'for-business/imaging-solutions/training-partners/index.htm');
g_navNode_2_19_1=g_navNode_2_19.addNode('ncom_bus_training_img_customer','Imaging Customers',ssUrlPrefix + 'for-business/imaging-solutions/training-customers/index.htm');
g_navNode_2_19_2=g_navNode_2_19.addNode('ncom_bus_imgsol_autostore','AutoStore',ssUrlPrefix + 'for-business/imaging-solutions/autostore/index.htm');
g_navNode_2_19_3=g_navNode_2_19.addNode('ncom_bus_imgsol_doccon','PDF and Document Conversion',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/index.htm');
g_navNode_2_19_3_0=g_navNode_2_19_3.addNode('ncom_bus_imgsol_doccon_ppdfcon','Power PDF Converter',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/index.htm');
g_navNode_2_19_3_0_0=g_navNode_2_19_3_0.addNode('ncom_bus_img_doc_ppdf_stan','Power PDF Standard',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/standard/index.htm');
g_navNode_2_19_3_0_1=g_navNode_2_19_3_0.addNode('ncom_bus_img_doc_ppdf_adv','Power PDF Advanced',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/advanced/index.htm');
g_navNode_2_19_3_0_2=g_navNode_2_19_3_0.addNode('ncom_bus_img_doc_ppdf_trial','Power PDF Free Trial',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/free-trial/index.htm');
g_navNode_2_19_3_0_3=g_navNode_2_19_3_0.addNode('ncom_bus_img_doc_ppdf_howto','Power PDF How-to',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/index.htm','RedirectSectionID==ncom_bus_img_doc_ppdf_how_crea');
g_navNode_2_19_3_0_3_0=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_how_word','Power PDF convert to Word',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/convert-pdf-to-word/index.htm');
g_navNode_2_19_3_0_3_1=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_how_crea','Power PDF Creator',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/pdf-creator/index.htm');
g_navNode_2_19_3_0_3_2=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_how_exce','Power PDF convert to Excel',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/convert-pdf-to-excel/index.htm');
g_navNode_2_19_3_0_3_3=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_how_merg','Power PDF Merge',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/merge-pdf/index.htm');
g_navNode_2_19_3_0_3_4=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_how_batc','Power PDF Batch Edit',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/pdf-editor-batch/index.htm');
g_navNode_2_19_3_0_3_5=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_how_form','Power PDF with Forms',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/pdf-with-forms/index.htm');
g_navNode_2_19_3_0_3_6=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_how_ppt','Power PDF convert to PPT',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/convert-pdf-to-ppt/index.htm');
g_navNode_2_19_3_0_3_7=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_reader','Power PDF Reader',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/pdf-reader/index.htm');
g_navNode_2_19_3_0_3_8=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_to_jpg','Power PDF convert to JPG',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/convert-pdf-to-jpg/index.htm');
g_navNode_2_19_3_0_3_9=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_for_mac','Power PDF convertor for MAC',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/pdf-converter-for-mac/index.htm');
g_navNode_2_19_3_0_3_10=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_edit','Power PDF Edit',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/edit-pdf/index.htm');
g_navNode_2_19_3_0_3_11=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_toc','Table of Contents',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/toc/index.htm');
g_navNode_2_19_3_0_3_12=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_esig','Electronic Signatures',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/esignatures/index.htm');
g_navNode_2_19_3_0_3_13=g_navNode_2_19_3_0_3.addNode('ncom_bus_img_doc_ppdf_rms','RMS Security',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/how-to/rms-security/index.htm');
g_navNode_2_19_3_0_4=g_navNode_2_19_3_0.addNode('ncom_bus_img_doc_ppdf_switch','Power PDF Why-switch',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/why-switch/index.htm','RedirectSectionID==ncom_bus_img_doc_ppdf_swch_ifc');
g_navNode_2_19_3_0_4_0=g_navNode_2_19_3_0_4.addNode('ncom_bus_img_doc_ppdf_swch_ifc','Power PDF Why Switch - Intuitive interface',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/why-switch/interface/index.htm');
g_navNode_2_19_3_0_4_1=g_navNode_2_19_3_0_4.addNode('ncom_bus_img_doc_ppdf_swch_bch','Power PDF Why Switch - Batch editing',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/why-switch/batch-editing/index.htm');
g_navNode_2_19_3_0_4_2=g_navNode_2_19_3_0_4.addNode('ncom_bus_img_doc_ppdf_swch_voc','Power PDF Why Switch - Voice recognition',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/why-switch/voice-recognition/index.htm');
g_navNode_2_19_3_0_4_3=g_navNode_2_19_3_0_4.addNode('ncom_bus_img_doc_ppdf_swch_src','Power PDF Why Switch - Pattern search',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/why-switch/pattern-search/index.htm');
g_navNode_2_19_3_0_4_4=g_navNode_2_19_3_0_4.addNode('ncom_bus_img_doc_ppdf_swch_sec','Power PDF Why Switch - Security',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/why-switch/pdf-security/index.htm');
g_navNode_2_19_3_0_4_5=g_navNode_2_19_3_0_4.addNode('ncom_bus_img_doc_ppdf_swch_lic','Power PDF Why Switch - Licensing',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/why-switch/licensing/index.htm');
g_navNode_2_19_3_0_5=g_navNode_2_19_3_0.addNode('ncom_bus_img_doc_ppdf_res','Power PDF Resources',ssUrlPrefix + 'for-business/imaging-solutions/document-conversion/power-pdf-converter/resources/index.htm');
g_navNode_2_19_4=g_navNode_2_19.addNode('ncom_bus_img_resourcelib','Imaging Resource Library',ssUrlPrefix + 'for-business/imaging-solutions/resources/index.htm','contributorOnly==FALSE');
g_navNode_2_19_4_0=g_navNode_2_19_4.addNode('ncom_bus_imgsol_reslib_ss','Success Stories',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/index.htm','contributorOnly==FALSE');
g_navNode_2_19_4_0_1=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_akronsum','Equitrac Express for AkronSummit',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-akronsummit/index.htm');
g_navNode_2_19_4_0_2=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_siliconv','Copitrac for SiliCon Valley Law Firm',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/copitrac-for-siliconvalley/index.htm');
g_navNode_2_19_4_0_3=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_somerset','AutoStore Equitrac for Somerset Partner',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-equitrac-for-somersetpartner/index.htm');
g_navNode_2_19_4_0_4=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_fortune5','Equitrac for Fortune 500',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-fortune500/index.htm');
g_navNode_2_19_4_0_5=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_shropshi','eCopy for Shropshire Fire \x26 Rescue',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-shropshire/index.htm');
g_navNode_2_19_4_0_6=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_engineer','Power PDF for Engineering Firm',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/powerpdf-for-engineering/index.htm');
g_navNode_2_19_4_0_7=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_casnered','Copitrak for Casner \x26 Edward',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/copitrak-for-casneredward/index.htm');
g_navNode_2_19_4_0_8=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_warwick','Safecom AutoStore for Warwick U',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/safecom-autostore-for-warwick/index.htm');
g_navNode_2_19_4_0_9=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_mail','eCopy for Mail Distribution at SitScrutton Bland',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-sitscrutton/index.htm');
g_navNode_2_19_4_0_10=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_producti','eCopy for Productivity at Sitzmann Morris and Lavis',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-sml-productivity/index.htm');
g_navNode_2_19_4_0_11=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_secure','eCopy for Secure Distribution',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-secure-distribution/index.htm');
g_navNode_2_19_4_0_12=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_bedell','eCopy for Bedell Group',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-bedell/index.htm');
g_navNode_2_19_4_0_13=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_cityinfo','eCopy for Wichita Access to City Information',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-wichita-city/index.htm');
g_navNode_2_19_4_0_14=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_texastow','eCopy for Old Texas Town',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-texastown/index.htm');
g_navNode_2_19_4_0_15=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_elizabet','Equitrac for Queen Elizabeth School',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-queen-elizabeth/index.htm');
g_navNode_2_19_4_0_16=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_nen','Equitrac for NEN',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-nen/index.htm');
g_navNode_2_19_4_0_17=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_hilsonmo','Equitrac for Hilson Moran',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-hilson-moran/index.htm');
g_navNode_2_19_4_0_18=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_sinclair','Equitrac for Sinclair College',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-sinclair-college/index.htm');
g_navNode_2_19_4_0_19=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_branch','Autostore for AgStar Branch Operations',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-agstar-operations/index.htm');
g_navNode_2_19_4_0_20=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_time','eCopy for Albihns',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-albihns/index.htm');
g_navNode_2_19_4_0_21=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_nwq','AutoStore for NWQ',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-NWQ/index.htm');
g_navNode_2_19_4_0_22=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_peirce','Equitrac Express for Peirce College',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-peirce-college/index.htm');
g_navNode_2_19_4_0_23=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_network','AutoStore for Navy and Marine',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-navy-marine/index.htm');
g_navNode_2_19_4_0_24=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_washingt','AutoStore for Washington',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-washington/index.htm');
g_navNode_2_19_4_0_25=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_malmo','AutoStore for Malmo Logistic Center',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-malmo-logistic/index.htm');
g_navNode_2_19_4_0_26=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_tiem','AutoStore for TIEM',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-tiem/index.htm');
g_navNode_2_19_4_0_27=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_crowley','AutoStore for Crowley Maritime',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-crowley/index.htm');
g_navNode_2_19_4_0_28=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_vha','AutoStore Output Manager for VHA',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-output-for-vha/index.htm');
g_navNode_2_19_4_0_29=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_abrazo','eCopy for Abrazo Healthcare',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-abrazo-healthcare/index.htm');
g_navNode_2_19_4_0_30=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_doj','AutoStore for Oregon DOJ',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-oregon-doj/index.htm');
g_navNode_2_19_4_0_31=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_fairfax','AutoStore for Fairfax County',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-fairfax-county/index.htm');
g_navNode_2_19_4_0_32=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_tulane','AutoStore for Tulance University',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-tulane/index.htm');
g_navNode_2_19_4_0_33=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_famc','AutoStore for FAMC',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-famc/index.htm');
g_navNode_2_19_4_0_34=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_florida','AutoStore for Florida Medical Center',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-florida-medical/index.htm');
g_navNode_2_19_4_0_35=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_norwood','Document Imaging for Norwood Health',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/docimaging-for-norwood/index.htm');
g_navNode_2_19_4_0_36=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_boston','AutoStore for Boston Children\'s Hospital',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-boston-hospital/index.htm');
g_navNode_2_19_4_0_37=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_randstad','AutoStore for Randstad Recruiting',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-randstad-recruiting/index.htm');
g_navNode_2_19_4_0_38=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_amcor','Equitrac for Amcor',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-amcor/index.htm');
g_navNode_2_19_4_0_39=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_fhlbbost','AutoStore for FHLBBoston',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-FHLBBoston/index.htm');
g_navNode_2_19_4_0_40=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_nhs','Equitrac for NHS Lanarkshire',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-nhs-lanarkshire/index.htm');
g_navNode_2_19_4_0_41=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_tgi','DocImaging for TGI ',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/docimaging-for-tgi/index.htm');
g_navNode_2_19_4_0_42=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_pwc','AutoStore for P\x26WC',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-pwc/index.htm');
g_navNode_2_19_4_0_43=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_hughes','AutoStore for Hughes Hubbard',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-hughes-hubbard/index.htm');
g_navNode_2_19_4_0_44=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_hanna','AutoStore for Hanna \x26 Brophy',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-hanna-brophy/index.htm');
g_navNode_2_19_4_0_45=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_stradley','Copitrak for Stradley Ronon',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/copitrak-for-stradley-ronon/index.htm');
g_navNode_2_19_4_0_46=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_okanagan','Equitrac for Okanagan School',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-okanagan-school/index.htm');
g_navNode_2_19_4_0_47=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_manatee','Equitrac for Manatee County',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-manatee/index.htm');
g_navNode_2_19_4_0_48=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_bettenwe','AutoStore for Bettenwelt',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-bettenwelt/index.htm');
g_navNode_2_19_4_0_49=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_swissban','Equitrac for Swiss Graubundner Kantonalbank',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-swiss-bank/index.htm');
g_navNode_2_19_4_0_50=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_kpmg','AutoStore for KPMG',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-kpmg/index.htm');
g_navNode_2_19_4_0_51=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_nmci','AutoStore for NMCI',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-nmci/index.htm');
g_navNode_2_19_4_0_52=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_bankdata','AutoStore for Bankdata',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-bankdata/index.htm');
g_navNode_2_19_4_0_53=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_drugmart','AutoStore for Drug Mart',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-drugmart/index.htm');
g_navNode_2_19_4_0_54=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_fmpa','AutoStore for FMPA',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-fmpa/index.htm');
g_navNode_2_19_4_0_55=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_gowlings','AutoStore for Gowlings',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-gowlings/index.htm');
g_navNode_2_19_4_0_56=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_union','AutoStore for Union Capital',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-union-capital/index.htm');
g_navNode_2_19_4_0_57=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_mdennehe','Power PDF for Marshall Dennehey ',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/powerpdf-for-marshalldennehey/index.htm');
g_navNode_2_19_4_0_58=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_crwnhtl','Autostore for Crown Hotels',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-crownhotels/index.htm');
g_navNode_2_19_4_0_59=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_uaes','Equitrac for UAES',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-uaes/index.htm');
g_navNode_2_19_4_0_60=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_ivi','Autostore for IVI',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-ivi/index.htm');
g_navNode_2_19_4_0_61=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_mlc','Equitrac fror MLC',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-mlc/index.htm');
g_navNode_2_19_4_0_62=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_voestalp','autostore-for-voestalpine',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-voestalpine/index.htm');
g_navNode_2_19_4_0_63=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_nw','eCopy for N and W',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-NW/index.htm');
g_navNode_2_19_4_0_64=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_magdalen','Equitrac for Magdalen',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-magdalen/index.htm');
g_navNode_2_19_4_0_65=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_estesexp','eCopy for Estesexpress',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-estesexpress/index.htm');
g_navNode_2_19_4_0_66=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_scheider','eCopy for Scheiderelectric',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-scheiderelectric/index.htm');
g_navNode_2_19_4_0_67=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_zeeland','eCopy for Zeeland',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-zeeland/index.htm');
g_navNode_2_19_4_0_68=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_bathspau','equitrac foe Bath Spa University',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-bathspauniversity/index.htm');
g_navNode_2_19_4_0_69=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_nuance','Equitrac for Nuance',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-nuance/index.htm');
g_navNode_2_19_4_0_70=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_daelmans','Autostore for Daelmans',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-daelmans/index.htm');
g_navNode_2_19_4_0_71=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_cuatreca','Safecom for Cuatrecasas',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/safecom-for-cuatrecasas/index.htm');
g_navNode_2_19_4_0_72=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_righttyp','Output Manager for Righttype',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/output-manager-for-righttype/index.htm');
g_navNode_2_19_4_0_73=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_jpmorgan','Equitrac for JP Morgan',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-forjp-morgan/index.htm');
g_navNode_2_19_4_0_74=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_foulsham','Equatrac for Foul Sham',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-foulsham/index.htm');
g_navNode_2_19_4_0_75=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_miron','eCopy for Miron',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ecopy-for-miron/index.htm');
g_navNode_2_19_4_0_76=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_pdf_gaa','Power PDF for GAA',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/power-pdf-for-gaa/index.htm');
g_navNode_2_19_4_0_77=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_pdf_vere','Power PDF for Vereb',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/power-pdf-for-vereb/index.htm');
g_navNode_2_19_4_0_78=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_lewalt','Power PDF for Lewalt',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/power-pdf-for-lewalt/index.htm');
g_navNode_2_19_4_0_79=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_et_ljmu','Equitrac for Ljmu',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-ljmu/index.htm');
g_navNode_2_19_4_0_80=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_pdfcarru','Power PDF for Carrus',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/power-pdf-for-carrus/index.htm');
g_navNode_2_19_4_0_81=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_sc_trust','Safecom for nhs trust',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/safecom-for-nhs-trust/index.htm');
g_navNode_2_19_4_0_82=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_baker','Power PDF Baker',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/power-pdf-baker/index.htm');
g_navNode_2_19_4_0_83=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_dollwear','Power Pdf Dollwear',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/power-pdf-dollwear/index.htm');
g_navNode_2_19_4_0_84=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_recupel','Autostore for Recupel',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/autostore-for-recupel/index.htm');
g_navNode_2_19_4_0_85=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_anderson','Equitrac for Andersons Solicitors',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-andersons-solicitors/index.htm');
g_navNode_2_19_4_0_86=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_chlawyer','Equitrac for CH Lawyers',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-ch-lawyers/index.htm');
g_navNode_2_19_4_0_87=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_amcnet','Equitrac for AMC Networks',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/equitrac-for-amc-networks/index.htm');
g_navNode_2_19_4_0_88=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_vanbreda','OCR for Vanbreda',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/ocr-for-vanbreda/index.htm');
if (SSContributor)
{
g_navNode_2_19_4_0_89=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_burnslev','PDF Converter at Burns Levinson',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/pdf-converter-at-burns-levinson/index.htm','contributorOnly==TRUE');
}
g_navNode_2_19_4_0_90=g_navNode_2_19_4_0.addNode('ncom_imgsol_reslib_ss_mds','Omnipagefor MDS',ssUrlPrefix + 'for-business/imaging-solutions/resources/success/omnipage-for-mds/index.htm');
g_navNode_2_19_5=g_navNode_2_19.addNode('ncom_bus_training_img_proserv','Professional Services',ssUrlPrefix + 'for-business/imaging-solutions/professional-services/index.htm');
g_navNode_2_20=g_navNode_2.addNode('ncom_bus_nte','Nuance Transcription Engine',ssUrlPrefix + 'for-business/nuance-transcription-engine/index.htm','contributorOnly==FALSE');
g_navNode_3=g_navNode_Root.addNode('ncom_forhealthcare','For healthcare',ssUrlPrefix + 'for-healthcare/index.htm');
g_navNode_3_0=g_navNode_3.addNode('ncom_heal_clintfam','Clintegrity 360',ssUrlPrefix + 'for-healthcare/clintegrity360/index.htm');
g_navNode_3_0_0=g_navNode_3_0.addNode('ncom_heal_clin_clidocimpr','Clinical Document Improvement',ssUrlPrefix + 'for-healthcare/clintegrity360/clinical-document-improvement/index.htm');
g_navNode_3_0_0_0=g_navNode_3_0_0.addNode('ncom_hlt_clint_cdi','CDI',ssUrlPrefix + 'for-healthcare/clintegrity360/clinical-document-improvement/cdi/index.htm');
g_navNode_3_0_0_1=g_navNode_3_0_0.addNode('ncom_hlt_clint_capd','CAPD',ssUrlPrefix + 'for-healthcare/clintegrity360/clinical-document-improvement/capd/index.htm');
g_navNode_3_0_1=g_navNode_3_0.addNode('ncom_heal_clin_qualmansol','Quality Management Solutions',ssUrlPrefix + 'for-healthcare/clintegrity360/quality-management-solutions/index.htm');
g_navNode_3_0_1_0=g_navNode_3_0_1.addNode('ncom_hlt_clint_qualitymeasures','Quality Measures',ssUrlPrefix + 'for-healthcare/clintegrity360/quality-management-solutions/quality-measures/index.htm');
g_navNode_3_0_1_1=g_navNode_3_0_1.addNode('ncom_hlt_clint_perf_ana','Performance Analytics',ssUrlPrefix + 'for-healthcare/clintegrity360/quality-management-solutions/performance-analytics/index.htm');
g_navNode_3_0_1_2=g_navNode_3_0_1.addNode('ncom_hlt_clint_narrativesearch','Narrative Search',ssUrlPrefix + 'for-healthcare/clintegrity360/quality-management-solutions/narrative-search/index.htm');
g_navNode_3_0_2=g_navNode_3_0.addNode('ncom_heal_clin_recmanag','Record Management',ssUrlPrefix + 'for-healthcare/clintegrity360/record-management/index.htm');
g_navNode_3_0_2_0=g_navNode_3_0_2.addNode('ncom_hlt_clint_rec_manag','Record Management',ssUrlPrefix + 'for-healthcare/clintegrity360/record-management/record-management/index.htm');
g_navNode_3_0_2_1=g_navNode_3_0_2.addNode('ncom_hlt_clint_edoc_management','Electronic Doc Management',ssUrlPrefix + 'for-healthcare/clintegrity360/record-management/electronic-doc-management/index.htm');
g_navNode_3_0_2_2=g_navNode_3_0_2.addNode('ncom_hlt_clint_enhancedworkflo','Enhanced Workflow',ssUrlPrefix + 'for-healthcare/clintegrity360/record-management/enhanced-workflow/index.htm');
g_navNode_3_0_2_3=g_navNode_3_0_2.addNode('ncom_hlt_clint_filemanager','File Manager',ssUrlPrefix + 'for-healthcare/clintegrity360/record-management/file-manager/index.htm','searchDispDesc==Clintegrity 360 - File Manager, an enterprise-wide, single platform document management solution');
g_navNode_3_0_2_4=g_navNode_3_0_2.addNode('ncom_hlt_clint_esignature','eSignature',ssUrlPrefix + 'for-healthcare/clintegrity360/record-management/esignature/index.htm');
g_navNode_3_0_3=g_navNode_3_0.addNode('ncom_heal_clin_icd10','ICD10 Education and Services',ssUrlPrefix + 'for-healthcare/clintegrity360/ICD-10-education-and-services/index.htm');
g_navNode_3_0_3_0=g_navNode_3_0_3.addNode('ncom_hlt_clint_icd10services','ICD-10 Services',ssUrlPrefix + 'for-healthcare/clintegrity360/ICD-10-education-and-services/icd-10services/index.htm');
g_navNode_3_0_4=g_navNode_3_0.addNode('ncom_heal_clin_comasscod','Computer Assisted Coding',ssUrlPrefix + 'for-healthcare/clintegrity360/computer-assisted-coding/index.htm');
g_navNode_3_0_4_0=g_navNode_3_0_4.addNode('ncom_hlt_clint_cac','CAC',ssUrlPrefix + 'for-healthcare/clintegrity360/computer-assisted-coding/cac/index.htm');
g_navNode_3_0_4_1=g_navNode_3_0_4.addNode('ncom_hlt_clint_compliance','Compliance',ssUrlPrefix + 'for-healthcare/clintegrity360/computer-assisted-coding/compliance/index.htm');
g_navNode_3_0_4_2=g_navNode_3_0_4.addNode('ncom_hlt_clint_abstracting','Abstracting',ssUrlPrefix + 'for-healthcare/clintegrity360/computer-assisted-coding/abstracting/index.htm');
g_navNode_3_0_4_3=g_navNode_3_0_4.addNode('ncom_hlt_clint_coding','Physician Coding',ssUrlPrefix + 'for-healthcare/clintegrity360/computer-assisted-coding/physician-coding/index.htm');
g_navNode_3_0_4_4=g_navNode_3_0_4.addNode('ncom_heal_clin_facilitycoding','Facility Coding',ssUrlPrefix + 'for-healthcare/clintegrity360/computer-assisted-coding/facility-coding/index.htm');
g_navNode_3_2=g_navNode_3.addNode('ncom_hea_product_gen_contactus','Contact Us',ssUrlPrefix + 'for-healthcare/contact-us/index.htm','RedirectTo==http\x3a//www.nuance.com/for-business/engage_us/index.htm?divisionVar\x3dHealthcare');
g_navNode_3_3=g_navNode_3.addNode('ncom_hlt_bygoals','By Goal',ssUrlPrefix + 'for-healthcare/by-goals/index.htm');
g_navNode_3_3_0=g_navNode_3_3.addNode('ncom_hlt_goa_decisionsupp','Decision Support',ssUrlPrefix + 'for-healthcare/by-goals/decision-support/index.htm','nonViewableCountries==ENUS');
g_navNode_3_4=g_navNode_3.addNode('ncom_hlt_bysolutions','By Solution',ssUrlPrefix + 'for-healthcare/by-solutions/index.htm');
g_navNode_3_4_7=g_navNode_3_4.addNode('ncom_health_sol_mobile','Mobile',ssUrlPrefix + 'for-healthcare/by-solutions/mobile/index.htm','RedirectTo==/for-healthcare/capture-anywhere/360-mobile-solutions/');
g_navNode_3_4_7_2=g_navNode_3_4_7.addNode('ncom_hea_sol_mo_dra_med_mo_sdk','Dragon Medical Mobile SDK',ssUrlPrefix + 'for-healthcare/by-solutions/mobile/dragon-medical-mobile-sdk/index.htm','RedirectTo==https\x3a//www.nuancehealthcaredeveloper.com/public/index.php?page\x3dhome');
g_navNode_3_4_7_3=g_navNode_3_4_7.addNode('ncom_hea_sol_mo_dra_med_mo_sea','Dragon Medical Mobile Search',ssUrlPrefix + 'for-healthcare/by-solutions/mobile/dragon-medical-mobile-search/index.htm');
g_navNode_3_4_7_4=g_navNode_3_4_7.addNode('ncom_hea_sol_mo_dra_med_mo_rec','Dragon Medical Mobile Recorder',ssUrlPrefix + 'for-healthcare/by-solutions/mobile/dragon-medical-mobile-recorder/index.htm');
g_navNode_3_5=g_navNode_3.addNode('ncom_hlt_bybenefits','Benefits For',ssUrlPrefix + 'for-healthcare/by-benefits/index.htm');
g_navNode_3_5_0=g_navNode_3_5.addNode('ncom_hlt_ben_clinician','Clinicians',ssUrlPrefix + 'for-healthcare/by-benefits/clinicians/index.htm','RedirectTo==/for-healthcare/capture-anywhere/radiology-solutions/index.htm','nonViewableCountries==ENUS');
g_navNode_3_5_3=g_navNode_3_5.addNode('ncom_hlt_ben_payers','Payers',ssUrlPrefix + 'for-healthcare/by-benefits/payers/index.htm','RedirectTo==/for-healthcare/capture-anywhere/radiology-solutions/index.htm','nonViewableCountries==ENUS');
g_navNode_3_5_3_1=g_navNode_3_5_3.addNode('ncom_hea_ben_payers_radcube','RadCube',ssUrlPrefix + 'for-healthcare/by-benefits/payers/radcube/index.htm');
g_navNode_3_6=g_navNode_3.addNode('ncom_hlt_resources','Resources',ssUrlPrefix + 'for-healthcare/resources/index.htm');
g_navNode_3_6_1=g_navNode_3_6.addNode('ncom_hlt_res_nlp','CLU',ssUrlPrefix + 'for-healthcare/resources/clinical-language-understanding/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_3_6_1_0=g_navNode_3_6_1.addNode('ncom_hea_resources_nlp_ontolog','Ontology',ssUrlPrefix + 'for-healthcare/resources/clinical-language-understanding/ontology/index.htm','nonViewableCountries==ENUK,DE,FR');
if (SSContributor)
{
g_navNode_3_6_3=g_navNode_3_6.addNode('ncom_healthcare_capd','Dragon Medical 360 MD Assist',ssUrlPrefix + 'for-healthcare/resources/dragon-medical-360-md-assist/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
g_navNode_3_9=g_navNode_3.addNode('ncom_healthcare_develope','Nuance Healthcare Developers Program',ssUrlPrefix + 'for-healthcare/developers-program/index.htm');
g_navNode_3_10=g_navNode_3.addNode('ncom_healt_ehrmeaningful','EHR Meaningful Use Physician Study ',ssUrlPrefix + 'for-healthcare/ehr-meaningful-use-physician-study/index.htm');
g_navNode_3_10_0=g_navNode_3_10.addNode('ncom_health_ehrq_quesand','Question and Answers',ssUrlPrefix + 'for-healthcare/ehr-meaningful-use-physician-study/question-and-answers/index.htm');
g_navNode_3_11=g_navNode_3.addNode('ncom_healthcare_military','Military Health Systems',ssUrlPrefix + 'for-healthcare/military-health-systems/index.htm');
g_navNode_3_11_0=g_navNode_3_11.addNode('ncom_health_mhs_tipsandt','MHS Tips and Tricks',ssUrlPrefix + 'for-healthcare/military-health-systems/mhs-tips-and-tricks/index.htm');
g_navNode_3_11_0_0=g_navNode_3_11_0.addNode('ncom_healthcare_mhs_mhst','MHS Terms',ssUrlPrefix + 'for-healthcare/military-health-systems/mhs-tips-and-tricks/mhs-terms/index.htm');
g_navNode_3_11_0_1=g_navNode_3_11_0.addNode('ncom_health_mhstips_chcs','MHS CHCS-l',ssUrlPrefix + 'for-healthcare/military-health-systems/mhs-tips-and-tricks/mhs-chcs-l/index.htm');
g_navNode_3_11_0_2=g_navNode_3_11_0.addNode('ncom_health_mhstips_ess','Dragon Medical and Essentris',ssUrlPrefix + 'for-healthcare/military-health-systems/mhs-tips-and-tricks/dragon-medical-and-essentris/index.htm');
g_navNode_3_11_0_3=g_navNode_3_11_0.addNode('ncom_hea_mhs_tptk_mahlta','MHS AHLTA',ssUrlPrefix + 'for-healthcare/military-health-systems/mhs-tips-and-tricks/mhs-ahlta/index.htm');
g_navNode_3_11_0_4=g_navNode_3_11_0.addNode('ncom_health_mhs_tptk_mco','MHS Commands',ssUrlPrefix + 'for-healthcare/military-health-systems/mhs-tips-and-tricks/mhs-commands/index.htm');
g_navNode_3_11_1=g_navNode_3_11.addNode('ncom_health_mhsgettingst','MHS Getting Started',ssUrlPrefix + 'for-healthcare/military-health-systems/mhs-getting-started/index.htm');
g_navNode_3_11_2=g_navNode_3_11.addNode('ncom_health_mhscontactus','MHS Contact Us',ssUrlPrefix + 'for-healthcare/military-health-systems/mhs-contact-us/index.htm');
if (SSContributor)
{
g_navNode_3_15=g_navNode_3.addNode('ncom_healthcare_dragonfd','Dragon For Doctors',ssUrlPrefix + 'for-healthcare/dragon-for-doctors/index.htm','contributorOnly==TRUE');
}
g_navNode_3_16=g_navNode_3.addNode('ncom_health_customvideos','Customer Video',ssUrlPrefix + 'for-healthcare/customer-video/index.htm');
g_navNode_3_16_0=g_navNode_3_16.addNode('ncom_health_dragon_video','Dragon Solution Videos',ssUrlPrefix + 'for-healthcare/customer-video/dragon-medical-solution-videos/index.htm');
g_navNode_3_16_1=g_navNode_3_16.addNode('ncom_health_hims_videos','HIM Solution Videos',ssUrlPrefix + 'for-healthcare/customer-video/him-solution-videos/index.htm');
g_navNode_3_16_2=g_navNode_3_16.addNode('ncom_health_mobi_videos','Mobile Solution Videos',ssUrlPrefix + 'for-healthcare/customer-video/mobile-solution-videos/index.htm');
g_navNode_3_16_3=g_navNode_3_16.addNode('ncom_health_radio_videos','Radiology Solutions Videos',ssUrlPrefix + 'for-healthcare/customer-video/radiology-solution-videos/index.htm');
g_navNode_3_18=g_navNode_3.addNode('ncom_healthcare_whatshot','Healthcare Insights',ssUrlPrefix + 'for-healthcare/insights/index.htm');
g_navNode_3_22=g_navNode_3.addNode('ncom_heal_powbnuaheal','Powered by Nuance Healthcare',ssUrlPrefix + 'for-healthcare/powered-by-nuance-healthcare/index.htm','RedirectTo==http\x3a//www.nuance.com/for-healthcare/cloud-based-healthcare-technologies/index.htm');
g_navNode_3_23=g_navNode_3.addNode('ncom_healthcare_capanywh','Capture Anywhere',ssUrlPrefix + 'for-healthcare/capture-anywhere/index.htm');
g_navNode_3_23_2=g_navNode_3_23.addNode('ncom_hea_capany_360mobsu','360 Mobile Solutions',ssUrlPrefix + 'for-healthcare/capture-anywhere/360-mobile-solutions/index.htm');
g_navNode_3_23_2_0=g_navNode_3_23_2.addNode('ncom_hea_capany_360mob_powermi','PowerMic Mobile',ssUrlPrefix + 'for-healthcare/capture-anywhere/360-mobile-solutions/powermicmobile/index.htm');
g_navNode_3_23_4=g_navNode_3_23.addNode('ncom_health_capt_radiols','Radiology Solutions',ssUrlPrefix + 'for-healthcare/capture-anywhere/radiology-solutions/index.htm','RedirectTo==/for-healthcare/capture-anywhere/radiology-solutions/index.htm');
g_navNode_3_26=g_navNode_3.addNode('ncom_heal_healannoun','Healthcare Announcement Quantim',ssUrlPrefix + 'for-healthcare/healthcare-announcement-quantim/index.htm');
g_navNode_3_27=g_navNode_3.addNode('ncom_heal_anou_jat','Healthcare Announcement JAThomas',ssUrlPrefix + 'for-healthcare/healthcare-announcement-jathomas/index.htm','contributorOnly==FALSE');
g_navNode_3_28=g_navNode_3.addNode('ncom_heal_himsolva','HIM Solutions VA',ssUrlPrefix + 'for-healthcare/him-solutions-va/index.htm');
g_navNode_3_28_0=g_navNode_3_28.addNode('ncom_hea_himsolva_icdred','ICD 10 Readiness Education',ssUrlPrefix + 'for-healthcare/him-solutions-va/ICD-10-readiness-education/index.htm');
g_navNode_3_28_1=g_navNode_3_28.addNode('ncom_hea_himsolva_impver','Improved VERA Funding',ssUrlPrefix + 'for-healthcare/him-solutions-va/improved-vera-funding/index.htm');
g_navNode_3_29=g_navNode_3.addNode('ncom_hea_himsoldodmhs','HIM Solutions DOD MHS',ssUrlPrefix + 'for-healthcare/him-solutions-dod-mhs/index.htm');
g_navNode_3_30=g_navNode_3.addNode('ncom_healt_quantim','Quantim',ssUrlPrefix + 'for-healthcare/quantim/index.htm');
g_navNode_3_31=g_navNode_3.addNode('ncom_health_ntstech','NTS Tech',ssUrlPrefix + 'for-healthcare/nts-tech/index.htm');
g_navNode_3_32=g_navNode_3.addNode('ncom_heal_advisory_webinar','Advisory Board Webinar Series',ssUrlPrefix + 'for-healthcare/advisory-board-webinar-series/index.htm');
g_navNode_3_35=g_navNode_3.addNode('ncom_health_ntstech_dess_canad','NTS Tech Dress Canada',ssUrlPrefix + 'for-healthcare/nts-tech-dess-canada/index.htm');
g_navNode_3_40=g_navNode_3.addNode('ncom_heal_artofmedicine','Art of Medicine',ssUrlPrefix + 'for-healthcare/artofmedicine/index.htm','searchDispDesc==In The Art of Medicine, Nuance examines current physician frustrations with technology and what needs to change to keep the focus on patients, not data entry.');
g_navNode_3_42=g_navNode_3.addNode('ncom_health_cloudtech','Cloud Based Healthcare Technologies',ssUrlPrefix + 'for-healthcare/cloud-based-healthcare-technologies/index.htm');
g_navNode_3_43=g_navNode_3.addNode('ncom_forhealthcare_emea','EMEA',ssUrlPrefix + 'for-healthcare/emea/index.htm');
g_navNode_3_46=g_navNode_3.addNode('ncom_health_dragonmedicalsol','Dragon Medical Solutions',ssUrlPrefix + 'for-healthcare/dragon-medical/index.htm');
g_navNode_3_48=g_navNode_3.addNode('ncom_health_med_trans_sol_ser','Medical Transcription Solution Services',ssUrlPrefix + 'for-healthcare/medical-transcription-solutions-services/index.htm');
g_navNode_3_49=g_navNode_3.addNode('ncom_health_med_trans_pltfrm','Medical Transcription Platform',ssUrlPrefix + 'for-healthcare/medical-transcription-platforms/index.htm');
g_navNode_3_50=g_navNode_3.addNode('ncom_cloudmobile_solution','Mobile \x26 Cloud Solutions ',ssUrlPrefix + 'for-healthcare/cloud-mobile-solutions/index.htm');
g_navNode_3_51=g_navNode_3.addNode('ncom_health_ehr_partnership','EHR Partnerships',ssUrlPrefix + 'for-healthcare/ehr-partnerships/index.htm');
g_navNode_3_53=g_navNode_3.addNode('ncom_heal_idn_solution','Health System IDN Solutions',ssUrlPrefix + 'for-healthcare/health-system-idn-solutions/index.htm');
g_navNode_3_54=g_navNode_3.addNode('ncom_hc_art_intlgnc','Artificial Intelligence',ssUrlPrefix + 'for-healthcare/artificial-intelligence/index.htm');
g_navNode_4=g_navNode_Root.addNode('ncom_forpartners','Our partners',ssUrlPrefix + 'for-partners/index.htm');
g_navNode_4_0=g_navNode_4.addNode('ncom_prt_bysolution','By Solution',ssUrlPrefix + 'for-partners/by-solution/index.htm');
g_navNode_4_0_0=g_navNode_4_0.addNode('ncom_prt_sol_cccc','Contact Center Customer Care',ssUrlPrefix + 'for-partners/by-solution/contact-center-customer-care/index.htm');
g_navNode_4_0_1=g_navNode_4_0.addNode('ncom_prt_sol_crittstresultmgmt','Critical Test Result Management',ssUrlPrefix + 'for-partners/by-solution/critical-test-result-management/index.htm');
g_navNode_4_0_2=g_navNode_4_0.addNode('ncom_prt_sol_docscanconversion','Document Scanning and Conversion',ssUrlPrefix + 'for-partners/by-solution/document-scanning-conversion/index.htm');
g_navNode_4_0_3=g_navNode_4_0.addNode('ncom_prt_sol_dragonsolutions','Dragon Desktop Solutions',ssUrlPrefix + 'for-partners/by-solution/dragon-desktop-solutions/index.htm');
g_navNode_4_0_3_0=g_navNode_4_0_3.addNode('ncom_partner_sol_dra_desktop','Dragon Partner Program',ssUrlPrefix + 'for-partners/by-solution/dragon-desktop-solutions/dragon-partner-program/index.htm');
if (SSContributor)
{
g_navNode_4_0_4=g_navNode_4_0.addNode('ncom_prt_sol_dragmed','Dragon Medical',ssUrlPrefix + 'for-partners/by-solution/dragon-medical/index.htm','contributorOnly==TRUE');
}
g_navNode_4_0_5=g_navNode_4_0.addNode('ncom_bus_sol_eps','Employee Productivity Suite',ssUrlPrefix + 'for-partners/by-solution/employee-productivity-suite/index.htm');
g_navNode_4_0_6=g_navNode_4_0.addNode('ncom_prt_sol_healthcaresol','Healthcare Solutions Partners',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/index.htm');
g_navNode_4_0_6_0=g_navNode_4_0_6.addNode('ncom_part_sol_ehr_part','Dragon Medical EHR Partners',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/ehr-partners/index.htm');
g_navNode_4_0_6_1=g_navNode_4_0_6.addNode('ncom_partn_ctrm_partnersupport','Partner Support',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/partner-support/index.htm');
g_navNode_4_0_6_2=g_navNode_4_0_6.addNode('ncom_partn_ctrm_becomeapartner','Become a Nuance Healthcare Partner',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/become-nuance-partner/index.htm');
g_navNode_4_0_6_3=g_navNode_4_0_6.addNode('ncom_partn_ctrm_findapartner','Find A Nuance Healthcare Partner',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/find-nuance-partner/index.htm');
g_navNode_4_0_6_4=g_navNode_4_0_6.addNode('ncom_part_sol_hc_workswith','EHRs Dragon Works With',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/ehrs-dragon-works-with/index.htm');
g_navNode_4_0_6_5=g_navNode_4_0_6.addNode('ncom_part_sol_hc_valadddistrib','Value-Added Distributors',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/value-added-distributors/index.htm');
g_navNode_4_0_6_6=g_navNode_4_0_6.addNode('ncom_part_sol_hc_channelpart','Channel Partners',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/channel-partners/index.htm');
g_navNode_4_0_6_7=g_navNode_4_0_6.addNode('ncom_part_sol_hc_indepswvends','For Independent Software Vendors',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/for-independent-software-vendors/index.htm');
g_navNode_4_0_6_8=g_navNode_4_0_6.addNode('ncom_part_sol_hc_directpartner','Direct Partners',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/direct-partners/index.htm');
g_navNode_4_0_6_9=g_navNode_4_0_6.addNode('ncom_part_sol_hc_dragcertehrs','Dragon Medical Certified EHRs',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/dragon-medical-certified-ehrs/index.htm');
g_navNode_4_0_6_10=g_navNode_4_0_6.addNode('ncom_part_sol_hc_ehrcertprog','Dragon Medical EHR Certification Program',ssUrlPrefix + 'for-partners/by-solution/healthcare-solutions/dragon-medical-ehr-certification-program/index.htm');
g_navNode_4_0_7=g_navNode_4_0.addNode('ncom_prt_sol_medtranshim','Medical Transcription and HIM Solutions',ssUrlPrefix + 'for-partners/by-solution/medical-transcription-him/index.htm');
g_navNode_4_0_8=g_navNode_4_0.addNode('ncom_part_sol_mobiledevprogram','Mobile Developer Program',ssUrlPrefix + 'for-partners/by-solution/mobile-developer-program/index.htm');
g_navNode_4_1=g_navNode_4.addNode('ncom_prt_byproduct','By Product',ssUrlPrefix + 'for-partners/by-product/index.htm','mainNavSeparatorClass==site-map-separator');
g_navNode_4_1_0=g_navNode_4_1.addNode('part_prod_dragon_medical','Physician Speech Recognition Solutions',ssUrlPrefix + 'for-partners/by-product/physician-speech-recognition-solutions/index.htm');
g_navNode_4_1_1=g_navNode_4_1.addNode('part_prod_dragon_medical_moble','Dragon Medical Mobile',ssUrlPrefix + 'for-partners/by-product/dragon-medical-mobile/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_4_1_2=g_navNode_4_1.addNode('part_prod_dragon_ns_legal','Dragon NaturallySpeaking Legal',ssUrlPrefix + 'for-partners/by-product/dragon-ns-legal/index.htm');
g_navNode_4_1_3=g_navNode_4_1.addNode('part_prod_dragon_ns_prof','Dragon NaturallySpeaking Professional',ssUrlPrefix + 'for-partners/by-product/dragon-ns-professional/index.htm');
g_navNode_4_1_4=g_navNode_4_1.addNode('part_prod_ecopy','eCopy',ssUrlPrefix + 'for-partners/by-product/ecopy/index.htm');
g_navNode_4_1_4_0=g_navNode_4_1_4.addNode('ncom_supp_ecopy_sw_alliance','Software Alliance Programs',ssUrlPrefix + 'for-partners/by-product/ecopy/software-alliance-programs/index.htm');
g_navNode_4_1_4_1=g_navNode_4_1_4.addNode('ncom_part_prod_partners_over','Partners Overview',ssUrlPrefix + 'for-partners/by-product/ecopy/partners-overview/index.htm');
g_navNode_4_1_4_2=g_navNode_4_1_4.addNode('ncom_supp_ecopy_sw_partners','Software Alliance Partners',ssUrlPrefix + 'for-partners/by-product/ecopy/software-alliance-partners/index.htm');
g_navNode_4_1_4_3=g_navNode_4_1_4.addNode('ncom_part_prod_ecopy_manufact','Office Equipment Manufacturers',ssUrlPrefix + 'for-partners/by-product/ecopy/office-equipment-manufacturers/index.htm');
g_navNode_4_1_4_4=g_navNode_4_1_4.addNode('ncom_part_prod_ecopy_emcsols','EMC Partner Solutions',ssUrlPrefix + 'for-partners/by-product/ecopy/emc-partner-solutions/index.htm');
g_navNode_4_1_4_5=g_navNode_4_1_4.addNode('ncom_part_prod_ecopy_mssols','Microsoft Partner Solutions',ssUrlPrefix + 'for-partners/by-product/ecopy/microsoft-partner-solutions/index.htm');
g_navNode_4_1_5=g_navNode_4_1.addNode('part_prod_employee_prod_suite','Employee Productivity Suite',ssUrlPrefix + 'for-partners/by-product/employee-productivity-suite/index.htm');
g_navNode_4_1_6=g_navNode_4_1.addNode('part_prod_escription','eScription',ssUrlPrefix + 'for-partners/by-product/escription/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_4_1_7=g_navNode_4_1.addNode('part_prod_macspeech_dictation','MacSpeech Dictate',ssUrlPrefix + 'for-partners/by-product/macspeech-dictate/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_4_1_8=g_navNode_4_1.addNode('part_prod_nuance_recognizer','Nuance Recognizer',ssUrlPrefix + 'for-partners/by-product/nuance-recognizer/index.htm');
if (SSContributor)
{
g_navNode_4_1_9=g_navNode_4_1.addNode('part_prod_nuance_verifier','Nuance Verifier',ssUrlPrefix + 'for-partners/by-product/nuance-verifier/index.htm','contributorOnly==TRUE');
}
g_navNode_4_1_10=g_navNode_4_1.addNode('part_prod_nuance_vocalizer','Nuance Vocalizer',ssUrlPrefix + 'for-partners/by-product/nuance-vocalizer/index.htm');
g_navNode_4_1_11=g_navNode_4_1.addNode('part_prod_omnipage','OmniPage',ssUrlPrefix + 'for-partners/by-product/omnipage/index.htm');
g_navNode_4_1_12=g_navNode_4_1.addNode('part_prod_openspeech_attendant','OpenSpeech Attendant',ssUrlPrefix + 'for-partners/by-product/openspeech-attendant/index.htm');
g_navNode_4_1_13=g_navNode_4_1.addNode('part_prod_paperport','PaperPort',ssUrlPrefix + 'for-partners/by-product/paperport/index.htm');
g_navNode_4_1_14=g_navNode_4_1.addNode('part_prod_pdf_converter','PDF Converter',ssUrlPrefix + 'for-partners/by-product/pdf-converter/index.htm');
g_navNode_4_1_15=g_navNode_4_1.addNode('part_prod_powerscribe','PowerScribe',ssUrlPrefix + 'for-partners/by-product/powerscribe/index.htm');
if (SSContributor)
{
g_navNode_4_1_16=g_navNode_4_1.addNode('part_prod_radcube','RadCube',ssUrlPrefix + 'for-partners/by-product/radcube/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
if (SSContributor)
{
g_navNode_4_1_18=g_navNode_4_1.addNode('part_prod_radwhere','RadWhere',ssUrlPrefix + 'for-partners/by-product/radwhere/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
g_navNode_4_1_19=g_navNode_4_1.addNode('part_prod_speech_attendant','SpeechAttendant',ssUrlPrefix + 'for-partners/by-product/speech-attendant/index.htm');
g_navNode_4_1_20=g_navNode_4_1.addNode('part_prod_speech_magic','SpeechMagic',ssUrlPrefix + 'for-partners/by-product/speech-magic/index.htm');
if (SSContributor)
{
g_navNode_4_1_21=g_navNode_4_1.addNode('part_prod_veriphy','Veriphy',ssUrlPrefix + 'for-partners/by-product/veriphy/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
g_navNode_4_1_22=g_navNode_4_1.addNode('ncom_part_prod_dns','Dragon NaturallySpeaking',ssUrlPrefix + 'for-partners/by-product/dragon-naturallyspeaking/index.htm');
g_navNode_4_1_24=g_navNode_4_1.addNode('part_prod_360solutionbuilder','360 \x7c SolutionBuilder',ssUrlPrefix + 'for-partners/by-product/solution-builder/index.htm');
g_navNode_5=g_navNode_Root.addNode('ncom_products','Products',ssUrlPrefix + 'products/index.htm');
if (SSContributor)
{
g_navNode_5_0=g_navNode_5.addNode('ncom_hea_sol_sp_en_ehr_d_me_mo','Dragon Medical Mobile',ssUrlPrefix + 'products/dragon-medical-mobile/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_0_0=g_navNode_5_0.addNode('ncom_hea_goal_moaccs_contactus','Contact Us',ssUrlPrefix + 'products/dragon-medical-mobile/contact-us/index.htm','nonViewableCountries==ENUK,DE,FR');
}
g_navNode_5_1=g_navNode_5.addNode('ncom_products_pdfconvmac','PDF Converter for Mac',ssUrlPrefix + 'products/pdf-converter-for-mac/index.htm','searchDispDesc==Nuance Power PDF software is the next generation PDF solution that enables businesses to collaborate faster, easier, and more affordably. See how.');
g_navNode_5_4=g_navNode_5.addNode('ncom_bus_prod_pdf_pdfreader','PDF Reader',ssUrlPrefix + 'products/pdf-reader/index.htm');
g_navNode_5_7=g_navNode_5.addNode('ncom_hea_goal_mo_dra_me_mo_rec','Dragon Medical 360 Mobile Recorder',ssUrlPrefix + 'products/dragon-medical-360-mobile-recorder/index.htm','nonViewableCountries==ENUK,DE,FR');
if (SSContributor)
{
g_navNode_5_8=g_navNode_5.addNode('ncom_hea_goal_mo_dra_me_mo_sdk','Dragon Medical Mobile SDK',ssUrlPrefix + 'products/dragon-medical-mobile-sdk/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
g_navNode_5_9=g_navNode_5.addNode('ncom_hea_goal_mo_dra_me_mo_sea','Dragon Medical 360 Mobile Search',ssUrlPrefix + 'products/dragon-medical-360-mobile-search/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_10=g_navNode_5.addNode('ncom_hea_sol_ctrm_powerscribe','PowerScribe 360',ssUrlPrefix + 'products/powerscribe360/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_11=g_navNode_5.addNode('ncom_hea_sol_sp_rec_speechmagi','SpeechMagic',ssUrlPrefix + 'products/speechmagic/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_13=g_navNode_5.addNode('ncom_hea_sol_rad_analy_radcube','RadCube',ssUrlPrefix + 'products/powerscribe-360-analytics/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_14=g_navNode_5.addNode('ncom_hea_sol_dia_rep_man_sp_so','Transcription Services',ssUrlPrefix + 'products/medical-transcription-services/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_14_0=g_navNode_5_14.addNode('ncom_prod_trnsol_flexovvew','Flexible Solutions Overview',ssUrlPrefix + 'products/medical-transcription-services/flexible-solutions-overview/index.htm');
g_navNode_5_15=g_navNode_5.addNode('ncom_hea_sol_ctrm_veriphy','Veriphy',ssUrlPrefix + 'products/powerscribe-360-critical-results/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_16=g_navNode_5.addNode('ncom_hea_sol_clin_doc_dict_ent','Dictaphone Enterprise Speech',ssUrlPrefix + 'products/dictaphone-enterprise-speech/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_16_0=g_navNode_5_16.addNode('ncom_prod_dipho_dradere','Dragon Medical 360 Desktop Recorder',ssUrlPrefix + 'products/dictaphone-enterprise-speech/dragon-medical-360-desktop-recorder/index.htm');
g_navNode_5_18=g_navNode_5.addNode('ncom_hea_sol_clin_doc_radwhere','RadWhere',ssUrlPrefix + 'products/radwhere/index.htm','nonViewableCountries==ENUS');
g_navNode_5_19=g_navNode_5.addNode('ncom_hea_sol_clin_doc_dra_medi','Physician Speech Recognition Solutions',ssUrlPrefix + 'products/physician-speech-recognition/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_19_0=g_navNode_5_19.addNode('ncom_hea_dra_med_vendor_result','Dragon Medical Vendor Self Evaluation',ssUrlPrefix + 'products/physician-speech-recognition/dragon-medical-vendor-self-evaluation/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_19_1=g_navNode_5_19.addNode('ncom_hea_dra_med_cert_results','Dragon Medical Certified Results',ssUrlPrefix + 'products/physician-speech-recognition/dragon-medical-certified-results/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_19_3=g_navNode_5_19.addNode('ncom_pro_psrs_cerehr','Certified EHR',ssUrlPrefix + 'products/physician-speech-recognition/certified-ehrs/index.htm');
if (SSContributor)
{
g_navNode_5_20=g_navNode_5.addNode('ncom_hea_sol_clin_doc_powerscr','PowerScribe 360 Reporting',ssUrlPrefix + 'products/powerscribe-360-reporting/index.htm','contributorOnly==TRUE','nonViewableCountries==ENUK,DE,FR');
}
g_navNode_5_23=g_navNode_5.addNode('ncom_prod_dragmedsmallpractice','Dragon Medical Practice Edition',ssUrlPrefix + 'products/dragon-medical-practice-edition/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_5_24=g_navNode_5.addNode('ncom_products_pdfcontmac','PDF Converter for Mac',ssUrlPrefix + 'products/pdf-converter-mac/index.htm');
g_navNode_5_25=g_navNode_5.addNode('ncom_prod_imagine_announ','Imaging Announcement',ssUrlPrefix + 'products/imaging-announcement/index.htm');
g_navNode_5_25_0=g_navNode_5_25.addNode('ncom_prod_imgann_equitra','support FAQ',ssUrlPrefix + 'products/imaging-announcement/equitrac-faq/index.htm');
g_navNode_5_26=g_navNode_5.addNode('ncom_products_svox','SVOX',ssUrlPrefix + 'products/SVOX/index.htm');
g_navNode_5_27=g_navNode_5.addNode('ncom_prod_speechmagic_solb','SpeechMagic Solution Builder',ssUrlPrefix + 'products/speechmagic-solution-builder/index.htm');
g_navNode_5_30=g_navNode_5.addNode('ncom_produc_maintenancer','Maintenance Renewal',ssUrlPrefix + 'products/maintenance-renewal/index.htm');
g_navNode_5_31=g_navNode_5.addNode('ncom_prod_qualityanalytics','qualityanalytics',ssUrlPrefix + 'products/qualityanalytics/index.htm');
g_navNode_5_36=g_navNode_5.addNode('ncom_pro_powerscribe360mr','PowerScribe 360 Mobile Radiologist',ssUrlPrefix + 'products/powerScribe-360-mobile-radiologist/index.htm');
g_navNode_5_39=g_navNode_5.addNode('ncom_prod_360_speech_anyw_serv','360 \x7c SpeechAnywhere Services',ssUrlPrefix + 'products/360-speechanywhere-services/index.htm','RedirectTo==https\x3a//www.nuancehealthcaredeveloper.com/public/index.php?page\x3dhome ');
g_navNode_5_41=g_navNode_5.addNode('ncom_prod_dragid','Dragon ID',ssUrlPrefix + 'products/dragon-id/index.htm');
g_navNode_5_60=g_navNode_5.addNode('ncom_prod_powershare_imgsharin','Powershare Image Sharing',ssUrlPrefix + 'products/powershare-medical-image-sharing/index.htm');
g_navNode_5_61=g_navNode_5.addNode('ncom_prod_powershare_imgexchan','Powershare Image Exchange',ssUrlPrefix + 'products/powershare-medical-image-exchange/index.htm');
g_navNode_5_63=g_navNode_5.addNode('ncom_prod_powerscribe_platform','PowerScribe 360 Platform',ssUrlPrefix + 'products/powerscribe360platform/index.htm');
g_navNode_5_65=g_navNode_5.addNode('ncom_products_dma','Dragon Medical Advisor',ssUrlPrefix + 'products/dragon-medical-advisor/index.htm','contributorOnly==FALSE');
g_navNode_5_66=g_navNode_5.addNode('ncom_prod_powershare_partners','PowerShare Network Partners',ssUrlPrefix + 'products/powershare-network-partners/index.htm');
g_navNode_5_69=g_navNode_5.addNode('ncom_dragonmedical_network','Dragon Medical Network Edition',ssUrlPrefix + 'products/dragon-medical-network-edition/index.htm');
g_navNode_5_70=g_navNode_5.addNode('ncom_dragonmedical_powerpack','Dragon Medical Powerpack',ssUrlPrefix + 'products/dragon-medical-powerpack/index.htm');
g_navNode_5_71=g_navNode_5.addNode('ncom_prod_dragon_medical_one','Dragon Medical One',ssUrlPrefix + 'products/dragon-medical-one/index.htm');
g_navNode_6=g_navNode_Root.addNode('ncom_company','Company',ssUrlPrefix + 'company/index.htm');
g_navNode_6_0=g_navNode_6.addNode('ncom_com_overview','Company Overview',ssUrlPrefix + 'company/company-overview/index.htm','RedirectTo==http\x3a//www.nuance.com/company/index.htm');
g_navNode_6_0_0=g_navNode_6_0.addNode('ncom_com_affiliates','Affiliates',ssUrlPrefix + 'company/company-overview/affiliates/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_6_0_1=g_navNode_6_0.addNode('ncom_comp_compover_policies','Company Policies',ssUrlPrefix + 'company/company-overview/company-policies/index.htm');
g_navNode_6_0_1_0=g_navNode_6_0_1.addNode('ncom_company_policies_privacy','Privacy Policies',ssUrlPrefix + 'company/company-overview/company-policies/privacy-policies/index.htm');
g_navNode_6_0_1_1=g_navNode_6_0_1.addNode('ncom_company_policies_legal','Legal Notices',ssUrlPrefix + 'company/company-overview/company-policies/legal-notices/index.htm');
g_navNode_6_0_1_2=g_navNode_6_0_1.addNode('ncom_company_policies_accessib','Accessibility',ssUrlPrefix + 'company/company-overview/company-policies/accessibility/index.htm');
g_navNode_6_0_1_3=g_navNode_6_0_1.addNode('ncom_company_policies_safe_har','Safe Harbor',ssUrlPrefix + 'company/company-overview/company-policies/safe-harbor/index.htm');
g_navNode_6_0_1_4=g_navNode_6_0_1.addNode('ncom_company_policies_corp_gov','Corporate Governance',ssUrlPrefix + 'company/company-overview/company-policies/corporate-governance/index.htm');
g_navNode_6_0_1_4_0=g_navNode_6_0_1_4.addNode('ncom_company_policies_cg_govco','Governance Committee',ssUrlPrefix + 'company/company-overview/company-policies/corporate-governance/governance-committee/index.htm');
g_navNode_6_0_1_4_1=g_navNode_6_0_1_4.addNode('ncom_company_policies_cg_compe','Compensation Committee',ssUrlPrefix + 'company/company-overview/company-policies/corporate-governance/compensation-committee/index.htm');
g_navNode_6_0_1_4_2=g_navNode_6_0_1_4.addNode('ncom_company_policies_cg_ethic','Code of Ethics',ssUrlPrefix + 'company/company-overview/company-policies/corporate-governance/code-of-ethics/index.htm');
g_navNode_6_0_1_4_3=g_navNode_6_0_1_4.addNode('ncom_company_policies_cg_audit','Audit Committee',ssUrlPrefix + 'company/company-overview/company-policies/corporate-governance/audit-committee/index.htm');
g_navNode_6_0_1_4_4=g_navNode_6_0_1_4.addNode('ncom_company_policies_cg_nomin','Nominating Committee',ssUrlPrefix + 'company/company-overview/company-policies/corporate-governance/nominating-committee/index.htm');
g_navNode_6_0_1_4_5=g_navNode_6_0_1_4.addNode('ncom_company_policies_cg_cmr','Conflict Minerals Report',ssUrlPrefix + 'company/company-overview/company-policies/corporate-governance/conflict-minerals-report/index.htm');
g_navNode_6_0_1_5=g_navNode_6_0_1.addNode('ncom_company_legal_marks','Legal Marks',ssUrlPrefix + 'company/company-overview/company-policies/LegalMarks/index.htm');
g_navNode_6_0_2=g_navNode_6_0.addNode('ncom_comp_compover_contactus','Contact Us',ssUrlPrefix + 'company/company-overview/contact-us/index.htm');
g_navNode_6_0_2_0=g_navNode_6_0_2.addNode('ncom_company_contactsales','Contact Sales',ssUrlPrefix + 'company/company-overview/contact-us/contactsales/index.htm');
g_navNode_6_0_3=g_navNode_6_0.addNode('ncom_com_compovr_corpcitzn','Corporate Citizenship',ssUrlPrefix + 'company/company-overview/corporate-citizenship/index.htm');
g_navNode_6_0_3_0=g_navNode_6_0_3.addNode('ncom_comp_compover_givingback','Giving Back',ssUrlPrefix + 'company/company-overview/corporate-citizenship/giving-back/index.htm');
g_navNode_6_0_4=g_navNode_6_0.addNode('ncom_comp_compover_fastfacts','Fast Facts',ssUrlPrefix + 'company/company-overview/fast-facts/index.htm');
g_navNode_6_0_5=g_navNode_6_0.addNode('ncom_comp_compover_leadership','Leadership Team',ssUrlPrefix + 'company/company-overview/leadership-team/index.htm');
g_navNode_6_0_6=g_navNode_6_0.addNode('ncom_comp_compover_offlocation','Office Locations',ssUrlPrefix + 'company/company-overview/office-locations/index.htm');
g_navNode_6_0_6_0=g_navNode_6_0_6.addNode('ncom_comove_offlocationsna','Office Locations America',ssUrlPrefix + 'company/company-overview/office-locations/office-locations-america/index.htm');
g_navNode_6_0_6_1=g_navNode_6_0_6.addNode('ncom_com_comove_offloceurope','Office Locations Europe',ssUrlPrefix + 'company/company-overview/office-locations/office-locations-europe/index.htm');
g_navNode_6_0_6_2=g_navNode_6_0_6.addNode('ncom_comp_comove_complocapac','Office Locations APAC',ssUrlPrefix + 'company/company-overview/office-locations/office-locations-apac/index.htm');
g_navNode_6_1=g_navNode_6.addNode('ncom_com_careers','Careers',ssUrlPrefix + 'company/careers/index.htm','RedirectTo==http\x3a//jobs.nuance.com/');
g_navNode_6_1_4=g_navNode_6_1.addNode('ncom_com_car_contacthr','Contact HR',ssUrlPrefix + 'company/careers/contact-hr/index.htm');
g_navNode_6_1_5=g_navNode_6_1.addNode('ncom_company_careers_nuniv','Nuance University ',ssUrlPrefix + 'company/careers/nuance_university/index.htm');
g_navNode_6_2=g_navNode_6.addNode('ncom_com_investrelations','Investor Relations',ssUrlPrefix + 'company/investor-relations/index.htm');
g_navNode_6_2_0=g_navNode_6_2.addNode('ncom_com_inv_earnings','Earnings Releases',ssUrlPrefix + 'company/investor-relations/earnings-releases/index.htm');
g_navNode_6_2_1=g_navNode_6_2.addNode('ncom_com_inv_faqs','FAQs',ssUrlPrefix + 'company/investor-relations/faqs/index.htm');
g_navNode_6_3=g_navNode_6.addNode('ncom_com_newsroom','Newsroom',ssUrlPrefix + 'company/news-room/index.htm');
g_navNode_6_3_0=g_navNode_6_3.addNode('ncom_com_nws_prsrels','Press Releases',ssUrlPrefix + 'company/news-room/press-releases/index.htm','secondaryUrlVariableField==PRODUCT_CONTENT','xmlQueryText==xDocSubType \x3cMATCHES\x3e \x60Press Release\x60 \x3cand\x3e \x28dExtension \x3cMATCHES\x3e \x60doc\x60 \x3cor\x3e dExtension \x3cMATCHES\x3e \x60docx\x60\x29');
g_navNode_6_3_1=g_navNode_6_3.addNode('ncom_com_nws_nuancenews','Nuance in the News',ssUrlPrefix + 'company/news-room/nuance-in-the-news/index.htm','xmlQueryText==xDocSubType \x3cMATCHES\x3e \x60Media Coverage\x60');
g_navNode_6_3_2=g_navNode_6_3.addNode('ncom_com_nws_events','Events',ssUrlPrefix + 'company/news-room/events/index.htm','xmlQueryText==dDocType \x3cmatches\x3e \x60Event\x60 \x3cAND\x3e \x3cNOT\x3e \x28xDocSubType \x3cmatches\x3e \x60\"Webinar Replay\"\x60\x29');
g_navNode_6_3_2_1=g_navNode_6_3_2.addNode('ncom_com_news_events_webin','Webinars',ssUrlPrefix + 'company/news-room/events/webinars/index.htm');
g_navNode_6_3_2_1_0=g_navNode_6_3_2_1.addNode('ncom_com_new_ev_web_speechatte','Nuance SpeechAttendant Webcast ',ssUrlPrefix + 'company/news-room/events/webinars/nuance-speech-attendant-webcast/index.htm');
g_navNode_6_3_2_1_1=g_navNode_6_3_2_1.addNode('ncom_hea_webinars_bus_intellig','Business Intelligence',ssUrlPrefix + 'company/news-room/events/webinars/business-intelligence/index.htm');
g_navNode_6_3_2_1_2=g_navNode_6_3_2_1.addNode('ncom_hea_webinars_closelooprad','Closed Loop Radiology',ssUrlPrefix + 'company/news-room/events/webinars/closed-loop-radiology/index.htm');
g_navNode_6_3_2_1_3=g_navNode_6_3_2_1.addNode('ncom_hea_webinars_dec_support','Decision Support',ssUrlPrefix + 'company/news-room/events/webinars/decision-support/index.htm');
g_navNode_6_3_2_1_4=g_navNode_6_3_2_1.addNode('TESTFORM','TESTFORM',ssUrlPrefix + 'company/news-room/events/webinars/TESTFORM/index.htm');
g_navNode_6_3_2_1_5=g_navNode_6_3_2_1.addNode('ncom_com_new_eve_web_parupdweb','Nuance Partner Update Webcast',ssUrlPrefix + 'company/news-room/events/webinars/nuance-partner-update-webcast/index.htm');
g_navNode_6_3_2_1_6=g_navNode_6_3_2_1.addNode('ncom_co_nr_ev_we_pdflega','PDF Legal for Professionals',ssUrlPrefix + 'company/news-room/events/webinars/pdf-legal-for-professionals/index.htm');
g_navNode_6_3_2_1_7=g_navNode_6_3_2_1.addNode('ncom_co_ne_ev_we_dledisc','Download The eDiscovery',ssUrlPrefix + 'company/news-room/events/webinars/download-the-ediscovery/index.htm');
g_navNode_6_3_2_2=g_navNode_6_3_2.addNode('ncom_com_news_events_webreplay','Webinar Replays',ssUrlPrefix + 'company/news-room/events/webinar-replays/index.htm');
g_navNode_6_3_2_2_0=g_navNode_6_3_2_2.addNode('43','Healthcare',ssUrlPrefix + 'company/news-room/events/webinar-replays/healthcare/index.htm');
g_navNode_6_3_2_2_0_0=g_navNode_6_3_2_2_0.addNode('ncom_replay_dragon','Dragon Replay',ssUrlPrefix + 'company/news-room/events/webinar-replays/healthcare/dragon-replay/index.htm');
g_navNode_6_3_3=g_navNode_6_3.addNode('ncom_com_nws_brandcntr','Brand Center',ssUrlPrefix + 'company/news-room/brand-center/index.htm');
g_navNode_6_3_4=g_navNode_6_3.addNode('ncom_com_nws_presskt','Press Kits',ssUrlPrefix + 'company/news-room/press-kits/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_6_3_4_0=g_navNode_6_3_4.addNode('ncom_co_ne_pk_ecop_prskt','eCopy ShareScan v5 Press Kit',ssUrlPrefix + 'company/news-room/press-kits/ecopy-share-scanv5presskit/index.htm');
g_navNode_6_3_4_1=g_navNode_6_3_4.addNode('ncom_co_ne_prkt_dragonpr','Dragon Press Kit',ssUrlPrefix + 'company/news-room/press-kits/dragon-press-kit/index.htm');
g_navNode_6_3_4_2=g_navNode_6_3_4.addNode('ncom_co_news_presskit_pa','PaperPort Press Kit',ssUrlPrefix + 'company/news-room/press-kits/paperport-press-kit/index.htm');
g_navNode_6_3_4_3=g_navNode_6_3_4.addNode('ncom_co_new_pk_swype','Swype Press Kits',ssUrlPrefix + 'company/news-room/press-kits/swype-press-kits/index.htm');
g_navNode_6_3_4_6=g_navNode_6_3_4.addNode('ncom_co_new_prki_ces','Consumer Electronics Show',ssUrlPrefix + 'company/news-room/press-kits/consumer-electronic-show/index.htm');
g_navNode_6_3_4_7=g_navNode_6_3_4.addNode('ncom_co_nr_pk_drgnotes','Dragon Notes',ssUrlPrefix + 'company/news-room/press-kits/dragon-notes/index.htm');
g_navNode_6_3_5=g_navNode_6_3.addNode('ncom_com_nws_presscontact','Press Contact',ssUrlPrefix + 'company/news-room/press-contact/index.htm');
g_navNode_6_4=g_navNode_6.addNode('ncom_company_legal','Legal',ssUrlPrefix + 'company/legal/index.htm','mainNavSeparatorClass==site-map-separator');
g_navNode_6_5=g_navNode_6.addNode('ncom_com_nuanunivtrainin','Nuance University Training',ssUrlPrefix + 'company/nuance-university-training/index.htm');
g_navNode_6_6=g_navNode_6.addNode('ncom_com_purc','purchasing',ssUrlPrefix + 'company/purchasing/index.htm');
g_navNode_6_6_0=g_navNode_6_6.addNode('terms','Terms',ssUrlPrefix + 'company/purchasing/terms/index.htm');
g_navNode_6_6_1=g_navNode_6_6.addNode('ncom_co_purc_txexem','Tax Exemption',ssUrlPrefix + 'company/purchasing/tax-exemption/index.htm');
g_navNode_6_6_2=g_navNode_6_6.addNode('ncom_co_purch_vendadform','Vendor Add Form',ssUrlPrefix + 'company/purchasing/vendor-add-form/index.htm');
g_navNode_8=g_navNode_Root.addNode('ncom_countries','Countries',ssUrlPrefix + 'countries/index.htm');
g_navNode_10=g_navNode_Root.addNode('ncom_fordevelopers','For Developers',ssUrlPrefix + 'for-developers/index.htm');
g_navNode_10_0=g_navNode_10.addNode('ncom_fordev_dragon','Dragon',ssUrlPrefix + 'for-developers/dragon/index.htm');
g_navNode_10_0_0=g_navNode_10_0.addNode('ncom_indiv_solu_drag_dev_audio','Audio Mining',ssUrlPrefix + 'for-developers/dragon/audio-mining/index.htm');
g_navNode_10_0_3=g_navNode_10_0.addNode('ncom_indivi_prod_drag_devopers','For Developers',ssUrlPrefix + 'for-developers/dragon/for-developers/index.htm');
g_navNode_11=g_navNode_Root.addNode('ncom_dragon','Dragon',ssUrlPrefix + 'dragon/index.htm');
g_navNode_11_0=g_navNode_11.addNode('ncom_drag_dns_webinars','Dragon NaturallySpeaking Webinars',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_0_0=g_navNode_11_0.addNode('ncom_drag_dnsweb_insuran','Webinar Insurance Recording Form',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/webinar-insurance-recording-form/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_0_1=g_navNode_11_0.addNode('ncom_drag_dnsweb_socialh','Webinar Social \x26 Health Services Recording',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/webinar-social-health-services-recording/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_0_2=g_navNode_11_0.addNode('ncom_drag_dnsweb_lawfirm','Webinar Law Firms Recording',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/webinar-law-firms-recording/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_0_3=g_navNode_11_0.addNode('ncom_drag_dnsweb_financ','Webinar Financial Advisor Recording',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/webinar-financial-advisor-recording/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_0_4=g_navNode_11_0.addNode('ncom_dragwe_dnsweb_law','Webinar Law Enforcement Recording',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/webinar-law-enforcement-recording/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_0_5=g_navNode_11_0.addNode('ncom_drag_dnswe_sdkrecor','Webinar SDK Recording',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/webinar-sdk-recording/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_0_6=g_navNode_11_0.addNode('ncom_dragon_webinar_educ','Webinar Education Recording',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/WebinarEducationRecording/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_0_7=g_navNode_11_0.addNode('ncom_drag_web_improvpro','Webinar Improve Productivity \x26 Reduce Injury',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/webinar-improve-productivity-reduce-injury/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_0_8=g_navNode_11_0.addNode('ncom_drag_web_improv_pro','Webinar Improve Productivity and Reduce Injury',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/dragon-webinar-improve-productivity-reduce-injury/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_0_9=g_navNode_11_0.addNode('ncom_drag_web_fedgovernm','Dragon NaturallySpeaking Federal Goverment Webinar Recording',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/dragon-naturallyspeaking-federal-goverment-webinar-recording/index.htm');
g_navNode_11_0_10=g_navNode_11_0.addNode('ncom_drag_web_smb','Webinar SMB Recording',ssUrlPrefix + 'dragon/dragon-naturallyspeaking-webinars/webinar-smb-recording/index.htm');
g_navNode_11_1=g_navNode_11.addNode('ncom_drag_whatsnewupgrade','What\'s New Upgrade',ssUrlPrefix + 'dragon/whats-new-upgrade/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_4=g_navNode_11.addNode('ncom_drag_contactsdksales','Contact SDK Sales',ssUrlPrefix + 'dragon/contact-sdk-sales/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_5=g_navNode_11.addNode('ncom_drag_featurerequest','Feature Request',ssUrlPrefix + 'dragon/feature-request/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_6=g_navNode_11.addNode('ncom_drag_purchase','Purchase',ssUrlPrefix + 'dragon/purchase/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_10=g_navNode_11.addNode('ncom_dragon_dragoncommun','Dragon Community',ssUrlPrefix + 'dragon/dragon-community/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_12=g_navNode_11.addNode('ncom_drag_customerrefere','Customer References',ssUrlPrefix + 'dragon/customer-references/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_12_0=g_navNode_11_12.addNode('ncom_drag_cusref_custtes','Customer Testimonial Videos',ssUrlPrefix + 'dragon/customer-references/customer-testimonial-videos/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_12_1=g_navNode_11_12.addNode('ncom_drag_cusref_cuscase','Customer Case Studies',ssUrlPrefix + 'dragon/customer-references/customer-case-studies/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_12_2=g_navNode_11_12.addNode('ncom_drag_cusref_custquo','Customer Quotes',ssUrlPrefix + 'dragon/customer-references/customer-quotes/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_14=g_navNode_11.addNode('ncom_drag_dragonnewsroom','Dragon Newsroom',ssUrlPrefix + 'dragon/dragon-newsroom/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_15=g_navNode_11.addNode('ncom_dragon_remotemicrop','Remote Microphone',ssUrlPrefix + 'dragon/remote-microphone/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_16=g_navNode_11.addNode('ncom_dragon_recorderapp','Recorder App',ssUrlPrefix + 'dragon/recorder-app/index.htm','nonViewableCountries==ENUK,DE,FR');
g_navNode_11_17=g_navNode_11.addNode('ncom_dragon_dragondeals','Dragon Deals',ssUrlPrefix + 'dragon/dragon-deals/index.htm');
g_navNode_11_18=g_navNode_11.addNode('ncom_dragon_emailoptin','Email Opt In',ssUrlPrefix + 'dragon/email-opt-in/index.htm');
g_navNode_11_19=g_navNode_11.addNode('ncom_drag_askthedictator','Ask the Dictator',ssUrlPrefix + 'dragon/ask-the-dictator/index.htm');
g_navNode_11_22=g_navNode_11.addNode('ncom_dragon_transcrsolut','Transcription Solutions',ssUrlPrefix + 'dragon/transcription-solutions/index.htm');
g_navNode_11_24=g_navNode_11.addNode('ncom_drag_acces_solu_amz','Accessibility Solutions AMZ',ssUrlPrefix + 'dragon/Accessibility-Solutions-AMZ/index.htm');
g_navNode_11_25=g_navNode_11.addNode('ncom_dragon_nanowrimo','Nanowrimo',ssUrlPrefix + 'dragon/nanowrimo/index.htm');
g_navNode_11_31=g_navNode_11.addNode('ncom_drag_dragassist','Dragon Assist',ssUrlPrefix + 'dragon/dragon-assist/index.htm');
g_navNode_11_33=g_navNode_11.addNode('ncom_drag_dragassistant','Dragon Assistant',ssUrlPrefix + 'dragon/dragonassistant/index.htm','RedirectTo==http\x3a//www.getdragon.com');
g_navNode_11_37=g_navNode_11.addNode('ncom_drag_dragnotes','Dragon Notes',ssUrlPrefix + 'dragon/dragon-notes/index.htm');
g_navNode_11_38=g_navNode_11.addNode('ncom_dra_dragassistant','Dragon Assistant',ssUrlPrefix + 'dragon/dragon-assistant/index.htm');
g_navNode_11_39=g_navNode_11.addNode('ncom_dra_dranotcloud','Dragon Notes Cloud',ssUrlPrefix + 'dragon/dragon-notes-cloud/index.htm');
g_navNode_11_41=g_navNode_11.addNode('ncom_dragon_offers_aarp','Dragon Offers AARP',ssUrlPrefix + 'dragon/dragon-offers-aarp/index.htm');
g_navNode_11_42=g_navNode_11.addNode('ncom_dragon_giftcert','Dragon Gift Certificate',ssUrlPrefix + 'dragon/dragon-gift-certificate/index.htm');
g_navNode_11_43=g_navNode_11.addNode('ncom_dragon_dyslexiasolutions','Dyslexia Solutions',ssUrlPrefix + 'dragon/dyslexia-solutions/index.htm');
g_navNode_11_44=g_navNode_11.addNode('ncom_dragon_accessibilitysolut','Accessibility Solutions for physical challenges',ssUrlPrefix + 'dragon/accessibility-solutions/index.htm');
g_navNode_11_45=g_navNode_11.addNode('ncom_dragon_customeroffers','Dragon Customer Offers',ssUrlPrefix + 'dragon/dragon-customer-offers/index.htm');
g_navNode_11_46=g_navNode_11.addNode('ncom_dra_dadsandgrads','Dads and Grads',ssUrlPrefix + 'dragon/dads-and-grads/index.htm','searchDispDesc==Dragon is celebrating graduation and Father\x26rsquo\x3bs Day with a savings event of over \x2455 off our speech recognition software. ');
g_navNode_11_47=g_navNode_11.addNode('ncom_dra_backtoschool','Back to School Offerrs',ssUrlPrefix + 'dragon/back-to-school-offers/index.htm');
g_navNode_11_49=g_navNode_11.addNode('ncom_dragon_dragontrials','Dragon Trials',ssUrlPrefix + 'dragon/dragon-trials/index.htm');
g_navNode_11_50=g_navNode_11.addNode('ncom_dragon_dragonlive','Dragon Live',ssUrlPrefix + 'dragon/dragon-live/index.htm');
g_navNode_11_51=g_navNode_11.addNode('ncom_dragon_extension5b','Extension5',ssUrlPrefix + 'dragon/extensions5/index.htm');
g_navNode_11_52=g_navNode_11.addNode('ncom_dragon_voiceisready','Voice is ready',ssUrlPrefix + 'dragon/voice-is-ready/index.htm');
g_navNode_11_52_0=g_navNode_11_52.addNode('ncom_dragon_smallbusiness','Small business',ssUrlPrefix + 'dragon/voice-is-ready/small-business/index.htm');
g_navNode_11_52_1=g_navNode_11_52.addNode('ncom_dragon_legal','legal',ssUrlPrefix + 'dragon/voice-is-ready/legal/index.htm');
g_navNode_11_52_1_0=g_navNode_11_52_1.addNode('ncom_dragon_legal_brief','Legal Brief',ssUrlPrefix + 'dragon/voice-is-ready/legal/legal-brief/index.htm');
g_navNode_11_52_2=g_navNode_11_52.addNode('ncom_dragon_legalgroup','Legal Group',ssUrlPrefix + 'dragon/voice-is-ready/dragon-legal-group/index.htm');
g_navNode_11_52_3=g_navNode_11_52.addNode('ncom_dragon_voice_publicsafety','Public Safety',ssUrlPrefix + 'dragon/voice-is-ready/public-safety/index.htm');
g_navNode_11_52_3_0=g_navNode_11_52_3.addNode('ncom_dragon_voice_public_chief','Tell Your Chief',ssUrlPrefix + 'dragon/voice-is-ready/public-safety/tell-your-chief/index.htm');
g_navNode_11_52_4=g_navNode_11_52.addNode('ncom_dragon_anywheregrou','Dragon Anywhere Group',ssUrlPrefix + 'dragon/voice-is-ready/dragon-anywhere-group/index.htm');
g_navNode_12=g_navNode_Root.addNode('ncom_error','Error',ssUrlPrefix + 'Error/index.htm');
g_navNode_14=g_navNode_Root.addNode('ncom_earnings_results','Earnings Results',ssUrlPrefix + 'earnings-results/index.htm');
g_navNode_48=g_navNode_Root.addNode('ncom_ndi_partners','Imaging Partner Portal',ssUrlPrefix + 'ndi-partners/index.htm');
g_navNode_52=g_navNode_Root.addNode('ncom_extensions','Dragon Web Extension',ssUrlPrefix + 'extensions/index.htm');
